app = $.extend(true, app, {
    "Alarm_Reported.html":{
        Init: function (isFirst, Param) {
            // 基础信息
            var $alarmSite = $("#alarmSite");
            var $alarmHappenTime = $("#alarmHappenTime");
            var $reportedPeople = $("#reportedPeople");
            var $alarmReportedSite = $('#alarmReportedSite');

            // 操作信息
            var $alarmContent = $("#alarmContent");
            var $alarmPhotoList = $("#alarmPhotoList");

            // 按钮
            var $btnReported = $(".btn-save");
            var $ScrollInit = $("#ScrollInit");
            var $imgAdd = $("#imgAdd");

            var entry = request("entry");
            var inteFlag = true;
            var projectID = getAppStorage("PROJECT_ID");
            
            var ImgAdd = function (img){
                var $html;
                if(img){
                    var html = '';
                    html += '<li class="scene-img-box alarm-img">';
                    html += '<img src="'+img+'" alt="" class="alarm-item-img">';
                    html += '</li>';

                    $html = $(html);
                    $imgAdd.before($html);
                }

                if($(".alarm-item-img").length >= 3){
                    $imgAdd.addClass("ui-hide");
                }
        
                $html.tap(ToClick, function (){
                    if(img) {
                        ImgPreview(img,$(this),function(){
                            $imgAdd.removeClass("ui-hide");
                        })
                    }
                })
            };

            // 设置基本信息
            var setBaseInfo = function (){
                var gpsObj = nativeGpsInfo();
                $alarmSite.html(gpsObj.address);
                $alarmReportedSite.data("lon", gpsObj.lon);
                $alarmReportedSite.data("lat", gpsObj.lat);
                // $alarmHappenTime.html(TimeToStr(new Date(), "yyyy-MM-dd HH:mm"));
                // $reportedPeople.html(getAppStorage("UserName"));
            };
            // 上报警情
            var reportAlarm = function (AlarmAnnexList){
                var ReportContent = $alarmContent.val();
                var ReportPlaceName = $alarmSite.html();
                var ReportLongitude = $alarmReportedSite.data("lon");
                var ReportLatitude = $alarmReportedSite.data("lat");
                var AlarmAnnexList = AlarmAnnexList;

                inte.AlarmReport({
                    ReportContent: ReportContent,
                    ReportPlaceName: ReportPlaceName,
                    ReportLongitude: ReportLongitude,
                    ReportLatitude: ReportLatitude,
                    AlarmAnnexList: JSON.stringify(AlarmAnnexList),
                    ProjectID: projectID
                },function (JsonObj){
                    if(JsonObj.Code == 1){
                        Msg.OK.Show(JsonObj.Message, 2, function (){
                            if(entry == "home"){
                                backAppPage();
                            }else{
                                winBack();
                            }
                        })
                    }else{
                        Msg.Error.Show(JsonObj.Message,2,function(){
                            inteFlag = true;
                        });
                    }
                })
            };

            // 图片上传
            var ImgUpload = function (){
                var imgPathArray = [];
                $(".alarm-item-img").each(function (){
                    var path;
                    if(!$(this).attr("src") || $(this).attr("src") == "Img/ico_addPhoto@2x.png"){
                        path = ""
                    }else{
                        path = $(this).attr("src");
                    }
                    imgPathArray.push(path);
                });

                var imgPathString = JSON.stringify(imgPathArray);
                if(imgPathString == '[]'){
                    // Msg.Error.Show("请上传图片");
                    reportAlarm([]);
                    return;
                }else{
                    if(inteFlag){
                        inteFlag = false;
                        nativeFileUpload(imgPathString);
                        nativeFileUploadResultInstance.setFun(function (file){
                            if(file){
                                reportAlarm(file.FileList);
                            }else{
                                inteFlag = true;
                            }
                            
                        });
                    }
                }
            };

            var required = function(){
                if(!$alarmContent.val()){
                    Msg.Error.Show("请填写警情内容");
                    return false;
                }
                return true;
            };

            // 点击操作
            var initClick = function (){
                $("#btnBack").unbind();
                $("#btnBack").click(function (){
                    if(entry == "home"){
                        backAppPage();
                    }else{
                        winBack();
                    }
                });

                $imgAdd.off();
                $imgAdd.on("click", function (){
                    setTimeout(function() {
                        nativePhotoResultInstance.setFun(function (photo){
                            if(photo.path){
                                ImgAdd(photo.path);
                            }
                        });

                        nativeOpenPhotoDialog('');
                    }, 300);
                });

                $btnReported.off().tap(ToClick, function (){
                    if(required()){
                        ImgUpload();
                    }
                })

                $alarmReportedSite.unbind();
                $alarmReportedSite.tap(ToClick, function () {
                    nativeGpsResultInstance.setFun(function (native_gps){
                        $alarmSite.html(native_gps.address);
                        $alarmReportedSite.data("lon", native_gps.lon);
                        $alarmReportedSite.data("lat", native_gps.lat);
                    })
                    nativeOpenMapWithButton($alarmReportedSite.data("lon"), $alarmReportedSite.data("lat"), '警情地点');
                })
            };

            // 固定title
            var setScroll = function () {
                OverScroll($ScrollInit.get(0));
            };

            var buttonPosition = function(){
                var $item =  $('.content-duty-detail').last();
                var btnTop = $btnReported.offset().top;
                var btnOrginTop = $item.offset().top + $item.outerHeight();
                var margintop = btnTop - btnOrginTop;
                if(margintop < 15){
                    margintop = 15;
                }
                $btnReported.css({
                    'margin-top':margintop+'px',
                    'margin-bottom':'0.15rem',
                    'position':'static'
                })
            };

            if (isFirst) {
                setScroll();
                initClick();
                setBaseInfo();
                buttonPosition();
            }
        }
    }
})