app = $.extend(true, app, {

  'Clock.html': {

    Init: function (isFirst, Param) {
      var $clockTime = $(".clock-time");
      var $shiftBox = $("#shiftBox");
      var $clockCircle = $(".clock-circle");
      var $btnBack = $("#btnBack");
      var $shiftPop = $(".shift-pop");
      var $shiftPopShadow = $(".shift-pop-shadow");
      var $shiftPopItem = $(".shift-pop-item");
      var $shift = $(".shift");
      var $clockWifi = $('.clock-wifi');
      var $clockWifiName = $(".clock-wifi-name");
      var $clockRange = $(".clock-range");
      var $shiftPopBox = $(".shift-pop-box");
      var $btnClockWarn = $('#btnClockWarn');

      var dutyID = request('DutyID');
      var sentryID = request('SentryID');
      var attendanceDate = request('AttendanceDate');
      var effectiveDistance = request('EffectiveDistance');
      var gpsInfo;
      var wifiInfo;
      var AttendanceInfo;
      var distanceFlag;
      var startSignRecordID;
      var IBeaconInfo = {};
      var offSignRecordID;
      var CurrentTime;

      var initClick = function () {
        // 班次点选
        $shiftBox.tap(ToClick, function (e) {
          e.preventDefault();
          if (!$shiftPopBox.text().trim()) {
            Msg.Error.Show("暂无班次");
          } else {
            $shiftPop.fadeIn();
          }
        })

        $shiftPopShadow.tap(ToClick, function (e) {
          e.preventDefault();
          $shiftPop.fadeOut();
        })

        $btnBack.tap(ToClick, function () {
          backAppPage();
        })

        $btnClockWarn.off().tap(ToClick, function () {
          winOpen('Clock_Warn.html')
        })

        $clockCircle.off().tap(ToClick, function () {
          var data = $(this).data('SignMode');
          if (data == 'QR_CODE') {
            // 二维码打卡 调 原生二维码扫描
            clockConfirm(data, nativeQrCode);
            nativeQrCodeResultInstance.setFun(function (qrcode) {
              AttendanceSign({
                qrcode: qrcode
              });
            })
          } else if (data == 'PHOTO') {
            // 拍照打卡 调 原生拍照
            clockConfirm(data, nativeOpenClockCamera);
            nativeFileUploadResultInstance.setFun(function (file) {
              if (file && file.Code == 1 && file.FileList && file.FileList.length > 0) {
                AttendanceSign({
                  imgInfo: JSON.stringify(file.FileList)
                });
              } else {
                Msg.Error.Show('请重新上传图片')
              }
            })
          } else if (data == 'ORDINARY') {
            // 直接打卡 调 打卡接口
            clockConfirm(data, AttendanceSign);
          } else if (data == 'IBEACON') {
            if (!IBeaconInfo.iBeaconID) {
              Msg.Error.Show('后台未设置IBEACON');
              return;
            } else {
              clockConfirm(data, nativeIBeaconInfo, IBeaconInfo.iBeaconID);
              nativeFindIbeaconResultInstance.setFun(function (iBeacon) {
                if (iBeacon == "T") {
                  AttendanceSign({
                    IBeaconInfo: IBeaconInfo
                  });
                }
              })
            }
          }
        })
      }

      function AttendanceList() {
        inte.AttendanceList({
          BeginIndex: 0,
          DataCount: 20
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            var $list = $shiftPopBox;
            $list.empty();
            var html = "";

            for (var key in JsonObj.AttendanceList) {
              var row = JsonObj.AttendanceList[key];

              var chooseFlag = row.DutyID == dutyID && row.DutyDate == attendanceDate

              html = '';
              html += '<div class="shift-pop-item' + (chooseFlag ? ' item-choose' : '') + '" data-dutyid=' + row.DutyID + ' data-dutydate=' + row.DutyDate + ' data-sentryid=' + row.SentryID + ' data-dutytypename=' + row.DutyTypeName + '>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div class="shift-pop-sel"></div>'
              html += '    <div>' + row.DutyDate + '</div>'
              html += '    <div>(' + row.DutyTypeName + ')</div>'
              html += '  </div>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div></div>'
              html += '    <div>' + row.DutyName + '</div>'
              html += '    <div>' + row.DutyWorkTime + '</div>'
              html += '  </div>'
              html += '</div>'

              var $html = $(html);
              $html.tap(ToClick, function (e) {
                e.preventDefault();
                sentryID = $(this).data('sentryid')
                dutyID = $(this).data('dutyid')
                attendanceDate = $(this).data('dutydate')
                $shiftPopItem.removeClass('item-choose')
                $(this).addClass('item-choose')
                $shiftPop.fadeOut()
                AttendanceDetails(false, $(this).data("dutytypename"));
              })

              $list.append($html);
            }

            if (JsonObj.AttendanceList.length < 1) {
              // html = '';
              // html += '<div class="ui-text-center">暂无班次</div>';
              // $list.append($(html));
            }

            $shiftPopItem = $(".shift-pop-item");

            // if ($shift.text() == '暂无班次' || !$shift.text().trim() && JsonObj.AttendanceList.length > 0){
            //   var row = JsonObj.AttendanceList[0];
            //   sentryID = row.SentryID;
            //   dutyID = row.DutyID;
            //   attendanceDate = row.DutyDate;
            //   AttendanceDetails();
            //   $shiftPopItem.removeClass('item-choose');
            //   $shiftPopItem.eq(0).addClass('item-choose');
            // }

          } else {
            Msg.Error.Show(JsonObj.Message);
          }

          Msg.Load.Hide();
        })
      }

      function AttendanceDetails(first, dutyTypeName) {
        // Msg.Load.Show('', 100);
        inte.AttendanceDetails({
          SentryID: sentryID,
          DutyID: dutyID,
          AttendanceDate: attendanceDate
        }, function (JsonObj) {
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            CurrentTime = new Date(JsonObj.CurrentServerTime);
            setInterval(function () {
              CurrentTime = new Date(CurrentTime.getTime() + 1000);

              //显示打卡时间
              $clockTime.text(TimeToStr(CurrentTime, 'HH:mm'));

              // 一分钟更新一次 GPS和WIFI
              if (CurrentTime.getSeconds() % 60 == 0) {
                GPSnWIFI();
              }
            }, 1000);

            AttendanceInfo = JsonObj.AttendanceInfo;
            if (AttendanceInfo) {
              GPSnWIFI();
              var dutyDate = AttendanceInfo.CurrentDate || ' ';
              var dutyName = AttendanceInfo.DutyName || ' ';
              var dutyTime = AttendanceInfo.WorkStartTime && AttendanceInfo.WorkOffTime ? AttendanceInfo.WorkStartTime + '-' + AttendanceInfo.WorkOffTime : ' ';
              if (dutyTypeName) {
                var str = dutyTypeName; //.replaceAll("班次", "");
                $shift.html(str + " " + dutyDate + "<br>( " + dutyName + " " + dutyTime + " )");
              } else {
                $shift.text(dutyDate + " " + dutyName + " (" + dutyTime + ")");
              }

              var starttime = new Date(AttendanceInfo.CurrentDate + ' ' + AttendanceInfo.WorkStartTime);
              var offtime = new Date(AttendanceInfo.CurrentDate + ' ' + AttendanceInfo.WorkOffTime);
              var AttendanceEffectiveTime = AttendanceInfo.AttendanceEffectiveTime || 0;
              if (offtime < starttime) {
                offtime.setDate(offtime.getDate() + 1);
              }
              $shift.data('offtime', offtime);
              $shift.data('starttime', starttime);
              $shift.data('effectivetime', AttendanceEffectiveTime);
              $shift.data('useflag', AttendanceInfo.UseFlag);
              $shift.data('overmvalue', AttendanceInfo.DataMatchValue);
              $shift.data('overvalue', AttendanceInfo.DataValue);
              IBeaconInfo.iBeaconName = AttendanceInfo.AttendanceIBeaconName || '';
              IBeaconInfo.iBeaconID = AttendanceInfo.AttendanceIBeaconIdentity || '';
              IBeaconInfo.SignPlaceName = AttendanceInfo.SignPlaceName || '';
              IBeaconInfo.SignPlaceLongitude = AttendanceInfo.SignLongitude || '';
              IBeaconInfo.SignPlaceLatitude = AttendanceInfo.SignLatitude || '';
              startSignRecordID = AttendanceInfo.StartSignRecordID || 0;
              offSignRecordID = AttendanceInfo.OffSignRecordID || 0;
            }

            if (first) {
              AttendanceList();
            } else {
              Msg.Load.Hide();
            }

          } else {
            Msg.Load.Hide();
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      function bpopInit() {
        var popUp = new BPopUp({
          trigger: '#ClockBox',
          data: [{
            title: '二维码打卡',
            data: 'QR_CODE',
            color: 'default'
          },
          {
            title: '拍照打卡',
            data: 'PHOTO',
            color: 'default'
          },
          {
            title: '普通打卡',
            data: 'ORDINARY',
            color: 'default'
          },
          {
            title: 'iBeacon打卡',
            data: 'IBEACON',
            color: 'default'
          }]
        }, function (data, title) {
          $clockCircle.data('SignMode', data);
          $('.clockType').html(title);
          setAppStorage('CLOCKTYPE', title);
          setAppStorage('CLOCKCIRCLE', data)
        }, function () {
          var notPop = $shift.text() == '暂无班次' || !$shift.text().trim();
          if (notPop) {
            Msg.Error.Show('暂无班次');
          }
          return notPop;
        })

        // popUp.init();
      }

      function clockConfirm(type, fun, param) {
        // var date = new Date();
        if (!CurrentTime) return;
        var date = CurrentTime;
        var offtime = $shift.data('offtime');
        var starttime = $shift.data('starttime');
        var effectivetime = $shift.data('effectivetime');
        var useflag = $shift.data('useflag');
        var overmvalue = parseFloat($shift.data('overmvalue'));
        var overvalue = parseFloat($shift.data('overvalue'));
        var offWorkFlag = date < offtime;
        var startEffectiveWorkFlag = true;
        var offEffectiveWorkFlag = true;

        if (effectivetime >= 0) {
          var startDel = DateDiff('m', starttime, date);
          if (startDel > effectivetime) {
            startEffectiveWorkFlag = false;
          }

          var offDel = DateDiff('m', date, offtime);
          if (offDel > effectivetime) {
            offEffectiveWorkFlag = false;
          }

          if (!offEffectiveWorkFlag && useflag == 'T' && offDel >= overmvalue + overvalue) {
            //不在有效下班时间内，但是是有效的加班，就默认是加班
            offEffectiveWorkFlag = true;
          }
        }

        if ((!startEffectiveWorkFlag && !startSignRecordID) || (!offEffectiveWorkFlag && startSignRecordID)) {
          Confirm.Show({
            title: "",
            content: "当前不在有效时间内，确认打卡？",
            warning: false,
            txt: true,
            btntxt: [
              "坚持打卡",
              "暂不打卡"
            ]
          }, function () {
            console.log('暂不打卡')
          }, function () {
            console.log('坚持打卡')
            if (fun) {
              fun(param);
            }
          });
          // Msg.Error.Show("当前不在有效时间内,无法打卡！", 2);
        } else if (offWorkFlag && startSignRecordID) {
          Confirm.Show({
            title: "未到下班时间",
            content: "坚持打卡会被记为早退",
            warning: false,
            btntxt: [
              "坚持打卡",
              "暂不打卡"
            ]
          }, function () {
            console.log('暂不打卡')
          }, function () {
            console.log('坚持打卡')
            if (fun) {
              fun(param);
            }
          });

        } else if (type != "QR_CODE" && !distanceFlag) {
          Confirm.Show({
            title: '当前不在打卡范围',
            content: '',
            warning: true,
            btntxt: [
              "坚持打卡",
              "暂不打卡"
            ]
          }, function () {
            console.log('暂不打卡')
          }, function () {
            console.log('坚持打卡')
            if (fun) {
              fun(param);
            }
          });
        } else {
          if (fun) {
            fun(param)
          }
        }
      }

      function AttendanceSign(param) {

        var qrcode;
        var imgInfo;
        var IBeaconInfo;


        if (param) {
          qrcode = param.qrcode || ''
          imgInfo = param.imgInfo || ''
          IBeaconInfo = param.IBeaconInfo || '';
        }

        // alert(JSON.stringify({
        //   SentryID: sentryID,
        //   DutyID: dutyID,
        //   AttendanceDate: attendanceDate,
        //   SignMode: $clockCircle.data('SignMode'),
        //   SignWifiName: wifiInfo ? wifiInfo.wifiName.replace('\"','').replace('\"','') : '',
        //   SignWifiBSSID: wifiInfo ? wifiInfo.bassid : '',
        //   SignQRCode: qrcode || '',
        //   SignElevation: gpsInfo ? gpsInfo.altitude : '',
        //   SignImgInfo: imgInfo || '',
        //   SignPlaceName: gpsInfo ? gpsInfo.address : '',
        //   SignPlaceLongitude: gpsInfo ? gpsInfo.lon : '',
        //   SignPlaceLatitude: gpsInfo ? gpsInfo.lat : ''
        // }))
        inte.AttendanceSign({
          SentryID: sentryID,
          DutyID: dutyID,
          AttendanceDate: attendanceDate,
          SignMode: $clockCircle.data('SignMode'),
          SignWifiName: wifiInfo ? wifiInfo.wifiName ? wifiInfo.wifiName.replace('\"', '').replace('\"', '') : '' : '',
          SignWifiBSSID: wifiInfo ? wifiInfo.bassid || '' : '',
          SignIBeaconName: IBeaconInfo ? IBeaconInfo.iBeaconName || '' : '',
          SignIBeaconIdentity: IBeaconInfo ? IBeaconInfo.iBeaconID || '' : '',
          SignQRCode: qrcode || '',
          SignElevation: gpsInfo ? gpsInfo.altitude || '' : '',
          SignImgInfo: imgInfo || '',
          SignPlaceName: IBeaconInfo ? IBeaconInfo.SignPlaceName : gpsInfo.address || '',
          SignPlaceLongitude: IBeaconInfo ? IBeaconInfo.SignPlaceLongitude : gpsInfo.lon || '',
          SignPlaceLatitude: IBeaconInfo ? IBeaconInfo.SignPlaceLatitude : gpsInfo.lat || '',
        }, function (JsonObj) {
          var result;
          var message;
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            result = 'success';
            message = '打卡成功'
          } else {
            result = 'fail';
            message = JsonObj.Message;
          }
          winOpen('Clock_QrCode_Result.html?result=' + result + '&message=' + message)
        })

      }

      function getRange(gpsInfo) {
        var range = nativeGetDistance(gpsInfo.lat, gpsInfo.lon, parseFloat(AttendanceInfo.SignLatitude), parseFloat(AttendanceInfo.SignLongitude));
        // return parseFloat(range).toFixed(2)
        return parseInt(range)
      }

      function GPSnWIFI() {

        //获取原生GPS信息
        gpsInfo = nativeGpsInfo();
        //获取原生wifi信息
        wifiInfo = nativeWifiInfo();

        if (gpsInfo && AttendanceInfo) {
          // distanceFlag = (range >= 0 && range < effectiveDistance);
          distanceFlag = nativeInRange(parseFloat(AttendanceInfo.SignLatitude), parseFloat(AttendanceInfo.SignLongitude));

          if (distanceFlag) {
            if (wifiInfo && wifiInfo.wifiName && wifiInfo.bassid) {
              $clockWifiName.text(wifiInfo.wifiName.replace('\"', '').replace('\"', ''))
              $clockWifiName.data('bassid', wifiInfo.bassid || '')
            } else {
              $clockWifi.hide()
            }
            $('.clock-in-range').removeClass('ui-hide')
          } else {
            $('.out-range-info').text((gpsInfo.address || '') + '-距离打卡范围' + getRange(gpsInfo) + '米')
            $('.clock-out-range').removeClass('ui-hide')
          }
        }
      }

      if (isFirst) {

        GPSnWIFI();

        if (getAppStorage('CLOCKTYPE') && getAppStorage('CLOCKCIRCLE')) {
          $('.clockType').html(getAppStorage('CLOCKTYPE'));
          $clockCircle.data('SignMode', getAppStorage('CLOCKCIRCLE'));
        } else {
          $('.clockType').html('普通打卡');
          $clockCircle.data('SignMode', 'ORDINARY');
        }

        // //ibeacon回调
        // nativeIBeaconInfo(attendaceIbeaconId);
        // nativeFindIbeaconResultInstance.setFun(function (iBeacon){
        //   AttendanceSign({
        //     iBeacon: iBeacon
        //   });
        // })

        // // 二维码扫码回调
        // nativeQrCodeResultInstance.setFun(function (qrcode) {
        //   AttendanceSign({
        //     qrcode: qrcode
        //   });
        // })

        // // 拍照回调
        // nativeFileUploadResultInstance.setFun(function (file) {
        //   if (file && file.Code == 1 && file.FileList && file.FileList.length > 0) {
        //     AttendanceSign({
        //       imgInfo: JSON.stringify(file.FileList)
        //     });
        //   } else {
        //     Msg.Error.Show('请重新上传图片')
        //   }
        // })

        AttendanceDetails(true, "当前班次");

        bpopInit();

        initClick();
      }
    }
  },

  'Clock_QrCode_Result.html': {
    Init: function (isFirst, Param) {

      var result = request('result');
      var message = request('message');
      var type = request('type');

      var $headerTitle = $('.header-title');
      var $qrcodeResult = $('.qrcode-result');
      var $qrcodeTips = $('.qrcode-tips');
      var $qrcodeTime = $('.qrcode-time');
      var $qrcodeImgType = $('.qrcode-img-type');
      var $btnBack = $('#btnBack');

      var initClick = function () {
        $btnBack.tap(ToClick, function () {
          if (type == 'point' || type == 'mp') {
            // nativeCloseWebView();
            backAppPage();
          } else {
            winBack();
          }
        })
      }

      if (isFirst) {
        if (result == "success") {
          if (type == 'point') {
            $headerTitle.text('打点成功');
            $(document).attr('title', '打点成功');
          } else {
            $headerTitle.text('打卡成功')
            $(document).attr('title', '打卡成功');
          }
          $qrcodeResult.addClass('qrcode-success')
          $qrcodeTips.text(message || '打卡成功')
          $qrcodeTime.text(TimeToStr(new Date(), 'yyyy-MM-dd HH:mm'))
          $qrcodeImgType.addClass('img-icon-clock-check')
        } else {
          if (type == 'point') {
            $headerTitle.text('打点失败')
            $(document).attr('title', '打点失败');
          } else {
            $headerTitle.text('打卡失败')
            $(document).attr('title', '打卡失败');
          }
          $qrcodeTips.text(message || '打卡失败')
          $qrcodeImgType.addClass('img-icon-clock-mark')
        }
        initClick()
      }
    }
  },

  'Clock_Task.html': {
    Init: function (isFirst, Param) {

      var $currentShift = $('.current-shift');
      var $signPlace = $('.sign-place');
      var $sentryType = $('.sentry-type');
      var $shiftPop = $('.shift-pop');
      var $shiftPopBox = $('.shift-pop-box');
      var $shiftPopItem = $(".shift-pop-item");
      var $shiftBox = $('#shiftBox');
      var $shiftPopShadow = $('.shift-pop-shadow');
      var $btnBack = $('#btnBack');

      var sentryID = request('SentryID');
      var dutyID = request('DutyID');
      var attendanceDate = request('AttendanceDate');

      var initClick = function () {
        $shiftBox.tap(ToClick, function (e) {
          e.preventDefault();
          if (!$shiftPopBox.text().trim()) {
            Msg.Error.Show("暂无班次");
          } else {
            $shiftPop.fadeIn();
          }
        })

        $shiftPopShadow.tap(ToClick, function (e) {
          e.preventDefault();
          $shiftPop.fadeOut();
        })

        $btnBack.tap(ToClick, function () {
          backAppPage();
        })
      }

      function AttendanceList() {

        inte.AttendanceList({
          BeginIndex: 0,
          DataCount: 20
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            var $list = $shiftPopBox;
            $list.empty();
            var html = "";

            for (var key in JsonObj.AttendanceList) {
              var row = JsonObj.AttendanceList[key];

              var chooseFlag = row.DutyID == dutyID && row.DutyDate == attendanceDate

              html = '';
              html += '<div class="shift-pop-item' + (chooseFlag ? ' item-choose' : '') + '" data-dutyid=' + row.DutyID + ' data-dutydate=' + row.DutyDate + ' data-sentytype=' + row.SentryTypeName + ' data-sentryid=' + row.SentryID + ' data-dutytypename=' + row.DutyTypeName + '>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div class="shift-pop-sel"></div>'
              html += '    <div>' + row.DutyDate + '</div>'
              html += '    <div>(' + row.DutyTypeName + ')</div>'
              html += '  </div>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div></div>'
              html += '    <div>' + row.DutyName + '</div>'
              html += '    <div>' + row.DutyWorkTime + '</div>'
              html += '  </div>'
              html += '</div>'

              if (chooseFlag) {
                $sentryType.text(row.SentryTypeName);
                if (!$sentryType.text()) {
                  $sentryType.addClass('empty-content');
                } else {
                  $sentryType.removeClass('empty-content');
                }
              }

              var $html = $(html);
              $html.tap(ToClick, function (e) {
                e.preventDefault();
                sentryID = $(this).data('sentryid')
                dutyID = $(this).data('dutyid')
                attendanceDate = $(this).data('dutydate')
                $shiftPopItem.removeClass('item-choose')
                $(this).addClass('item-choose')
                $sentryType.text($(this).data('sentytype'));
                if (!$sentryType.text()) {
                  $sentryType.addClass('empty-content');
                } else {
                  $sentryType.removeClass('empty-content');
                }
                $shiftPop.fadeOut()
                AttendanceDetails($(this).data("dutytypename"))
              })

              $list.append($html);
            }

            if (JsonObj.AttendanceList.length < 1) {
              // html = '';
              // html += '<div class="ui-text-center">暂无班次</div>';
              // $list.append($(html));
            }

            $shiftPopItem = $(".shift-pop-item");
          } else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      function AttendanceDetails(dutyTypeName) {
        inte.AttendanceDetails({
          SentryID: sentryID,
          DutyID: dutyID,
          AttendanceDate: attendanceDate
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            var AttendanceInfo = JsonObj.AttendanceInfo
            if (AttendanceInfo) {
              var dutyDate = AttendanceInfo.CurrentDate || ' ';
              var dutyName = AttendanceInfo.DutyName || ' ';
              var dutyTime = AttendanceInfo.WorkStartTime && AttendanceInfo.WorkOffTime ? AttendanceInfo.WorkStartTime + '-' + AttendanceInfo.WorkOffTime : ' ';
              if (dutyTypeName) {
                var str = dutyTypeName; //.replaceAll("班次", "");
                $currentShift.html(str + " " + dutyDate + "<br>( " + dutyName + " " + dutyTime + " )");
              } else {
                $currentShift.text(dutyDate + " " + dutyName + " (" + dutyTime + ")");
              }

              $signPlace.text(AttendanceInfo.SignPlaceName);
              if (!$signPlace.text()) {
                $signPlace.addClass('empty-content');
              } else {
                $signPlace.removeClass('empty-content');
              }
            }

          } else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      if (isFirst) {
        AttendanceList();
        AttendanceDetails("当前班次");
        initClick()
      }
    }
  },

  'Clock_Record.html': {
    Init: function (isFirst, Param) {

      var $shiftPop = $('.shift-pop');
      var $shiftPopBox = $('.shift-pop-box');
      var $shiftPopItem = $(".shift-pop-item");
      var $shiftBox = $('#shiftBox');
      var $shiftPopShadow = $('.shift-pop-shadow');
      var $btnBack = $('#btnBack');
      var $currentShift = $('.current-shift');
      var $sentryType = $('.sentry-type');

      var sentryID = request('SentryID');
      var dutyID = request('DutyID');
      var attendanceDate = request('AttendanceDate');

      var $tab = $('.record-tab-item');
      var $tabList1 = $('#Tab1-ScrollInit');
      var $tabList2 = $('#Tab2-ScrollInit');
      var $tablist = $('.clock-record-list');

      var initClick = function () {

        $tab.tap(ToClick, function () {
          $tab.removeClass('choose');
          $(this).addClass('choose');
          var tabIndex = $(this).data('tab');
          $tablist.hide();
          if (tabIndex == 2) {
            $tabList2.show();
          } else {
            $tabList1.show();
          }
        })

        $shiftBox.tap(ToClick, function (e) {
          e.preventDefault();
          if (!$shiftPopBox.text().trim()) {
            Msg.Error.Show("暂无班次");
          } else {
            $shiftPop.fadeIn();
          }
        })

        $shiftPopShadow.tap(ToClick, function (e) {
          e.preventDefault();
          $shiftPop.fadeOut();
        })

        $btnBack.tap(ToClick, function () {
          backAppPage();
        })
      }

      function AttendanceList() {
        inte.AttendanceList({
          // SentryID: sentryID,
          // BeginDate: attendanceDate,
          // EndDate: attendanceDate,
          BeginIndex: 0,
          DataCount: 20
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            var $list = $shiftPopBox;
            $list.empty();
            var html = "";

            for (var key in JsonObj.AttendanceList) {
              var row = JsonObj.AttendanceList[key];

              var chooseFlag = row.DutyID == dutyID && row.DutyDate == attendanceDate

              html = '';
              html += '<div class="shift-pop-item' + (chooseFlag ? ' item-choose' : '') + '" data-dutyid=' + row.DutyID + ' data-dutydate=' + row.DutyDate + ' data-sentryid=' + row.SentryID + ' data-dutytypename=' + row.DutyTypeName + '>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div class="shift-pop-sel"></div>'
              html += '    <div>' + row.DutyDate + '</div>'
              html += '    <div>(' + row.DutyTypeName + ')</div>'
              html += '  </div>'
              html += '  <div class="flex-column-center shift-pop-contain">'
              html += '    <div></div>'
              html += '    <div>' + row.DutyName + '</div>'
              html += '    <div>' + row.DutyWorkTime + '</div>'
              html += '  </div>'
              html += '</div>'

              var $html = $(html);
              $html.tap(ToClick, function (e) {
                e.preventDefault();
                sentryID = $(this).data('sentryid');
                dutyID = $(this).data('dutyid');
                attendanceDate = $(this).data('dutydate');
                $shiftPopItem.removeClass('item-choose');
                $(this).addClass('item-choose');
                $shiftPop.fadeOut();
                AttendanceAndDutyRecordInfo($(this).data("dutytypename"));
              })

              $list.append($html);
            }

            if (JsonObj.AttendanceList.length < 1) {
              // html = '';
              // html += '<div class="ui-text-center">暂无班次</div>';
              // $list.append($(html));
            }

            $shiftPopItem = $(".shift-pop-item");

          } else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      function AttendanceAndDutyRecordInfo(dutyTypeName) {
        inte.AttendanceAndDutyRecordInfo({
          SentryID: sentryID,
          DutyID: dutyID,
          DutyDate: attendanceDate
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            if (JsonObj.AttendanceInfo) {
              var AttendanceInfo = JsonObj.AttendanceInfo;
              var dutyDate = AttendanceInfo.CurrentAttendanceDate || ' ';
              var dutyName = AttendanceInfo.DutyName || ' ';
              var dutyTime = AttendanceInfo.WorkStartTime && AttendanceInfo.WorkOffTime ? AttendanceInfo.WorkStartTime + '-' + AttendanceInfo.WorkOffTime : ' ';
              if (dutyTypeName) {
                var str = dutyTypeName; //.replaceAll("班次", "");
                $currentShift.html(str + " " + dutyDate + "<br>( " + dutyName + " " + dutyTime + " )");
              } else {
                $currentShift.text(dutyDate + " " + dutyName + " (" + dutyTime + ")");
              }
            }

            if (JsonObj.DutyInfo) {
              var sentryType = '-';
              if (JsonObj.DutyInfo.SentryType == 'REGULAR') {
                sentryType = '按序巡查'
              } else if (JsonObj.DutyInfo.SentryType == 'RANGE') {
                sentryType = '范围巡查'
              } else if (JsonObj.DutyInfo.SentryType == 'POINT') {
                sentryType = '无序巡查'
              }
              $sentryType.text(sentryType);
            }

            // 打卡记录
            $tabList1.empty();
            for (var key in JsonObj.AttendanceSignRecordList) {
              var row = JsonObj.AttendanceSignRecordList[key];
              var html = '';
              html += '<div class="clock-record-item">';
              html += '    <div class="clock-record-type flex-center">';
              if (row.SignMode == "QR_CODE") {
                html += '        <div>二维码打卡</div>';
              } else if (row.SignMode == "PHOTO") {
                html += '        <div>拍照打卡</div>';
              } else if (row.SignMode == "ORDINARY") {
                html += '        <div>普通打卡</div>';
              } else if (row.SignMode == "IBEACON") {
                html += '        <div>iBeacon打卡</div>';
              }
              html += '        <div>' + (row.SignTime || '') + '</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>WiFi</div>';
              html += '        <div>' + (row.SignWifiName || '') + '</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>海拔</div>';
              html += '        <div>' + (row.SignElevation || 0) + '米</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>位置</div>';
              html += '        <div class="ui-nowrap-2line">' + (row.SignPlaceName || '') + '</div>';
              html += '    </div>';
              if (row.SignMode == "PHOTO") {
                html += '    <div class="clock-record-info">';
                html += '        <div>照片</div>';
                if (row.SignImg) {
                  html += '        <div><div class="clock-record-photo" style="background-image:url(' + row.SignImg + ')" data-img="' + row.SignImgThumb + '"></div></div>';
                } else {
                  html += '        <div><div class="clock-record-photo"></div></div>';
                }
                html += '    </div>';
              }
              html += '</div>';

              var $html = $(html);

              $tabList1.append($html);
              $html.find('.clock-record-photo').each(function () {
                $(this).tap(ToClick, function () {
                  if ($(this).data('img')) {
                    ImgPreview($(this).data('img'));
                  }
                })
              })
            }
            if (JsonObj.AttendanceSignRecordList.length < 1) {
              $tabList1.append('<div class="clock-record-nomessage flex-center">暂无内容</div>');
            }

            // 打点记录
            $tabList2.empty();
            for (var key in JsonObj.DutySignRecordList) {
              var row = JsonObj.DutySignRecordList[key];
              var html = '';
              html += '<div class="clock-record-item">';
              html += '    <div class="clock-record-type flex-center">';
              if (row.SignMode == "QR_CODE") {
                html += '        <div>二维码打点</div>';
              } else if (row.SignMode == "PHOTO") {
                html += '        <div>拍照打点</div>';
              } else if (row.SignMode == "ORDINARY") {
                html += '        <div>普通打点</div>';
              } else if (row.SignMode == "IBEACON") {
                html += '        <div>iBeacon打点</div>';
              }
              html += '        <div>' + (row.SignTime || '') + '</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>WiFi</div>';
              html += '        <div>' + (row.SignWifiName || '') + '</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>海拔</div>';
              html += '        <div>' + (row.SignElevation || 0) + '米</div>';
              html += '    </div>';
              html += '    <div class="clock-record-info">';
              html += '        <div>位置</div>';
              html += '        <div class="ui-nowrap-2line">' + (row.SignPlaceName || '') + '</div>';
              html += '    </div>';
              if (row.SignMode == "PHOTO") {
                html += '    <div class="clock-record-info">';
                html += '        <div>照片</div>';
                if (row.SignImg) {
                  html += '        <div><div class="clock-record-photo" style="background-image:url(' + row.SignImg + ')" data-img="' + row.SignImgThumb + '"></div></div>';
                } else {
                  html += '        <div><div class="clock-record-photo"></div></div>';
                }
                html += '    </div>';
              }
              html += '</div>';

              var $html = $(html);

              $tabList2.append($html);
              $html.find('.clock-record-photo').each(function () {
                $(this).tap(ToClick, function () {
                  if ($(this).data('img')) {
                    ImgPreview($(this).data('img'));
                  }
                })
              })
            }
            if (JsonObj.DutySignRecordList.length < 1) {
              $tabList2.append('<div class="clock-record-nomessage flex-center">暂无内容</div>');
            }

          } else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      if (!$('.header-nav').is(':visible')) {
        $shiftPopShadow.addClass('mask-mp');
      }

      if (isFirst) {

        AttendanceList();
        AttendanceAndDutyRecordInfo("当前班次");

        initClick()

        // 设置滚动区域
        OverScroll($tabList1.get(0));
        OverScroll($tabList2.get(0));
      }
    }
  }
})