app = $.extend(true, app, {
    'Duty_Handover.html': {
        Init: function (isFirst, Param) {
            var $ScrollInit = $("#ScrollInit");
            var $DutyAddress = $("#DutyAddress");
            var $fromContentList = $('.from-content-list');
            var $toContentList = $('.to-content-list');
            var $FromRemark = $("#FromRemark");
            var $ToRemark = $("#ToRemark");
            var $FromContent = $("#FromContent");
            var $ToContent = $("#ToContent");
            var $SentryBox = $("#SentryBox");
            var $DutyBox = $("#DutyBox");
            var $DutyBoxFrom = $("#DutyBox1");
            var $DutyBoxTo = $("#DutyBox2");
            var $noDuty = $("#noDuty");
            var $handover = $("#Handover");

            var $btnBack = $("#btnBack");
            var $btnSave = $('.btn-save');

            var shiftType = request('shiftType').toUpperCase();
            var inteFlag = true;
            var fromPhotoBox;
            var toPhotoBox;
            var dutyPopUp;
            var gps = nativeGpsInfo();

            var initClick = function () {

                $btnBack.click(function () {
                    backAppPage();
                });

                $btnSave.tap(ToClick, function () {
                    // 填写错误提示
                    if (required()) {
                        ImgUpload();
                    }
                });
            };

            var required = function () {
                if (!$SentryBox.data('sentryid')) {
                    Msg.Error.Show('请选择岗位');
                    return false;
                }
                if (!$DutyBox.data('fromdutyid') || !$DutyBox.data('todutyid')) {
                    Msg.Error.Show('请选择班次');
                    return false;
                }
                // if(!gps || !gps.lon || !gps.lat){
                //   Msg.Error.Show('无GPS信息');
                //   return false;
                // }

                var remark;
                var $list;
                var flag = true;
                var abnormal = false;

                if (shiftType == "FROM") {
                    $list = $fromContentList;
                    remark = $FromRemark.find('textarea').val()
                } else if (shiftType == "TO") {
                    $list = $toContentList;
                    remark = $ToRemark.find('textarea').val()
                }

                $list.find('.duty-detail-item').each(function () {
                    var state = $(this).data('state');
                    if (state != 'NORMAL' && state != 'ABNORMAL') {
                        flag = false;
                    }

                    if (state == 'ABNORMAL') {
                        abnormal = true;
                    }
                });
                if (!flag) {
                    Msg.Error.Show('请选择交接项状态');
                    return false;
                }
                if (!remark && abnormal) {
                    Msg.Error.Show('请填写备注');
                    return false;
                }

                var imgPathString;
                if (shiftType == "FROM") {
                    imgPathString = fromPhotoBox.getData();
                } else if (shiftType == "TO") {
                    imgPathString = toPhotoBox.getData();
                }

                /*
                if (imgPathString == '[]') {
                    Msg.Error.Show("请上传图片");
                    return false;
                }
                */

                return true;
            };

            // 图片上传
            var ImgUpload = function () {

                var nativeImgArr = [];
                var urlImgArr = [];

                if (shiftType == "FROM") {
                    $(fromPhotoBox.elid+' .scene-img-item').each(function () {
                        var path;
                        if (!$(this).attr("src") || $(this).attr("src") == "Img/ico_addPhoto@2x.png") {
                            path = ""
                        } else {
                            path = $(this).attr("src");
                        }

                        var imgData = $(this).data('imgdata');
                        if(imgData){
                            urlImgArr.push(imgData);
                        }else{
                            nativeImgArr.push(path);
                        }
                    })
                } else if (shiftType == "TO") {
                    $(toPhotoBox.elid+' .scene-img-item').each(function () {
                        var path;
                        if (!$(this).attr("src") || $(this).attr("src") == "Img/ico_addPhoto@2x.png") {
                            path = ""
                        } else {
                            path = $(this).attr("src");
                        }

                        var imgData = $(this).data('imgdata');
                        if(imgData){
                            urlImgArr.push(imgData);
                        }else{
                            nativeImgArr.push(path);
                        }
                    })
                }

                var imgPathString = JSON.stringify(nativeImgArr);
                if(imgPathString == '[]'){
                    submit(urlImgArr);
                } else if(inteFlag) {
                    inteFlag = false;
                    nativeFileUpload(imgPathString);
                    nativeFileUploadResultInstance.setFun(function (file) {
                        if (file) {
                            submit(file.FileList.concat(urlImgArr));
                        } else {
                            inteFlag = true;
                        }
                    });
                }
            };

            // 提交
            var submit = function (fileList) {

                var contentList = [];
                var $list;
                var remark;
                var state;

                if (shiftType == "FROM") {
                    $list = $fromContentList;
                    remark = $FromRemark.find('textarea').val();
                    state = "S0I"
                } else if (shiftType == "TO") {
                    $list = $toContentList;
                    remark = $ToRemark.find('textarea').val();
                    state = "S0A"
                }
                $list.find('.duty-detail-item').each(function () {
                    contentList.push({
                        ContentID: $(this).data('id'),
                        Content: $(this).data('content'),
                        ContentStatus: $(this).data('state')
                    })
                });

                var params = {
                    SentryID: $SentryBox.data('sentryid'),
                    FromDutyID: $DutyBox.data('fromdutyid'),
                    FromDutyDate: $DutyBox.data('fromdutydate'),
                    ToDutyID: $DutyBox.data('todutyid'),
                    ToDutyDate: $DutyBox.data('todutydate'),
                    ShiftType: shiftType,
                    PlaceName: gps ? gps.address : '',
                    PlaceLongitude: gps ? gps.lon : '',
                    PlaceLatitude: gps ? gps.lat : '',
                    Remard: remark,
                    HandleStatus: state,
                    ContentList: JSON.stringify(contentList),
                    AnnexList: JSON.stringify(fileList)
                };

                inte.ShiftHandleV2(params, function (JsonObj) {
                    if (JsonObj.Code == 1) {
                        Msg.OK.Show(JsonObj.Message, 2, function () {
                            backAppPage();
                        })
                    } else {
                        Msg.Error.Show(JsonObj.Message, 2, function () {
                            inteFlag = true;
                            if (JsonObj.IsRefreshPage == "T") {
                                sentryPopInit();
                            }
                        });
                    }
                })
            };

            // 岗位弹窗
            var sentryPopInit = function () {

                inte.ShiftSentryDutyList({
                    SentryID: 0,
                    ShiftType: shiftType
                }, function (JsonObj) {
                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {
                        var dataList = [];
                        var dutyData = [];
                        for (var key in JsonObj.SentryList) {

                            var row = JsonObj.SentryList[key];

                            var html = '';
                            html += '<div class="flex-column-center shift-pop-contain">'
                            html += '  <div class="shift-pop-sel"></div>'
                            html += '  <div>' + row.SentryName + '</div>';
                            html += '</div>'

                            var choose = 0;

                            if (key == 0) {
                                choose = row.SentryID;
                                $SentryBox.text(row.SentryName);
                                $SentryBox.data('sentryid', row.SentryID);
                            }
                            var data = {
                                html: html,
                                data: row,
                                choose: choose
                            }
                            if (choose) {
                                dutyData = row.ShiftDutyList;
                            }

                            dataList.push(data);
                        }

                        if (JsonObj.SentryList.length <= 0) {
                            $SentryBox.text('暂无岗位');
                            $SentryBox.tap(ToClick, function () {
                                Msg.Error.Show('暂无岗位');
                            })

                            $noDuty.show();
                            $DutyBoxFrom.hide();
                            $DutyBoxTo.hide();
                            $DutyBox.tap(ToClick, function () {
                                Msg.Error.Show('暂无班次');
                            })

                            $DutyAddress.text('-');
                            $FromRemark.find('textarea').val('');
                            if (shiftType == "TO") {
                                $FromRemark.find('textarea').attr('disabled', 'disabled');
                                $ToRemark.find('textarea').val('')
                                toPhotoBox.imgClean();
                            }
                            fromPhotoBox.imgClean();
                            $fromContentList.empty();
                            $toContentList.empty();
                            buttonPosition();
                        } else {
                            var popUp = new MPopUp({
                                trigger: '#SentryBox',
                                data: dataList
                            }, function (data, title) {
                                $SentryBox.text(data.SentryName);
                                $SentryBox.data('sentryid', data.SentryID);
                                var dutyData = data.ShiftDutyList;
                                if (dutyData && dutyData.length > 0) {
                                    var dutyDate = dutyData[0].FromDutyDate || ' ';
                                    var dutyName = dutyData[0].FromDutyName || ' ';
                                    var dutyTime = dutyData[0].FromDutyBeginTime && dutyData[0].FromDutyEndTime ? '(' + dutyData[0].FromDutyBeginTime + '-' + dutyData[0].FromDutyEndTime + ')' : ' ';

                                    var dutyDateTo = dutyData[0].ToDutyDate || ' ';
                                    var dutyNameTo  = dutyData[0].ToDutyName || ' ';
                                    var dutyTimeTo  = dutyData[0].ToDutyBeginTime && dutyData[0].ToDutyEndTime ? '(' + dutyData[0].ToDutyBeginTime + '-' + dutyData[0].ToDutyEndTime + ')' : ' ';

                                    $noDuty.hide();
                                    $DutyBoxFrom.show();
                                    $DutyBoxTo.show();

                                    $DutyBoxFrom.text(dutyDate + ' ' + dutyName + dutyTime);
                                    $DutyBoxTo.text(dutyDateTo + ' ' + dutyNameTo + dutyTimeTo);

                                    $DutyBox.data('fromdutyid', dutyData[0].FromDutyID);
                                    $DutyBox.data('fromdutydate', dutyData[0].FromDutyDate);
                                    $DutyBox.data('todutyid', dutyData[0].ToDutyID);
                                    $DutyBox.data('todutydate', dutyData[0].ToDutyDate);
                                    dutyPopInit(dutyData);
                                    ShiftInfo();
                                } else {

                                }
                            })

                            dutyPopUp = new MPopUp({
                                trigger: '#DutyBox',
                                data: []
                            }, function (data, title) {
                                var dutyDate = data.FromDutyDate || ' ';
                                var dutyName = data.FromDutyName || ' ';
                                var dutyTime = data.FromDutyBeginTime && data.FromDutyEndTime ? '(' + data.FromDutyBeginTime + '-' + data.FromDutyEndTime + ')' : ' ';
                                var dutyDateTo = data.ToDutyDate || ' ';
                                var dutyNameTo  = data.ToDutyName || ' ';
                                var dutyTimeTo  = data.ToDutyBeginTime && data.ToDutyEndTime ? '(' + data.ToDutyBeginTime + '-' + data.ToDutyEndTime + ')' : ' ';

                                $noDuty.hide();
                                $DutyBoxFrom.show();
                                $DutyBoxTo.show();

                                $DutyBoxFrom.html(dutyDate + '&nbsp;&nbsp;' + dutyName + dutyTime);
                                $DutyBoxTo.html(dutyDateTo + '&nbsp;&nbsp;' + dutyNameTo + dutyTimeTo);
                                $DutyBox.data('fromdutyid', data.FromDutyID);
                                $DutyBox.data('fromdutydate', data.FromDutyDate);
                                $DutyBox.data('todutyid', data.ToDutyID);
                                $DutyBox.data('todutydate', data.ToDutyDate);
                                ShiftInfo();
                            })

                            dutyPopInit(dutyData);

                            if (dutyData && dutyData.length > 0) {
                                var dutyDate = dutyData[0].FromDutyDate || ' ';
                                var dutyName = dutyData[0].FromDutyName || ' ';
                                var dutyTime = dutyData[0].FromDutyBeginTime && dutyData[0].FromDutyEndTime ? '(' + dutyData[0].FromDutyBeginTime + '-' + dutyData[0].FromDutyEndTime + ')' : ' ';

                                var dutyDateTo = dutyData[0].ToDutyDate || ' ';
                                var dutyNameTo  = dutyData[0].ToDutyName || ' ';
                                var dutyTimeTo  = dutyData[0].ToDutyBeginTime && dutyData[0].ToDutyEndTime ? '(' + dutyData[0].ToDutyBeginTime + '-' + dutyData[0].ToDutyEndTime + ')' : ' ';

                                $noDuty.hide();
                                $DutyBoxFrom.show();
                                $DutyBoxTo.show();

                                $DutyBoxFrom.html(dutyDate + '&nbsp;&nbsp;' + dutyName + dutyTime);
                                $DutyBoxTo.html(dutyDateTo + '&nbsp;&nbsp;' + dutyNameTo + dutyTimeTo);

                                $DutyBox.data('fromdutyid', dutyData[0].FromDutyID);
                                $DutyBox.data('fromdutydate', dutyData[0].FromDutyDate);
                                $DutyBox.data('todutyid', dutyData[0].ToDutyID);
                                $DutyBox.data('todutydate', dutyData[0].ToDutyDate);
                                dutyPopInit(dutyData);
                                ShiftInfo();
                            }
                        }
                    } else if (JsonObj.Code == -101) {
                        //账号多地登录
                        Msg.Error.Show(JsonObj.Message);
                    } else {
                        Msg.Error.Show(JsonObj.Message);
                    }
                })

            };

            // 班次弹窗
            var dutyPopInit = function (dutyData) {

                var dataList = [];
                for (var key in dutyData) {

                    var row = dutyData[key];
                    var dutyTime = row.FromDutyBeginTime && row.FromDutyEndTime ? '(' + row.FromDutyBeginTime + '-' + row.FromDutyEndTime + ')' : ' ';
                    var dutyTimeTo = row.ToDutyBeginTime && row.ToDutyEndTime ? '(' + row.ToDutyBeginTime + '-' + row.ToDutyEndTime + ')' : ' ';

                    var html = '';
                    html += '<div class="flex-column-center shift-pop-contain">'
                    html += '  <div class="shift-pop-sel"></div>'
                    html += '  <div>交班班次</div>'
                    html += '  <div>' + row.FromDutyDate + '</div>'
                    html += '</div>'
                    html += '<div class="flex-column-center shift-pop-contain">'
                    html += '  <div></div>'
                    html += '  <div>' + row.FromDutyName + '</div>'
                    html += '  <div>' +dutyTime + '</div>'
                    html += '</div>'
                    html += '<div class="flex-column-center shift-pop-contain ui-margin-t-10">'
                    html += '  <div></div>'
                    html += '  <div>接班班次</div>'
                    html += '  <div>' + row.ToDutyDate + '</div>'
                    html += '</div>'
                    html += '<div class="flex-column-center shift-pop-contain">'
                    html += '  <div></div>'
                    html += '  <div>' + row.ToDutyName + '</div>'
                    html += '  <div>' +dutyTimeTo + '</div>'
                    html += '</div>'

                    var choose = $DutyBox.data('fromdutyid') && $DutyBox.data('todutyid')
                        && $DutyBox.data('fromdutydate') && $DutyBox.data('todutydate')
                        && row.FromDutyID == $DutyBox.data('fromdutyid')
                        && row.ToDutyID == $DutyBox.data('todutyid')
                        && row.FromDutyDate == $DutyBox.data('fromdutydate')
                        && row.ToDutyDate == $DutyBox.data('todutydate');
                    var data = {
                        html: html,
                        data: row,
                        choose: choose
                    }

                    dataList.push(data);
                }

                if (dutyData.length <= 0) {
                    $noDuty.show();
                    $DutyBoxFrom.hide();
                    $DutyBoxTo.hide();
                    $DutyBox.tap(ToClick, function () {
                        Msg.Error.Show('暂无班次');
                    })
                } else {
                    dutyPopUp.setContent(dataList);
                }

            };

            // 交接班信息
            var ShiftInfo = function () {

                // return
                inte.ShiftInfoV2({
                    SentryID: $SentryBox.data('sentryid') || 0,
                    FromDutyID: $DutyBox.data('fromdutyid') || 0,
                    FromDutyDate: $DutyBox.data('fromdutydate') || '',
                    ToDutyID: $DutyBox.data('todutyid') || 0,
                    ToDutyDate: $DutyBox.data('todutydate') || '',
                    ShiftType: shiftType
                }, function (JsonObj) {
                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {

                        var info = JsonObj.ShiftInfo;
                        if (info) {
                            // $SentryBox.text(info.SentryName || '');
                            // $SentryBox.data('sentryid', info.SentryID);
                            //
                            // var dutyDate = info.FromDutyDate || ' ';
                            // var dutyName = info.FromDutyName || ' '
                            // var dutyTime = info.FromDutyBeginTime && info.FromDutyEndTime ? '(' + info.FromDutyBeginTime + '-' + info.FromDutyEndTime + ')' : ' ';
                            // $DutyBox.text(dutyDate + ' ' + dutyName + dutyTime);
                            // $DutyBox.data('fromdutyid', info.FromDutyID);
                            // $DutyBox.data('fromdutydate', info.FromDutyDate);
                            // $DutyBox.data('todutyid', info.ToDutyID);
                            // $DutyBox.data('todutydate', info.ToDutyDate);
                            $DutyBox.data('fromdutyendtime', info.FromDutyEndTime);
                            $DutyBox.data('todutybegintime', info.ToDutyBeginTime);
                            $DutyBox.data('shifteffectivetime', info.ShiftEffectiveTime);

                            $DutyAddress.text(info.ShiftPlaceName || '')
                            $FromRemark.find('textarea').val(info.FromRemard || '')

                            if (shiftType == "TO") {
                                $FromRemark.find('textarea').attr('disabled', 'disabled')
                                $ToRemark.find('textarea').val(info.ToRemard || '')
                            }
                        }

                        fromPhotoBox.imgClean();
                        if (JsonObj.FromShiftAnnexList) {
                            for (var key in JsonObj.FromShiftAnnexList) {
                                var annex = JsonObj.FromShiftAnnexList[key];
                                var imgData = {
                                    "FileNo": annex.FileNo,
                                    "FileType": annex.FileType,
                                    "FileUrl": annex.FilePath,
                                    "ThumbUrl": annex.FileThumbPath
                                };
                                fromPhotoBox.imgAdd(annex.FilePath,annex.FileThumbPath,imgData);
                            }
                        }

                        if (shiftType == "TO") {
                            $handover.find('.duty-place-word').text(JsonObj.FromUserInfo ? JsonObj.FromUserInfo.UserName || '' : '');
                            fromPhotoBox.readonly();
                            toPhotoBox.imgClean();
                            if (JsonObj.ToShiftAnnexList) {
                                for (var key in JsonObj.ToShiftAnnexList) {
                                    var annex = JsonObj.ToShiftAnnexList[key];
                                    var imgData = {
                                        "FileNo": annex.FileNo,
                                        "FileType": annex.FileType,
                                        "FileUrl": annex.FilePath,
                                        "ThumbUrl": annex.FileThumbPath
                                    };
                                    toPhotoBox.imgAdd(annex.FilePath,annex.FileThumbPath, imgData);
                                }
                            }
                        }

                        var $list = $fromContentList;
                        var data = JsonObj.FromShiftContentList;
                        shiftContentRender(data, $list);

                        if (shiftType == "TO") {
                            $list = $toContentList;
                            data = JsonObj.ToShiftContentList;
                            shiftContentRender(data, $list);
                        }

                        buttonPosition();

                    } else if (JsonObj.Code == -101) {
                        //账号多地登录
                        Msg.Error.Show(JsonObj.Message);
                    } else {
                        Msg.Error.Show(JsonObj.Message, 2 , function () {
                            if (JsonObj.IsRefreshPage == "T") {
                                sentryPopInit();
                            }
                        });
                    }
                })

            }

            // 交接内容
            var shiftContentRender = function (data, $list) {

                $list.empty();
                var flag = shiftType == "TO" && $list == $fromContentList;
                var html = "";

                for (var key in data) {

                    var row = data[key];

                    var elID = 'DutyDetailChoose' + parseInt(Math.random() * 100000);

                    html = '';
                    html += '<li class="duty-item duty-site">'
                    html += '  <div class="duty-tite">' + row.Content + '</div>'
                    html += '  <div class="duty-site-box flex-column-center">'
                    var state;
                    if (row.ContentStatus == "NORMAL") {
                        state = "正常";
                    } else if (row.ContentStatus == "ABNORMAL") {
                        state = "异常";
                    } else {
                        state = "请选择";
                    }
                    html += '    <div class="duty-location-word duty-place-word duty-detail-item ' + (state == "请选择" ? 'ui-color-99 ' : ' ')
                        + (row.ContentStatus == 'ABNORMAL' ? 'ui-color-red' : '') + (flag ? ' item-no-img' : '')
                        + '" data-id="' + row.ContentID + '" data-state="' + row.ContentStatus + '" data-content="' + row.Content
                        + '" id="' + elID + '">' + state + '</div>'
                    if (!flag) {
                        html += '    <div class="img-icon-go duty-icon"></div>'
                    }
                    html += '  </div>'
                    html += '</li>'

                    var $html = $(html);
                    $list.append($html);

                    if (!flag) {
                        var popUp = new BPopUp({
                            trigger: '#' + elID,
                            data: [{
                                title: '正常',
                                data: 'NORMAL',
                                color: 'default'
                            }, {
                                title: '异常',
                                data: 'ABNORMAL',
                                color: 'red'
                            }],
                        }, function (data, title) {
                            $(this.trigger).removeClass('ui-color-99');
                            $(this.trigger).text(title);
                            $(this.trigger).data('state', data);
                            if (data == "ABNORMAL") {
                                $(this.trigger).addClass('ui-color-red');
                            } else {
                                $(this.trigger).removeClass('ui-color-red');
                            }
                        })
                    }

                }

                if (data.length <= 0) {

                }
            }

            var buttonPosition = function () {
                var $item = $('.scene-img').last();
                var btnTop = $btnSave.offset().top;
                var btnOrginTop = $item.offset().top + $item.outerHeight();
                var margintop = btnTop - btnOrginTop;
                if (margintop < 15) {
                    margintop = 15;
                }
                $btnSave.css({
                    'margin-top': margintop + 'px',
                    'margin-bottom': '0.15rem',
                    'position': 'static',
                })
            }

            if (isFirst) {

                fromPhotoBox = new PhotoBox({
                    beforeEl: $FromRemark
                })
                // fromPhotoBox.imgAdd('//www.baidu.com/img/bd_logo1.png?qua=high');

                if (shiftType == "FROM") {
                    $handover.hide();
                    $ToContent.hide();
                } else if (shiftType == "TO") {
                    $(".header-title").text('接班');
                    $btnSave.text('确认接班');
                    toPhotoBox = new PhotoBox({
                        beforeEl: $ToRemark
                    });

                    var $remark = $FromRemark.find('textarea')
                    $remark.attr('placeholder','无')
                }

                initClick();
                OverScroll($ScrollInit.get(0));

                sentryPopInit();
            }
        }
    }
})
