app = $.extend(true, app, {
  'Mine_ChooseTeam.html': {
    Init: function (isFirst, Param) {

      var $ProjectList = $("#ProjectList");
      var $TeamList = $("#TeamList");
      var $nextStep = $('#NextStep');
      var $btnSave = $('#BtnSave');
      var $btnBack = $("#btnBack");
      var $ScrollInit = $(".team");
      var $headerTitle = $('.header-title');
      var groupID = getAppStorage("DEPARTMENT_GROUP_ID");
      var projectID = getAppStorage("PROJECT_ID");

      var data = {};

      var GetTeamList = function () {
        inte.TeamList({}, function (JsonObj) {
          if (JsonObj.Code == 1) {
            var DepartmentGroupList = JsonObj.DepartmentGroupList;
            for (var i in DepartmentGroupList) {
              var row = DepartmentGroupList[i];

              if (row.ProjectID) {
                var project = data[row.ProjectID];
                if (!project) {
                  data[row.ProjectID] = {
                    projectName: row.ProjectName,
                    projectType: row.ProjectType,
                    groupList: []
                  }
                }

                project = data[row.ProjectID];
                project.groupList.push(row);
              }
            }

            ProjectRender();
          } else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      var ProjectRender = function () {
        for (var k in data) {
          row = data[k];
          var html = '';
          html += '<li class="team-item ui-border-b-slim">';
          html += '  <div class="team-item-box">';
          html += '    <span class="team-name" >' + row.projectName +'(' + (row.projectType == 'OFFICE' ? '内勤' : '外勤')+ ')</span>';
          html += '  </div>'
          html += '</li>';
          $html = $(html);
          $html.data('groupList', row.groupList);
          $html.tap(ToClick, function () {
            $ProjectList.find('.team-item').removeClass("team-choose");
            $ProjectList.find(".team-choose-icon").remove();
            $(this).addClass("team-choose");
            AddChooseIcon($(this));
            projectEvent($(this).data('groupList'));
          })
          $ProjectList.append($html);
          if (projectID) {
            if (k == projectID) {
              AddChooseIcon($html);
              $html.addClass("team-choose");
              projectEvent($html.data('groupList'));
            }
          }
        }

        if ($ProjectList.find(".team-choose").length <= 0) {
          var $html = $ProjectList.find('.team-item').eq(0);
          AddChooseIcon($html);
          $html.addClass("team-choose");
          projectEvent($html.data('groupList'));
        }

        btnPosition($nextStep);
      }

      var projectEvent = function (groupList) {
        $nextStep.off().tap(ToClick, function () {
          $ProjectList.hide();
          $nextStep.hide();
          $TeamList.show();
          $btnSave.show();
          $headerTitle.text('我的职位');
          $btnBack.off().click(function () {
            $ProjectList.show();
            $nextStep.show();
            $TeamList.hide();
            $btnSave.hide();
            $headerTitle.text('我的项目');
            $btnBack.off().click(function () {
              nativeShowTab();
              winBack();
            })
          })
          TeamRender(groupList);
        })
      }

      var TeamRender = function (groupList) {
        $TeamList.find('li').remove();
        $TeamList.data('projectid', groupList[0].ProjectID);
        $TeamList.data('projecttype', groupList[0].ProjectType);
        $TeamList.data('projectname', groupList[0].ProjectName);
        for (var key in groupList) {
          var group = groupList[key];
          var $html = AddTeamList(group.DepartmentGroupID, group.DepartmentGroupName || '', group.RoleSpecKey, group.RoleSpecName);
          $TeamList.append($html);
          if (groupID) {
            if (group.DepartmentGroupID == groupID) {
              AddChooseIcon($html);
              $html.addClass("team-choose");
              teamEvent($html);
            }
          }
        }

        if ($TeamList.find(".team-choose").length <= 0) {
          var $html = $TeamList.find('.team-item').eq(0);
          AddChooseIcon($html);
          $html.addClass("team-choose");
          teamEvent($html);
        }

        btnPosition($btnSave);
      }


      var AddTeamList = function (GroupID, GroupName, RoleSpecKey, RoleSpecName) {
        var html = '';
        html += '<li class="team-item ui-border-b-slim" data-groupid="' + GroupID + '" data-grounpname="' + GroupName + '" data-roleid="' + RoleSpecKey + '">';
        html += '<div class="team-item-box">';
        if (GroupName) {
          html += '<span class="team-name" >' + GroupName + '</span>';
        }
        html += '<span class="team-name" >' + RoleSpecName + '</span>'
        html += '</div>'
        html += '</li>';
        $html = $(html);
        $html.tap(ToClick, function () {
          $TeamList.find('.team-item').removeClass("team-choose");
          $TeamList.find(".team-choose-icon").remove();
          $(this).addClass("team-choose");
          AddChooseIcon($(this));
          teamEvent($(this));
        })
        return $html;
      }

      var teamEvent = function ($html) {
        $btnSave.off();
        $btnSave.tap(ToClick, function () {
          var GroupID = $html.data("groupid");
          var GrounpName = $html.data("grounpname");
          var RoleID = $html.data("roleid");
          var ProjectID = $TeamList.data('projectid');
          var ProjectType = $TeamList.data('projecttype');
          var ProjectName = $TeamList.data('projectname');
          if (window.PlatformID == 4) {
            wx.miniProgram.postMessage({
              data: {
                groupid: GroupID,
                groupname: GrounpName,
                roleid: RoleID,
                projid: ProjectID,
                projtype: ProjectType,
                projname: ProjectName
              }
            })
            wx.miniProgram.redirectTo({ url: '../saving/saving' });
          } else {
            setAppStorage("DEPARTMENT_GROUP_ID", GroupID);
            setAppStorage("DEPARTMENT_GROUP_NAME", GrounpName);
            setAppStorage("ROLE_ID", RoleID);
            setAppStorage("PROJECT_ID", ProjectID);
            setAppStorage("PROJECT_NAME", ProjectName);
            setAppStorage("PROJECT_TYPE", ProjectType);
            nativeChooseProject(ProjectID, GroupID);
            nativeShowTab();
            winBack();
          }
        })
      }

      var AddChooseIcon = function (el) {
        var html = '';
        html += '<div class="team-choose-icon">';
        html += '<img src="Img/ico_choose@3x.png" alt="">';
        html += '</div>'

        el.append(html);
      }

      var InitClick = function () {
        $btnBack.click(function () {
          nativeShowTab();
          winBack();
        })
      }

      var headerH = $('.header-nav:visible').height();
      var lineH = $('.bottom-line').height();
      var btnPosition = function ($btn) {
        var contentH = $('.teamlist').height();
        var btnH = $btn.height();
        var margintop = window.innerHeight - headerH - contentH - btnH - lineH - 1;
        if (margintop < 40) {
          margintop = 40;
        }
        $btn.css('margin-top', margintop);
        $btn.show();
      }

      if (isFirst) {
        InitClick();
        OverScroll($ScrollInit.get(0));
        GetTeamList();
      } else {

      }
    }
  }
})
