app = $.extend(true, app, {

  "Work_Daily_List.html": {
    Init: function (isFirst, Param) {

      var $btnBack = $('#btnBack');
      var $btnRelease = $('.img-btn-release');
      var $dailyList = $("#dailyList");
      var $dailyListShow = $("#dailyListShow");
      var $ScrollInit = $("#ScrollInit");
      var $dailyDetailShow = $("#dailyDetailShow");
      var $dailyHappenTime = $("#dailyHappenTime");
      var $reportedPeople = $("#reportedPeople");
      var $dailyToday = $("#dailyToday");
      var $dailyTomorrow = $("#dailyTomorrow");
      var $dailyPhotoList = $("#dailyPhotoList");
      var $calendarDate = $('.calendar-date');
      var $btnClose = $('#btnClose');
      var $txtSearch = $('#txtSearch');
      var $addSpace = $('.add-space');

      var beginIndex = 0;
      var dataCount = 20;
      var canLoadMore = true;
      var versionsNum = window.PlatformID;

      var roleID = getAppStorage('ROLE_ID');
      var roleFlag = roleID == "MANAGER" || roleID == "GMANAGER" || roleID == "ADMIN_A" || roleID == "CLERICAL_STAFF";
      if (roleFlag) {
        $btnRelease.addClass("ui-hide");
        $addSpace.addClass("ui-hide");
      }

      var addImg = function (thumb, img) {
        var html = '';
        html += '<li class="scene-img-box alarm-img-item" data-originalimg="' + img + '">';
        html += '<img src="' + thumb + '" alt="" class="alarm-item-img">';
        html += '</li>';

        var $html = $(html);
        $html.tap(ToClick, function () {
          if ($(this).data('originalimg')) {
            ImgPreview($(this).data('originalimg'));
          }
        })

        $dailyPhotoList.append($html);
      }

      var addWorkDailyList = function (row) {
        var html = '';
        html += '<li class="alarm-list-item ui-border-b-slim" data-name="' + row.UserName + '" data-id="' + row.WorkingReportID + '">';
        html += '<div class="alarm-img default-img">';
        if (row.AnnexList[0].FileThumbPath) {
          html += '<img src="' + row.AnnexList[0].FileThumbPath + '" class="alarm-list-img" />';
        }
        html += '</div>';
        html += '<div class="alarm-details">';
        html += '<div class="alarm-details-top">';
        html += '<div class="alarm-reporter">汇报人：' + row.UserName + '</div>';
        html += '<div class="alarm-reportime">' + row.AddTime + '</div>';
        html += '</div>';
        html += '<div class="alarm-details-bottom">' + row.ContentToday + '';
        html += '</div>';
        html += '</div>';
        html += '</li>';

        var $html = $(html);
        $html.off().tap(ToClick, function () {    
          $txtSearch.blur();
          $dailyListShow.addClass("ui-hide");
          $dailyDetailShow.removeClass("ui-hide");
          // $btnRelease.addClass("ui-hide");
          $dailyHappenTime.html(row.AddTime);
          $reportedPeople.html(row.UserName);
          $dailyToday.html(row.ContentToday);
          $dailyTomorrow.html(row.ContentTomorrow);
          $dailyPhotoList.empty();
          for (var i in row.AnnexList) {
            var thumb = row.AnnexList[i].FileThumbPath;
            var img = row.AnnexList[i].FilePath;
            addImg(thumb, img)
          }
          $dailyListShow.addClass("ui-hide");
          $dailyDetailShow.removeClass("ui-hide");

          $btnBack.off().click(function () {
            $dailyListShow.removeClass("ui-hide");
            $dailyDetailShow.addClass("ui-hide");

            $btnBack.off().click(function () {
              backAppPage();
            })
          })
        })

        $dailyList.append($html)
      }

      function WorkingReportRecordList() {
        var searchName = $txtSearch.val().trim() || '';
        var reportDate = $calendarDate.data('date');

        inte.WorkingReportRecordList({
          BeginIndex: beginIndex,
          DataCount: dataCount,
          // TOFIX
          // ReportDate: '',
          ReportDate: reportDate,
          SearchName: searchName
        }, function (JsonObj) {
          if(!beginIndex){
            $dailyList.empty();
          }
          $('.no-messages').remove();
          canLoadMore = true;
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            var WorkingReportList = JsonObj.WorkingReportList;
            for (var i in WorkingReportList) {
              var row = WorkingReportList[i];
              addWorkDailyList(row);
            }
            if (!WorkingReportList || !WorkingReportList.length) {
              var html = '';
              if(!beginIndex){
                html += '<div class="no-messages ui-bgc-f5">没有信息</div>';
              }else{
                // html += '<div class="no-messages ui-bgc-f5">没有更多信息</div>';
              }
              $addSpace.before(html);
              canLoadMore = false;
            }
            beginIndex += WorkingReportList.length;
          } else {
            Msg.Error.Show(JsonObj.Message)
          }
        })
      }

      var initClick = function () {
        $btnBack.off().click(function () {
          backAppPage();
        })

        $btnRelease.off().tap(ToClick, function () {
          winOpen("Work_Daily_Add.html");
        })

        $btnClose.off().tap(ToClick, function (e) {
          $txtSearch.val("");
          beginIndex = 0;
          WorkingReportRecordList();
          $btnClose.addClass("ui-hide");
        });
      };

      //写完关键词触发
      var compositionendToShow = function () {
        var flag = false;
        if (versionsNum == 1) {
          flag = true;
          $txtSearch.on({
            'compositionstart': function () {
              flag = false;
            },
            'compositionend': function () {
              flag = true;
            },
            'input': function () {
              setTimeout(function () {
                if (flag) {
                  inputSearch();
                }
              }, 50);
            }
          });
        }else if(versionsNum == 0){
          $txtSearch.on({
            compositionend:function(){
              setTimeout(function(){
                inputSearch();
                flag = false;
              },50)
            },
            compositionstart:function(){
              flag = true;
            },
            keydown:function () {
              setTimeout(function(){
                if(!flag){
                  inputSearch();
                }
              },50)
            }
          });
        }
        
      };

      var inputSearch = function(){
        var str = $txtSearch.val().trim() || "";
        if (str) {
          $btnClose.removeClass("ui-hide");
        }
        beginIndex = 0;
        WorkingReportRecordList();
      }

      if (isFirst) {

        initClick();
        OverScroll($ScrollInit.get(0));
        OverScroll($dailyDetailShow.get(0));

        $calendarDate.text(TimeToStr(new Date(), 'yyyy-MM-dd'));
        $calendarDate.data('date', TimeToStr(new Date(), 'yyyy-MM-dd'));

        var calendar = new lCalendar();
        calendar.init({
          'trigger': '.calendar-div',
          'type': 'date',
          'txtShow': '.calendar-date',
          'txtType': 'html'
        }, function (data) {
          // 日期选择事件
          calendar.setDate(data);
          $calendarDate.data('date', data);
          beginIndex = 0;
          WorkingReportRecordList();
        });

        compositionendToShow();

        WorkingReportRecordList();

        $ScrollInit.scroll(function () {
          var $item = $('.alarm-list-item').last();
          if($item.length > 0 && $item.offset().top < window.innerHeight && canLoadMore){
            canLoadMore = false;
            WorkingReportRecordList();
          }
        })

        // 弹出键盘后添加按钮隐藏
        var widnowHeight = window.innerHeight;
        window.addEventListener('resize',function(){  
          if($dailyListShow.is(':visible')){
            if(window.innerHeight < widnowHeight - 100){
              $btnRelease.addClass("ui-hide");
              if (!roleFlag) {
                $btnRelease.addClass("interim");
              }
            }else{
              if($btnRelease.hasClass("interim")){
                $btnRelease.removeClass("ui-hide");
              }
            }
          }
        })

      }
    }
  }
});