app = $.extend(true, app, {
  "Work_Daily_Calendar.html": {
    Init: function (isFirst, Param) {
      var $btnBack = $('#btnBack');
      var $btnAdd = $('#DailyAdd');
      var $ScrollInit = $("#ScrollInit");
      var $messages = $('.messages');
      var $topDiv = $('#topDiv');
      var $contentDiv = $('#contentDiv');
      var $divH = $('#divH');
      var $schedulebox = $('#schedule-box');

      var $detailDiv = $('#ScrollInit-Detail');
      var $btnEdit = $('#DailyEdit');
      var $detailDate = $('.detail-date');
      var $detailUser = $('.detail-user');
      var $detailPosition = $('.detail-position');
      var $detailContent = $('.detail-content');
      var $DailyContent = $('#DailyContent');
      var $DailyInfo = $('#DailyInfo');
      // var $placeSpace = $detailDiv.find('.place-space');
      var $btnEditCommit = $('.btn-edit-commit');
      var $btnCancel = $('#DailyCancle');

      var $addDiv = $('#ScrollInit-Add');
      var $btnAddCommit = $('.btn-add-commit');
      var $addContent = $('.add-content');

      var roleID = getAppStorage('ROLE_ID');
      var gps = nativeGpsInfo();
      var inteFlag = true;
      var mySchedule;
      var photoboxEdit;
      var photoboxAdd;
      var isSelf = false;
      var detail = {};

      // -------------------------------------------------- 日历组件函数 --------------------------------------------------

      //设置滚动区域
      var setScroll = function () {
        var pd2 = $topDiv.height();
        var pd = $divH.height();
        var ScrollInitID = $ScrollInit.attr("id");
        var ArtHeight = window.innerHeight;
        var movebox2 = document.querySelector("#messagesDiv"); //内容
        var Delheight = $topDiv.height() + $schedulebox.height();
        var endY = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0;

        //设置日历和内容区域的上边距=顶部高度
        $contentDiv.css({
          "padding-top": pd2 + "px"
        });

        var DivArray = $ScrollInit.parent().children();
        for (var i = 0; i < DivArray.length; i++) {
          if (DivArray.eq(i).attr("id") != ScrollInitID) {
            Delheight += DivArray.eq(i).height();
          }
        }
        $ScrollInit.css({ //列表容器高度
          "height": (ArtHeight - Delheight - endY) + "px",
          // "padding-top": pd + "px",
          "overflow-x": "auto"
        });
        $ScrollInit.addClass("ui-ios");
      };

      var updateScroll = function (moveDir) {
        //更新滚动区域的高度
        var ScrollInitID = $ScrollInit.attr("id");
        var ArtHeight = window.innerHeight;
        var movebox2 = document.querySelector("#messagesDiv"); //内容
        var Delheight = $topDiv.height() + $schedulebox.height();
        var endY = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0;

        var DivArray = $ScrollInit.parent().children();
        for (var i = 0; i < DivArray.length; i++) {
          if (DivArray.eq(i).attr("id") != ScrollInitID) {
            Delheight += DivArray.eq(i).height();
          }
        }
        $ScrollInit.css({ //列表容器高度
          "height": (ArtHeight - Delheight - endY) + "px"
        });

        if (moveDir) {
          $ScrollInit.css({ //列表容器高度
            "overflow-y": "scroll"
          });
        } else {
          $ScrollInit.css({ //列表容器高度
            "overflow-y": "hidden"
          });
        }
      };

      //更新日历translateY值
      var updateSchedule = function () {
        var movebox1 = document.querySelector("#schedule-box"); //日历框
        var movebox2 = document.querySelector("#messagesDiv"); //内容
        var liH = parseInt($('ul.schedule-bd li').eq(1).css('height').replace('px', '')); //一个单元的高度(加上下边框的高度)
        var rows = parseInt($('ul.schedule-bd li').length / 9) - 1; //总共有多少行日历
        var endY2 = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值
        var choose;

        if (!endY2) {
          updateScroll(false);
        } else {
          updateScroll(true);

          if ($(".schedule-bd .selected-style").index() !== -1) {
            choose = Math.floor($(".schedule-bd .selected-style").index() / 9);
          } else {
            choose = Math.floor($(".schedule-bd .today-flag").index() / 9);
          }

          if (choose < 0) {
            choose = 0;
          }
          movebox1.style.webkitTransform = "translateY(" + (-choose * liH) + "px)";
          movebox2.style.webkitTransform = "translateY(" + (-liH * rows) + "px)";
        }
      };

      var scheduleAnimate = function () {
        var moveY, //手指滑动距离
          endY1, //手指停止滑动时Y轴坐标
          endY2, //手指停止滑动时Y轴坐标
          startY, //获取触摸坐标
          moveDir, //滑动方向
          choose; //滑动方向
        var nflag = false; // 下框是否拉到顶部
        var moveFlag = 0; //是否有touchmove
        var movebox1 = document.querySelector("#schedule-box"); //日历框
        var movebox2 = document.querySelector("#messagesDiv"); //内容
        var movebox3 = document.querySelector("#ScrollInit"); //滚动内容
        var liH = parseInt($('ul.schedule-bd li').eq(1).css('height').replace('px', '')); //一个单元的高度(加上下边框的高度)
        var maxMove1 = 0;
        var maxMove2 = 0;
        var scale = 1;
        var rows = parseInt($('ul.schedule-bd li').length / 9) - 1; //总共有多少行日历


        //触摸开始
        function boxTouchStart(e) {
          var touch = e.touches[0]; //获取触摸对象
          moveFlag = 1;
          rows = parseInt($('ul.schedule-bd li').length / 9) - 1;
          startY = touch.pageY; //获取触摸坐标
          endY1 = parseInt(movebox1.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值
          endY2 = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值

          //translateY效果用时，为0时是随手指的移动移动
          movebox1.style.transitionDuration = "0s";
          movebox2.style.transitionDuration = "0s";

          if ($(".schedule-bd .selected-style").index() !== -1) {
            choose = Math.floor($(".schedule-bd .selected-style").index() / 9);
          } else {
            choose = Math.floor($(".schedule-bd .today-flag").index() / 9);
          }

          if (choose < 0) {
            choose = 0;
          }

          //向上移动最终位置
          maxMove1 = choose * liH;
          maxMove2 = rows * liH;

          scale = maxMove1 / maxMove2;

          if ($ScrollInit.scrollTop() <= 0) {
            nflag = true;
          } else {
            nflag = false;
          }
        }


        function boxTouchMove(e) {
          e.preventDefault();
          var touch = e.touches[0];
          var tempY1;
          var tempY2;

          moveFlag = 2;
          if (!nflag) {
            //滑动日历，如果滚动内容不是在顶部，设置到顶部
            $ScrollInit.animate({
              scrollTop: 0
            }, 500);
            nflag = true;
          }

          moveY = touch.pageY - startY; //手指水平方向移动的距离
          moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

          if (moveDir && endY2 == -maxMove2) {
            //向上，并且初始位置就是最终位置，说明原来位置就是在0
            return;
          } else if (!moveDir && endY2 == 0) {
            return;
          }

          tempY1 = endY1 + moveY * scale;
          tempY2 = endY2 + moveY;

          if (moveDir) {
            if (tempY1 >= -maxMove1) {
              movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)"; //手指滑动时滑动对象随之滑动
            }

            if (tempY2 >= -maxMove2) {
              movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)"; //手指滑动时滑动对象随之滑动
            }
          } else {
            if (tempY1 <= 0) {
              movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox1.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
            }

            if (tempY2 <= 0) {
              movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox2.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
            }
          }

          updateScroll(false);

        }

        function boxTouchEnd(e) {
          if (moveFlag != 2) {
            moveFlag = 0;
            return;
          }
          e.preventDefault(); //让点击效果失效

          moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

          //translateY效果用时
          movebox1.style.transitionDuration = "0.2s";
          movebox2.style.transitionDuration = "0.2s";

          if (moveDir) {
            movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)";
            movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)";
          } else {
            movebox1.style.webkitTransform = "translateY(" + (0) + "px)";
            movebox2.style.webkitTransform = "translateY(" + (0) + "px)";
          }

          updateScroll(moveDir);
        }

        function boxTouchMove2(e) {
          var touch = e.touches[0];
          var tempY1;
          var tempY2;

          moveFlag = 2;

          moveY = touch.pageY - startY; //手指水平方向移动的距离
          moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

          if (!nflag) {
            return;
          }

          if (window.PlatformID !== 0) {
            e.preventDefault();
          }

          if (endY1 < 0 && nflag && moveDir) {
            e.returnValue = true;
          }

          if (moveDir && endY2 == -maxMove2) {
            //向上，并且初始位置就是最终位置，说明原来位置就是在0
            return;
          } else if (!moveDir && endY2 == 0) {
            return;
          }

          tempY1 = endY1 + moveY * scale;
          tempY2 = endY2 + moveY;

          if (moveDir) {
            if (tempY1 >= -maxMove1) {
              movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)"; //手指滑动时滑动对象随之滑动
            }

            if (tempY2 >= -maxMove2) {
              movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)"; //手指滑动时滑动对象随之滑动
            }
          } else {
            if (tempY1 <= 0) {
              movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox1.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
            }

            if (tempY2 <= 0) {
              movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
            } else {
              movebox2.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
            }
          }

          updateScroll(false);
        }

        function boxTouchEnd2(e) {
          if (!nflag || moveFlag != 2) {
            moveFlag = 0;
            return;
          }
          moveFlag = 0;
          e.preventDefault(); //让点击效果失效
          moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

          movebox1.style.transitionDuration = "0.2s";
          movebox2.style.transitionDuration = "0.2s";
          if (moveDir) {
            movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)";
            movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)";
          } else {
            movebox1.style.webkitTransform = "translateY(" + (0) + "px)";
            movebox2.style.webkitTransform = "translateY(" + (0) + "px)";
          }

          updateScroll(moveDir);
        }

        //滑动对象事件绑定
        movebox1.addEventListener("touchstart", boxTouchStart, false);
        movebox1.addEventListener("touchmove", boxTouchMove, false);
        movebox1.addEventListener("touchend", boxTouchEnd, false);

        movebox3.addEventListener("touchstart", boxTouchStart, false);
        movebox3.addEventListener("touchmove", boxTouchMove2, false);
        movebox3.addEventListener("touchend", boxTouchEnd2, false);

        setScroll();
        updateScroll(false);
      };

      // -------------------------------------------------- 日历组件函数 --------------------------------------------------

      function WorkingMonthRecordList() {
        $('.calendar-content').remove()

        var monthDate = $('#txtDate').data('date') || TimeToStr(new Date(), 'yyyy-MM-dd');

        inte.WorkingMonthRecordList({
          ReportDate: monthDate
        }, function (JsonObj) {

          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            for (var key in JsonObj.DayList) {
              var row = JsonObj.DayList[key];
              var $list = $(".currentDate[title='" + row.DayDate + "']");
              var html = '';
              if (row.WorkingReportList && row.WorkingReportList.length > 0) {
                html += '<div class="calendar-content">'
                html += '  <div class="point"></div>';
                html += '</div>'
              }

              var $html = $(html);
              $list.data("WorkingReportList", row.WorkingReportList);

              $list.append($html);
            }
            if ($('.today-flag').length > 0) {
              $('.today-flag').click();
            } else {
              $('.currentDate').eq(0).click();
            }
            updateSchedule();
          }
        })
      }

      var ListRender = function (list) {
        $messages.empty();
        for (var key in list) {
          var row = list[key];
          var $list = $messages;
          var html = '';

          html += '<div class="ui-padding-lr-15 ui-bgc-ff" data-dailyid=' + row.WorkingReportID + '>';
          html += '    <div class="ui-row-flex ui-flex-align-center msgs-item ui-height-80 ui-border-b-slim">';
          html += '        <div class="ui-nowrap-2line ui-col ui-col ui-color-26 ui-fontsize-16" style="line-height: 1.5">' + row.ContentToday + '</div>';
          if (row.AnnexList && row.AnnexList.length) {
            if (row.AnnexList[0].FilePath.length) {
              // html += '    <div class="daily-photo ui-margin-l-13" style="background-image:url(' + row.AnnexList[0].FilePath + ')"></div>';
              html += '    <div class="daily-photo ui-margin-l-13"><img src="'+row.AnnexList[0].FilePath+'"></div>';
            }
          }
          html += '    </div>';
          html += '    <div class="flex-between ui-height-45 ui-fontsize-14 ui-color-61">';
          html += '        <div>' + row.UserName + '</div>';
          html += '        <div>' + row.AddTime + '</div>';
          html += '    </div>';
          html += '  </div>';
          html += '</div>';
          if (key < list.length - 1) {
            html += '<div class="bottom-line"></div>';
          }

          var $html = $(html);
          $html.data('detail', row);
          $html.tap(ToClick, function () {
            detail = $(this).data('detail');
            DetailRender();
            DetailShow();
          });

          $list.append($html);
        }
        if (!list || list.length === 0) {
          var $html = $('<div class="no-message">当天没有工作日报</div>');
          $messages.append($html);
        }
      };

      var DetailRender = function () {
        isSelf = detail.UIdentifyID == getAppStorage('UIDENTIFY_ID');
        var date = detail.AddTime ? detail.AddTime.replace(' ', ' ' + $('.weekDay').text()) + ' ' : '';
        $detailDate.text(date);
        $detailUser.text(detail.UserName || '-');
        $detailPosition.text(detail.DepartmentGroupInfos || '-');
        $detailContent.val(detail.ContentToday || ' ');
        photoboxEdit.imgClean();
        for (var key in detail.AnnexList) {
          var annex = detail.AnnexList[key]
          var imgData = {
            "FileNo": annex.AnnexNo,
            "FileType": annex.FileType,
            "FileUrl": annex.FilePath,
            "ThumbUrl": annex.FileThumbPath
          }
          photoboxEdit.imgAdd(annex.FilePath, "", imgData);
        }
        photoboxEdit.readonly();
        $btnEditCommit.data('dailyid', detail.WorkingReportID);
      }

      var ListShow = function () {
        // 所有人都可以写日报
        $btnAdd.show();
        // if (roleID == 'CAPTAIN' || roleID == 'MONITOR' || roleID == 'MEMBER') {
        //   $btnAdd.show();
        // } else {
        //   if (window.PlatformID == 4) {
        //     $('.header-nav').addClass('ui-hide');
        //     $('.mp-fix').addClass('mp-fix-active');
        //     $('#topDiv').children('div').first().remove();
        //   }
        // }
        $addDiv.hide();
        $btnEdit.hide();
        $detailDiv.hide();
        $topDiv.show();
        $contentDiv.show();
        $btnBack.off().click(function () {
          backAppPage();
        })
      }

      var DetailShow = function () {
        if (window.PlatformID == 4) {
          if (isSelf) {
            $('.header-nav').removeClass('ui-hide');
            $('.mp-fix').removeClass('mp-fix-active');
          } else {
            $('.header-nav').addClass('ui-hide');
            $('.mp-fix').addClass('mp-fix-active');
          }
        }
        $btnAdd.hide();
        if (isSelf) {
          $btnEdit.show();
        }
        $detailDiv.show();
        $topDiv.hide();
        $contentDiv.hide();
        $btnBack.off().click(function () {
          ListShow();
        })
      }

      var EditShow = function () {
        if (window.PlatformID == 4) {
          $('.header-nav').removeClass('ui-hide');
          $('.mp-fix').removeClass('mp-fix-active');
        }
        photoboxEdit.editable();
        $DailyInfo.hide();
        $detailContent.removeAttr('readonly');
        $btnEditCommit.show();
        // $placeSpace.show();
        $btnEdit.hide();
        $btnCancel.show();
        buttonPositionEdit();
        $btnBack.off().click(function () {
          CancleEdit();
          DetailRender();
        })
      }

      var AddShow = function () {
        if (window.PlatformID == 4) {
          $('.header-nav').addClass('ui-hide');
          $('.mp-fix').addClass('mp-fix-active');
        }
        $btnAdd.hide();
        $topDiv.hide();
        $contentDiv.hide();
        $addDiv.show();
        buttonPositionAdd();
        $btnBack.off().click(function () {
          ListShow();
        })
      }

      var CancleEdit = function () {
        photoboxEdit.readonly();
        $DailyInfo.show();
        $detailContent.attr('readonly', 'readonly');
        $btnEditCommit.hide();
        // $placeSpace.hide();
        if (isSelf) {
          $btnEdit.show();
        }
        $btnCancel.hide();
        $btnBack.off().click(function () {
          ListShow();
        })
      }

      // 图片上传
      var ImgUploadEdit = function () {
        var imgPathString = photoboxEdit.getData();
        if (imgPathString == '[]' && !$detailContent.val().trim()) {
          Msg.Error.Show("请填写日报内容或上传图片");
          return;
        }

        var nativeImgArr = [];
        var urlImgArr = [];

        $(photoboxEdit.elid + ' .scene-img-item').each(function () {
          var path;
          if (!$(this).attr("src") || $(this).attr("src") == "Img/ico_addPhoto@2x.png") {
            path = ""
          } else {
            path = $(this).attr("src");
          }

          var imgData = $(this).data('imgdata');
          if (imgData) {
            urlImgArr.push(imgData);
          } else {
            nativeImgArr.push(path);
          }
        })

        var imgPathString = JSON.stringify(nativeImgArr);
        if (imgPathString == '[]') {
          EditCommit(urlImgArr);
        } else {
          if (inteFlag) {
            inteFlag = false;
            nativeFileUploadResultInstance.setFun(function (file) {
              if (file) {
                EditCommit(file.FileList.concat(urlImgArr));
              } else {
                inteFlag = true;
              }

            });
            nativeFileUpload(imgPathString);
          }
        }
      }

      var ImgUploadAdd = function () {

        var imgPathString = photoboxAdd.getData();
        if (imgPathString == '[]' && !$addContent.val().trim()) {
          Msg.Error.Show("请填写日报内容或上传图片");
          return;
        }

        if (imgPathString == '[]') {
          AddCommit([]);
        } else {
          if (inteFlag) {
            inteFlag = false;
            nativeFileUpload(imgPathString);
            nativeFileUploadResultInstance.setFun(function (file) {
              if (file) {
                AddCommit(file.FileList);
              } else {
                inteFlag = true;
              }
            });
          }
        }

      }


      function reload() {
        var v = request('v');
        var href = window.location.href.replace(v, Math.random());
        window.location.replace(href);
      }

      var EditCommit = function (fileList) {
        var param = {
          ContentToday: $detailContent.val().trim(),
          ContentTomorrow: '',
          ReportPlaceName: gps.address,
          ReportLongitude: gps.lon,
          ReportLatitude: gps.lat,
          AnnexList: JSON.stringify(fileList),
          WorkingReportID: $btnEditCommit.data('dailyid'),
          OperateType: 'UPDATE',
        }

        inte.WorkingReport(param, function (JsonObj) {
          if (JsonObj.Code == 1) {
            Msg.OK.Show(JsonObj.Message, 2, function () {
              if (Browser.Versions.IsMiniProgram) {
                reload();
              } else {
                window.location.replace(window.location.href);
              }
            })
          } else {
            Msg.Error.Show(JsonObj.Message, 2, function () {
              inteFlag = true;
            });
          }
        })

      }

      var AddCommit = function (fileList) {
        var param = {
          ContentToday: $addContent.val().trim(),
          ContentTomorrow: '',
          ReportPlaceName: gps.address,
          ReportLongitude: gps.lon,
          ReportLatitude: gps.lat,
          AnnexList: JSON.stringify(fileList),
          WorkingReportID: 0,
          OperateType: 'ADD',
        }

        inte.WorkingReport(param, function (JsonObj) {
          if (JsonObj.Code == 1) {
            Msg.OK.Show(JsonObj.Message, 2, function () {
              if (Browser.Versions.IsMiniProgram) {
                reload();
              } else {
                window.location.replace(window.location.href);
              }
            })
          } else {
            Msg.Error.Show(JsonObj.Message, 2, function () {
              inteFlag = true;
            });
          }
        })
      }

      var initClick = function () {

        $btnAdd.off().tap(ToClick, function () {
          // 写日报
          AddShow();
        })

        $btnEdit.off().tap(ToClick, function () {
          // 编辑
          EditShow();
        })

        $btnEditCommit.off().tap(ToClick, function () {
          // 提交编辑
          ImgUploadEdit();
        })

        $btnCancel.off().tap(ToClick, function () {
          // 取消编辑
          CancleEdit();
          DetailRender();
        })

        $btnAddCommit.off().tap(ToClick, function () {
          // 提交新增
          ImgUploadAdd();
        })

      };

      var buttonPositionAdd = function () {
        var $item = $btnAddCommit.prev();
        var btnTop = $btnAddCommit.offset().top;
        var btnOrginTop = $item.offset().top + $item.outerHeight();
        var margintop = btnTop - btnOrginTop;
        if (margintop < 15) {
          margintop = 15;
        }
        $btnAddCommit.css({
          'margin-top': margintop + 'px',
          'margin-bottom': '0.15rem',
          'position': 'static'
        })
      };

      var buttonPositionEdit = function () {
        var $item = $btnEditCommit.prev();
        var btnTop = $btnEditCommit.offset().top;
        var btnOrginTop = $item.offset().top + $item.outerHeight();
        var margintop = btnTop - btnOrginTop;
        if (margintop < 15) {
          margintop = 15;
        }
        $btnEditCommit.css({
          'margin-top': margintop + 'px',
          'margin-bottom': '0.15rem',
          'position': 'static'
        })
      };

      if (isFirst) {
        ListShow();
        // DetailShow();

        mySchedule = new Schedule({
          el: '#schedule-box',
          //date: '2018-9-20',
          clickCb: function (y, m, d, w, el) {
            // 日历单格点击事件
            var WorkingReportList = $(el).data('WorkingReportList');
            ListRender(WorkingReportList);
          },

        });

        // 日历特效
        scheduleAnimate();

        var calendar = new lCalendar();
        calendar.init({
          'trigger': '#btnDate',
          'type': 'ym',
          'txtShow': '#txtDate',
          'txtType': 'html'
        }, function (data) {
          // 日期选择事件
          data = TimeToStr(new Date(data), 'yyyy-MM-dd')
          mySchedule.setDate(data.substr(0, 4), (parseInt(data.substr(5, 2)) - 1));
          updateSchedule();
          $('#txtDate').data('date', data);
          $('.dateDay').empty();
          $('.weekDay').empty();
          $messages.empty();
          $messages.append('<div class="no-message">当天没有执勤记录</div>');
          WorkingMonthRecordList();
          calendar.setDate(data);
        });

        photoboxEdit = new PhotoBox({
          beforeEl: $detailContent
        })
        photoboxAdd = new PhotoBox({
          beforeEl: $addContent
        })

        WorkingMonthRecordList();
        initClick();
        OverScroll($ScrollInit.get(0));
        OverScroll($detailDiv.get(0));
        OverScroll($addDiv.get(0));
      } else {

      }


    }
  }
})
