app = $.extend(true, app, {
  "Work_Schedule_List.html": {
    Init: function (isFirst, Param) {
      var $calendarDate = $('.calendar-date');
      var $listBox = $('.list-box');
      var $ScrollInit = $("#ScrollInit");

      var beginIndex = 0;
      var dataCount = 20;
      var canLoadMore = true;

      var initClick = function () {
        $('.header-text-right').tap(ToClick,function(){
          winOpen('Work_Schedule_Post.html');
        })

        $('#btnBack').tap(ToClick,function(){
          backAppPage();
        })

        $('#staff').tap(ToClick,function(){
          winOpen('Work_Schedule_Staff.html');
        })
      };

      //设置滚动区域
      var setScroll = function () {
        
        var ScrollInitID = $ScrollInit.attr("id");
        var ArtHeight = $("article").height();
        var Delheight = 0;
        var DivArray = $ScrollInit.parent().children();
        for (var i = 0; i < DivArray.length; i++) {
            if (DivArray.eq(i).attr("id") != ScrollInitID) {
                Delheight += DivArray.eq(i).height();
            }
        }
        
        $ScrollInit.css({//列表容器高度
            "height": (ArtHeight - Delheight) / window.GlobalBasisSize + "rem",
            "overflow-x": "auto"
        });
        OverScroll($ScrollInit.get(0));

        $ScrollInit.scroll(function () {
          if ($ScrollInit.scrollTop() + window.innerHeight - Delheight >= 50 && canLoadMore) {
              canLoadMore = false;
              DutyAssignList();
          }
        });
      };

      function DutyAssignList(){
        inte.DutyAssignList({
          DutyDate:$calendarDate.data('date') || TimeToStr(new Date(), 'yyyy-MM-dd'),
          BeginIndex:beginIndex,
          DataCount:dataCount
        },function(JsonObj){
          canLoadMore = true;
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {
            
            $ScrollInit.find('.no-messages').remove();
            var $list = $listBox;
            if (beginIndex == 0) {
              $list.empty();
            }
            
            var html = "";

            if (JsonObj.DutyList.length <= 0) {
              if (beginIndex == 0) {
                  html = '<div class="no-messages ui-bgc-f5">沒有信息</div>';
                  $ScrollInit.append(html);
              } else {
                  html = '<div class="no-messages list-no-messages">暂无更多信息</div>';
                  $list.append(html);
              }
              canLoadMore = false;
            }

            beginIndex += JsonObj.DutyList.length;

            for (var key in JsonObj.DutyList) {
              var row = JsonObj.DutyList[key];

              html = '';
              html += '<div class="ui-border-b-slim schedule-item" data-sentryid='+ row.SentryID +' data-dutyid='+ row.DutyID +' data-sentryrouteid='+ row.SentryRouteID +'>'
              html += '  <div class="">'+ row.SentryTypeName +'</div>'
              html += '  <div class="ui-nowrap">'+ row.DutyAssignName +'</div>'
              html += '  <div class="">执勤人</div>'
              html += '  <div class="ui-nowrap">'+ row.ExecutorInfo +'</div>'
              html += '</div>'

              var $html = $(html);
              $html.tap(ToClick,function(){
                winOpen('Work_Schedule_Detail.html?SentryID='
                        +$(this).data('sentryid')
                        +'&DutyID='+$(this).data('dutyid')
                        +'&SentryRouteID='+$(this).data('sentryrouteid')
                        +'&DutyDate='+$calendarDate.text())
              })

              $list.append($html);
            }
          }else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      if (isFirst) {
        $calendarDate.text(TimeToStr(new Date(), 'yyyy-MM-dd'));
        
        var calendar = new lCalendar();
        calendar.init({
            'trigger': '.calendar-div',
            'type': 'date',
            'txtShow': '.calendar-date',
            'txtType': 'html'
        }, function (data) {
            // 日期选择事件
            calendar.setDate(data);
            $calendarDate.data('date',data);
            beginIndex = 0;
            DutyAssignList();
        });

        initClick();
        setScroll();
        DutyAssignList();
      }
    }
  },

  "Work_Schedule_Detail.html": {
    Init: function (isFirst, Param) {
      var $alarmTime = $(".alarm-time");
      var $sentryType = $(".sentry-type");
      var $sentryName = $(".sentry-name");
      var $executorNumType = $(".executor-num-type");
      var $dutyTime = $(".duty-time");
      var $executor = $(".executor");
      var $teamInner = $(".team-inner");
      var $headerRight = $(".header-text-right");
      var $btnBack = $("#btnBack");
      var $wsDetail = $("#ws-detail");
      var $ScrollInit = $("#ScrollInit");
      var $teamList = $(".teamlist");

      var sentryID = request('SentryID');
      var sentryRouteID = request('SentryRouteID');
      var dutyID = request('DutyID');
      var dutyDate = request('DutyDate');

      var executorData;
      var executorList = [];

      var initClick = function () {
        $btnBack.click(function(){
          winBack();
        })

        $headerRight.tap(ToClick,function(){
          executorList = [];
          var executorName = '';
          $teamInner.find('li.team-choose').each(function(){
            executorList.push($(this).data('uid'));
            executorName += ($(this).find('.team-name').eq(0).text()+',');
          })
          executorName = executorName.trimEnd(',');
          $executor.text(executorName);
          $ScrollInit.hide();
          $(this).hide();
          $wsDetail.show();
        })

        $('#staff').tap(ToClick,function(){
          showExecutor();
        })

        $('.btn-save').tap(ToClick,function(){
          inte.DutyAssignExecutor({
            SentryID:sentryID,
            DutyID:dutyID,
            SentryRouteID:sentryRouteID,
            DutyDate:dutyDate,
            AlarmDate:$alarmTime.data('date') || '',
            ExecutorUIdentifyIDs:executorList.join(',')  //执行者用户识别码ID 多个执行者用,隔开 如  ID1,ID2,ID3
          },function(JsonObj) {
            if (JsonObj.Code == 1){
              Msg.OK.Show(JsonObj.Message,2,function(){
                nativeBack();
                nativeSetAlarm($alarmTime.data('date'));
              });
            }else{
              Msg.Error.Show(JsonObj.Message);
            }
          })
        })
      };

      //设置滚动区域
      var setScroll = function () {
        
        var ScrollInitID = $ScrollInit.attr("id");
        var ArtHeight = $("article").height();
        var Delheight = 0;
        var DivArray = $ScrollInit.parent().children();
        for (var i = 0; i < DivArray.length; i++) {
            if (DivArray.eq(i).attr("id") != ScrollInitID) {
                Delheight += DivArray.eq(i).height();
            }
        }
        
        $ScrollInit.css({//列表容器高度
            "height": (ArtHeight - Delheight) / window.GlobalBasisSize + "rem",
            "overflow-x": "auto"
        });
        OverScroll($ScrollInit.get(0));

      };

      function DutyAssignDetails(){
        inte.DutyAssignDetails({
          DutyID:dutyID,
          SentryID:sentryID,
          SentryRouteID:sentryRouteID,
          DutyDate:dutyDate
        },function(JsonObj){
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            $sentryType.text(JsonObj.DutyInfo.SentryTypeName || '-');
            $sentryName.text(JsonObj.DutyInfo.DutyAssignName || '-');
            switch (JsonObj.DutyInfo.ExecutorNumType) {
              case 'ONE':
                $executorNumType.text('单岗');
                break
              case 'TWO':
                $executorNumType.text('双岗');
                break
              case 'MORE':
                $executorNumType.text('多岗');
                break
              default:
                $executorNumType.text('-');
                break
            }
            $dutyTime.text(JsonObj.DutyInfo.DutyBeginTime + '-' + JsonObj.DutyInfo.DutyEndTime);
            if(!JsonObj.DutyInfo.AlarmTime){
              $alarmTime.text('请选择时间');
              $alarmTime.addClass('ui-color-a8');
            }else{
              $alarmTime.text(JsonObj.DutyInfo.AlarmTime);
            }
            $alarmTime.data('date',JsonObj.DutyInfo.AlarmTime);
            executorData = JsonObj.ExecutorList;
            var executor = '';
            for(var key in JsonObj.ExecutorList){
              if(JsonObj.ExecutorList[key].ChooseStatus == 'S0A'){
                executor += (JsonObj.ExecutorList[key].UserName + ',')
                executorList.push(JsonObj.ExecutorList[key].UIdentifyID)
              }
            }
            executor = executor.trimEnd(',');
            $executor.text(executor);
            
            executorRender();
          }else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      function executorRender(){
        var $list = $teamList;
        $list.empty();
        for(var key in executorData){
          var row = executorData[key];
          html = '';
          html += '<li class="team-item ui-border-b-slim '+ (row.ChooseStatus=='S0A'?'team-choose':'') +'" data-uid="'+ row.UIdentifyID +'">'
          html += '  <div class="team-item-box">'
          html += '    <span class="team-name">'+ row.UserName +'</span>'
          html += '    <span class="team-name">('+ row.RoleSpecName +')</span>'
          if(row.EventType == 'LEAVE'){
            html += '    <div class="state-div leave-div"></div>'
          }else if(row.EventType == 'ABSENCE'){
            html += '    <div class="state-div absent-div"></div>'
          }else if(row.EventType == 'DEPARTURE'){
            html += '    <div class="state-div departure-div"></div>'
          }else if(row.EventType == 'LATE'){
            html += '    <div class="state-div late-div"></div>'
          }else if(row.EventType == 'EARLY'){
            html += '    <div class="state-div early-div"></div>'
          }else if(row.EventType == 'NORMAL'){
            html += '    <div class="state-div normal-div"></div>'
          }
          html += '  </div>'
          html += '  <div class="team-choose-icon">'
          html += '    <img src="Img/ico_choose@3x.png" alt="">'
          html += '  </div>'
          html += '</li>'

          $html = $(html);
          $html.tap(ToClick, function (e) {
            $(this).toggleClass('team-choose');
          })

          $list.append($html);
        }
      }

      function showExecutor(){

        $wsDetail.hide();
        $ScrollInit.show();
        $headerRight.show();

        $btnBack.unbind();
        $btnBack.click(function(){
          $wsDetail.show();
          $ScrollInit.hide();
          $headerRight.hide();
          $btnBack.unbind();
          $btnBack.click(function(){
            winBack();
          })

        })
      }

      if (isFirst) {

        var calendar = new lCalendar();
        calendar.init({
            'trigger': '.alarm',
            'type': 'hm',
            'txtShow': '.alarm-time',
            'txtType': 'html'
        }, function (data) {
            // 日期选择事件
            calendar.setDate(data);
            $alarmTime.data('date',data);
            $alarmTime.removeClass('ui-color-a8');
        });

        initClick();
        setScroll();
        $wsDetail.show();
        DutyAssignDetails();
      }
    }
  },

  "Work_Schedule_Post.html": {
    Init: function (isFirst, Param) {
      var $sentryName = $("#sentryName");
      var $sentryType = $("#sentryType");
      var $dutyList = $("#dutyList");
      var $btnSave = $(".btn-save");
      var $sentryList = $(".sentryList");
      var $sentrySet = $(".sentrySet");
      var $btnBack = $('#btnBack');
      var $ScrollInit = $("#ScrollInit");
      var beginIndex = 0;
      var dataCount = 20;
      var sentryID;

      var initClick = function () {
        $btnBack.click(function(){
          winBack();
        })

        $('.work-part').tap(ToClick,function(){
          $(this).parent().toggleClass('tab-choose');
        })

        $btnSave.tap(ToClick,function(){ 
          var dutyList = [];

          $(".tab-choose").each(function(){
            var duty = {};
            duty['DutyName'] = $(this).data('name');
            duty['DutyShiftType'] = $(this).data('type');
            var calendarStartID = duty['DutyShiftType'] + 'start'
            var calendarEndID = duty['DutyShiftType'] + 'end'
            duty['DutyBeginTime'] = $('#'+calendarStartID).data('time');
            duty['DutyEndTime'] = $('#'+calendarEndID).data('time');
            if(duty['DutyBeginTime'] && duty['DutyEndTime']){
              dutyList.push(duty);
            }
          });

          //修改接口
          inte.DutySentrySetting({
            SentryID:sentryID,
            DutyList:JSON.stringify(dutyList)
          },function (JsonObj) {
            if (JsonObj.Code == 1) {
              Msg.OK.Show(JsonObj.Message,2,function(){
                nativeBack();
              });
            }else{
              Msg.Error.Show(JsonObj.Message);
            }
          })
        })
        
      }

      //设置滚动区域
      var setScroll = function () {
        
        var ScrollInitID = $ScrollInit.attr("id");
        var ArtHeight = $("article").height();
        var Delheight = 0;
        var DivArray = $ScrollInit.parent().children();
        for (var i = 0; i < DivArray.length; i++) {
            if (DivArray.eq(i).attr("id") != ScrollInitID) {
                Delheight += DivArray.eq(i).height();
            }
        }
        
        $ScrollInit.css({//列表容器高度
            "height": (ArtHeight - Delheight) / window.GlobalBasisSize + "rem",
            "overflow-x": "auto"
        });
        OverScroll($ScrollInit.get(0));

      };

      function DutySentryList(){
        inte.DutySentryList({
          BeginIndex:beginIndex,
          DataCount:dataCount
        },function(JsonObj){
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

            var $list = $sentryList;
            $list.empty();
            var html = "";

            if(JsonObj.SentryList.length==1){
              //只有一个岗位时 默认跳转到该岗位设置
              sentryID = JsonObj.SentryList[0].SentryID;
              $ScrollInit.hide();
              $sentrySet.show();
              DutySentryDetails();
            }else{
              //否则显示岗位列表
              for (var key in JsonObj.SentryList) {
                var row = JsonObj.SentryList[key];

                html = '';
                html += '<div data-sentryid='+ row.SentryID +' class="flex-between ui-height-50 ui-border-b-slim">'
                html += '  <div>'+ row.SentryName +'</div>'
                html += '  <div>'+ row.SentryTypeName +'</div>'
                html += '</div>'
  
                var $html = $(html);
                $html.tap(ToClick,function(){
                  sentryID = $(this).data('sentryid');
                  $ScrollInit.hide();
                  $sentrySet.show();
                  DutySentryDetails();

                  $btnBack.unbind();
                  $btnBack.click(function(){
                    $ScrollInit.show();
                    $sentrySet.hide();
                    
                    $btnBack.unbind();
                    $btnBack.click(function(){
                      winBack();
                    })
                  })
                })
  
                $list.append($html);
            }  
            if(JsonObj.SentryList.length < 1){
              html = '';
              html += '<div class="no-messages ui-bgc-f5">没有信息</div>';
              $ScrollInit.append(html);
            }
          }
        }else {
          Msg.Error.Show(JsonObj.Message);
        }
        })
      }

      function DutySentryDetails(){
        inte.DutySentryDetails({
          SentryID:sentryID,
        },function (JsonObj) {
          if (JsonObj.Code == 1 || JsonObj.Code == -301) {

              $sentryName.text(JsonObj.SentryInfo.SentryName || '-');
              $sentryType.text(JsonObj.SentryInfo.SentryTypeName || '-');

              var $list = $dutyList;
              $list.empty();
              var html = "";

              for (var key in JsonObj.DutyList) {
                var row = JsonObj.DutyList[key];

                html = '';
                html += '<div data-type="'+ row.DutyShiftType +'" data-name="'+ row.DutyName +'" class="ui-flex ui-flex-align-center '+ (row.ChooseStatus == 'S0A'?'tab-choose':'') +'">'
                html += '  <div class="ui-flex-align-center work-part">'
                html += '    <div class="tab-item-day"></div>'
                html += '    <div class="tab-item-unit">'+ row.DutyName +'</div>'
                html += '  </div>'
                html += '  <div class="ui-flex ui-flex-align-center time-pick-box">'
                var calendarStartID = row.DutyShiftType + 'start'
                html += '    <div class="hour-num" id="'+ calendarStartID +'" data-time="'+ (row.DutyBeginTime || '') +'">'+ (row.DutyBeginTime || '') +'</div>'
                html += '    <span>-</span>'
                var calendarEndID = row.DutyShiftType + 'end'
                html += '    <div class="hour-num margin-0" id="'+ calendarEndID +'" data-time="'+ (row.DutyEndTime || '') +'">'+ (row.DutyEndTime || '') +'</div>'
                html += '  </div>'
                html += '</div>'

                var $html = $(html);
                $html.find('.work-part').tap(ToClick, function (e) {
                  $(this).parent().toggleClass('tab-choose');
                });

                $list.append($html);

                var calendarStart = new lCalendar();
                calendarStart.init({
                    'trigger': '#'+calendarStartID,
                    'type': 'hm',
                    'txtShow': '#'+calendarStartID,
                    'txtType': 'html'
                }, function (data) {
                  // calendarStart.setDate(data);
                  $(this.trigger).data('time', data);
                });

                var calendarEnd = new lCalendar();
                calendarEnd.init({
                    'trigger': '#'+calendarEndID,
                    'type': 'hm',
                    'txtShow': '#'+calendarEndID,
                    'txtType': 'html'
                }, function (data) {
                  // calendarEnd.setDate(data);
                  $(this.trigger).data('time', data);
                });
              }
          }else {
            Msg.Error.Show(JsonObj.Message);
          }
        })
      }

      if (isFirst) {
        initClick();
        setScroll();
        DutySentryList();
      }
    }
  }

});