app = $.extend(true, app, {
    "Work_Schedule_Calendar.html": {
        Init: function (isFirst, Param) {

            var $ScrollInit = $("#ScrollInit");
            var $messages = $('.messages');
            var $ondutyDetail = $('#ondutyDetail');
            var $topDiv = $('#topDiv');
            var $divH = $('#divH');
            var $schedulebox = $('#schedule-box');
            var $btnBack = $('#btnBack');
            var mySchedule;

            var initClick = function () {

                $btnBack.click(function () {
                    backAppPage();
                });
            };

            var DutyRecordMonthList = function () {

                $('.calendar-content').remove();
                // $('#schedule-box .point').remove();
                // $('#schedule-box .temp').remove();

                var monthDate = $('#txtDate').data('date') || TimeToStr(new Date(), 'yyyy-MM-dd');
                inte.SentryDutyMonthList({
                    MonthDate: monthDate
                }, function (JsonObj) {
                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {
                        for (var key in JsonObj.DayList) {
                            var row = JsonObj.DayList[key];
                            var $list = $(".currentDate[title='" + row.DayDate + "']");
                            var html = '';
                            html += '<div class="calendar-content">'
                            if (row.SentryNum > 0) {
                                html += '  <div class="point"></div>';
                            }
                            if (row.TempNum > 0) {
                                html += '  <div class="temp">临时</div>';
                            }
                            html += '</div>'

                            var $html = $(html);
                            $list.data("SentryList", row.SentryList);
                            $list.append($html);
                        }
                        if ($('.today-flag').length > 0) {
                            $('.today-flag').click();
                        } else {
                            $('.currentDate').eq(0).click();
                        }
                        updateSchedule();
                    } else if (JsonObj.Code == -101) {
                        // 账号多地登录
                        exitApp(JsonObj.Message)
                    } else {
                        Msg.Error.Show(JsonObj.Message)
                    }
                })
            };

            //设置滚动区域
            var setScroll = function () {
                var pd2 = $topDiv.height();
                var pd = $divH.height();
                var ScrollInitID = $ScrollInit.attr("id");
                var ArtHeight = window.innerHeight;
                var movebox2 = document.querySelector("#messagesDiv"); //内容
                var Delheight = $topDiv.height() + $schedulebox.height();
                var endY = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0;

                //设置日历和内容区域的上边距=顶部高度
                $("#contentDiv").css({
                    "padding-top": pd2 + "px"
                });

                var DivArray = $ScrollInit.parent().children();
                for (var i = 0; i < DivArray.length; i++) {
                    if (DivArray.eq(i).attr("id") != ScrollInitID) {
                        Delheight += DivArray.eq(i).height();
                    }
                }
                $ScrollInit.css({ //列表容器高度
                    "height": (ArtHeight - Delheight - endY) + "px",
                    "padding-top": pd + "px",
                    "overflow-x": "auto"
                });
                $ScrollInit.addClass("ui-ios");
            };

            var updateScroll = function (moveDir) {
                //更新滚动区域的高度
                var ScrollInitID = $ScrollInit.attr("id");
                var ArtHeight = window.innerHeight;
                var movebox2 = document.querySelector("#messagesDiv"); //内容
                var Delheight = $topDiv.height() + $schedulebox.height();
                var endY = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0;

                var DivArray = $ScrollInit.parent().children();
                for (var i = 0; i < DivArray.length; i++) {
                    if (DivArray.eq(i).attr("id") != ScrollInitID) {
                        Delheight += DivArray.eq(i).height();
                    }
                }
                $ScrollInit.css({ //列表容器高度
                    "height": (ArtHeight - Delheight - endY) + "px"
                });

                if (moveDir) {
                    $ScrollInit.css({ //列表容器高度
                        "overflow-y": "scroll"
                    });
                } else {
                    $ScrollInit.css({ //列表容器高度
                        "overflow-y": "hidden"
                    });
                }
            };

            //更新日历translateY值
            var updateSchedule = function () {
                var movebox1 = document.querySelector("#schedule-box"); //日历框
                var movebox2 = document.querySelector("#messagesDiv"); //内容
                var liH = parseInt($('ul.schedule-bd li').eq(1).css('height').replace('px', '')); //一个单元的高度(加上下边框的高度)
                var rows = parseInt($('ul.schedule-bd li').length / 9) - 1; //总共有多少行日历
                var endY2 = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值
                var choose;

                if (!endY2) {
                    updateScroll(false);
                } else {
                    updateScroll(true);

                    if ($(".schedule-bd .selected-style").index() !== -1) {
                        choose = Math.floor($(".schedule-bd .selected-style").index() / 9);
                    } else {
                        choose = Math.floor($(".schedule-bd .today-flag").index() / 9);
                    }

                    if (choose < 0) {
                        choose = 0;
                    }
                    movebox1.style.webkitTransform = "translateY(" + (-choose * liH) + "px)";
                    movebox2.style.webkitTransform = "translateY(" + (-liH * rows) + "px)";
                }
            };

            var scheduleAnimate = function () {
                var moveY, //手指滑动距离
                    endY1, //手指停止滑动时Y轴坐标
                    endY2, //手指停止滑动时Y轴坐标
                    startY, //获取触摸坐标
                    moveDir, //滑动方向
                    choose; //滑动方向
                var nflag = false; // 下框是否拉到顶部
                var moveFlag = 0; //是否有touchmove
                var movebox1 = document.querySelector("#schedule-box"); //日历框
                var movebox2 = document.querySelector("#messagesDiv"); //内容
                var movebox3 = document.querySelector("#ScrollInit"); //滚动内容
                var liH = parseInt($('ul.schedule-bd li').eq(1).css('height').replace('px', '')); //一个单元的高度(加上下边框的高度)
                var maxMove1 = 0;
                var maxMove2 = 0;
                var scale = 1;
                var rows = parseInt($('ul.schedule-bd li').length / 9) - 1; //总共有多少行日历


                //触摸开始
                function boxTouchStart(e) {
                    var touch = e.touches[0]; //获取触摸对象
                    moveFlag = 1;
                    rows = parseInt($('ul.schedule-bd li').length / 9) - 1;
                    startY = touch.pageY; //获取触摸坐标
                    endY1 = parseInt(movebox1.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值
                    endY2 = parseInt(movebox2.style.webkitTransform.replace("translateY(", "").replace("px)", "")) || 0; //获取每次触摸时滑动对象Y轴的偏移值

                    //translateY效果用时，为0时是随手指的移动移动
                    movebox1.style.transitionDuration = "0s";
                    movebox2.style.transitionDuration = "0s";

                    if ($(".schedule-bd .selected-style").index() !== -1) {
                        choose = Math.floor($(".schedule-bd .selected-style").index() / 9);
                    } else {
                        choose = Math.floor($(".schedule-bd .today-flag").index() / 9);
                    }

                    if (choose < 0) {
                        choose = 0;
                    }

                    //向上移动最终位置
                    maxMove1 = choose * liH;
                    maxMove2 = rows * liH;

                    scale = maxMove1 / maxMove2;

                    if ($ScrollInit.scrollTop() <= 0) {
                        nflag = true;
                    } else {
                        nflag = false;
                    }
                }


                function boxTouchMove(e) {
                    e.preventDefault();
                    var touch = e.touches[0];
                    var tempY1;
                    var tempY2;

                    moveFlag = 2;
                    if (!nflag) {
                        //滑动日历，如果滚动内容不是在顶部，设置到顶部
                        $ScrollInit.animate({
                            scrollTop: 0
                        }, 500);
                        nflag = true;
                    }

                    moveY = touch.pageY - startY; //手指水平方向移动的距离
                    moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

                    if (moveDir && endY2 == -maxMove2) {
                        //向上，并且初始位置就是最终位置，说明原来位置就是在0
                        return;
                    } else if (!moveDir && endY2 == 0) {
                        return;
                    }

                    tempY1 = endY1 + moveY * scale;
                    tempY2 = endY2 + moveY;

                    if (moveDir) {
                        if (tempY1 >= -maxMove1) {
                            movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)"; //手指滑动时滑动对象随之滑动
                        }

                        if (tempY2 >= -maxMove2) {
                            movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)"; //手指滑动时滑动对象随之滑动
                        }
                    } else {
                        if (tempY1 <= 0) {
                            movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox1.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
                        }

                        if (tempY2 <= 0) {
                            movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox2.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
                        }
                    }

                    updateScroll(false);

                }

                function boxTouchEnd(e) {
                    if (moveFlag != 2) {
                        moveFlag = 0;
                        return;
                    }
                    e.preventDefault(); //让点击效果失效

                    moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

                    //translateY效果用时
                    movebox1.style.transitionDuration = "0.2s";
                    movebox2.style.transitionDuration = "0.2s";

                    if (moveDir) {
                        movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)";
                        movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)";
                    } else {
                        movebox1.style.webkitTransform = "translateY(" + (0) + "px)";
                        movebox2.style.webkitTransform = "translateY(" + (0) + "px)";
                    }

                    updateScroll(moveDir);
                }

                function boxTouchMove2(e) {
                    var touch = e.touches[0];
                    var tempY1;
                    var tempY2;

                    moveFlag = 2;

                    moveY = touch.pageY - startY; //手指水平方向移动的距离
                    moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

                    if (!nflag) {
                        return;
                    }

                    if(window.PlatformID !== 0){
                        e.preventDefault();
                    }
                    
                    if(endY1 < 0 && nflag && moveDir){
                        e.returnValue = true;
                    }

                    if (moveDir && endY2 == -maxMove2) {
                        //向上，并且初始位置就是最终位置，说明原来位置就是在0
                        return;
                    } else if (!moveDir && endY2 == 0) {
                        return;
                    }

                    tempY1 = endY1 + moveY * scale;
                    tempY2 = endY2 + moveY;

                    if (moveDir) {
                        if (tempY1 >= -maxMove1) {
                            movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)"; //手指滑动时滑动对象随之滑动
                        }

                        if (tempY2 >= -maxMove2) {
                            movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)"; //手指滑动时滑动对象随之滑动
                        }
                    } else {
                        if (tempY1 <= 0) {
                            movebox1.style.webkitTransform = "translateY(" + (tempY1) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox1.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
                        }

                        if (tempY2 <= 0) {
                            movebox2.style.webkitTransform = "translateY(" + (tempY2) + "px)"; //手指滑动时滑动对象随之滑动
                        } else {
                            movebox2.style.webkitTransform = "translateY(" + (0) + "px)"; //手指滑动时滑动对象随之滑动
                        }
                    }

                    updateScroll(false);
                }

                function boxTouchEnd2(e) {
                    if (!nflag || moveFlag != 2) {
                        moveFlag = 0;
                        return;
                    }
                    moveFlag = 0;
                    e.preventDefault(); //让点击效果失效
                    moveDir = moveY < 0 ? true : false; //滑动方向小于0表示向上滑动，大于0表示向下滑动

                    movebox1.style.transitionDuration = "0.2s";
                    movebox2.style.transitionDuration = "0.2s";
                    if (moveDir) {
                        movebox1.style.webkitTransform = "translateY(" + (-maxMove1) + "px)";
                        movebox2.style.webkitTransform = "translateY(" + (-maxMove2) + "px)";
                    } else {
                        movebox1.style.webkitTransform = "translateY(" + (0) + "px)";
                        movebox2.style.webkitTransform = "translateY(" + (0) + "px)";
                    }

                    updateScroll(moveDir);
                }

                //滑动对象事件绑定
                movebox1.addEventListener("touchstart", boxTouchStart, false);
                movebox1.addEventListener("touchmove", boxTouchMove, false);
                movebox1.addEventListener("touchend", boxTouchEnd, false);

                movebox3.addEventListener("touchstart", boxTouchStart, false);
                movebox3.addEventListener("touchmove", boxTouchMove2, false);
                movebox3.addEventListener("touchend", boxTouchEnd2, false);

                setScroll();
                updateScroll(false);
            };

            var DutyListRender = function (sentryList) {
                var $dutyContainer = $messages;
                $dutyContainer.children().remove();
                for (var key in sentryList) {
                    var row = sentryList[key];
                    var $list = $dutyContainer;
                    var html = '';
                    html += '<div class="ui-padding-lr-15 msgs-item">';
                    html += '    <div class="ui-border-b-slim flex-between ui-height-50">';
                    html += '        <div class="ui-nowrap ui-color-26 ui-fontsize-17" style="max-width: 2.67rem;">' + row.SentryName + '</div>';
                    html += '        <div class="ui-color-61 ui-fontsize-16">' + row.SentryTypeName + '</div>';
                    html += '    </div>';
                    for(var kk in row.DutyList){
                        var dutyRow = row.DutyList[kk];
                        html += '<div class="ui-border-b-slim ui-fontsize-16" style="padding: .19rem 0;">';
                        html += '    <div class="ui-row-flex ui-margin-b-17" style="line-height:1;">';
                        html += '      <div class="ui-color-26 left-width">' + dutyRow.DutyName + '</div>';
                        html += '      <div class="ui-color-61">' + (dutyRow.DutyBeginTime + '~' + dutyRow.DutyEndTime) + '</div>';
                        html += '    </div>';
                        html += '    <div class="ui-row-flex">';
                        html += '      <div class="ui-color-26 left-width">执勤人员</div>';
                        html += '      <div class="ui-color-61 duty-staff">';
                        for(var k in dutyRow.RegularExecutorList){
                            var staffRow = dutyRow.RegularExecutorList[k];
                            html += '      <div class="flex-center">'+ staffRow.UserName +'</div>';
                        }
                        for(var k in dutyRow.TempExecutorList){
                            var tempRow = dutyRow.TempExecutorList[k];
                            html += '      <div class="flex-center">'+ tempRow.UserName + '<div class="img-temporaries"></div>' +'</div>';
                        }
                        html += '      </div>';
                        html += '    </div>';
                        html += '</div>';
                    }
                    html += '</div>';
                    // if(key != sentryList.length-1){
                        html += '<div class="bottom-line"></div>';
                    // }

                    var $html = $(html);
                    $html.data("sentryid", row.SentryID);
                    $html.tap(ToClick, function () {
                    // $html.click(function () {
                        var dutyDate = $(".dateDay").data('date') || new Date();
                        $('article').css('height', 0);
                        $('#selecMonthContainer').hide();
                        $('#week').hide();
                        $ondutyDetail.show();
                        $btnBack.off();
                        app.Init("Work_Schedule_Calendar_Detail.html", false, {
                            from : "calendar",
                            sentryid: $(this).data("sentryid"),
                            dutyWeek: $('.weekDay').text(),
                            dutyDate: TimeToStr(dutyDate, 'yyyy-MM-dd')
                        });
                    });

                    $list.append($html);
                }
                if (!sentryList || sentryList.length === 0) {
                    var $html = $('<div class="no-message">当天没有排班记录</div>');
                    $messages.append($html);
                }
            };

            if (isFirst) {

                mySchedule = new Schedule({
                    el: '#schedule-box',
                    //date: '2018-9-20',
                    clickCb: function (y, m, d, w, el) {
                        // 日历单格点击事件
                        var SentryList = $(el).data('SentryList');
                        DutyListRender(SentryList);
                    },

                });

                // 日历特效
                scheduleAnimate();

                var calendar = new lCalendar();
                calendar.init({
                    'trigger': '#btnDate',
                    'type': 'ym',
                    'txtShow': '#txtDate',
                    'txtType': 'html'
                }, function (data) { 
                    // 日期选择事件
                    data = TimeToStr(new Date(data),'yyyy-MM-dd')
                    mySchedule.setDate(data.substr(0, 4), (parseInt(data.substr(5, 2)) - 1));
                    updateSchedule();
                    $('#txtDate').data('date', data);
                    $('.dateDay').empty();
                    $('.weekDay').empty();
                    $messages.empty();
                    $messages.append('<div class="no-message">当天没有排班记录</div>');
                    DutyRecordMonthList();
                    calendar.setDate(data);
                });

                DutyRecordMonthList();

                initClick();
                
            }else{
                DutyRecordMonthList();
            }
        }
    },

    "Work_Schedule_Calendar_Detail.html": {
        Init: function (isFirst, Param) {
            var $divDate = $('.div-date');
            var $ondutyDetail= $('#ondutyDetail');
            var $selectPeople = $('#selectPeople');
            var $saveBtn = $('.header-text-right');
            var $dutyList = $('.duty-list');
            var $ScrollInit = $dutyList;
            var $sentryName = $('.sentry-name');
            var $sentryType = $('.sentry-type');
            var $sentryNum = $('.sentry-num');
            var $sentryDate = $('.sentry-date');

            function ScheduleInfo(){

                inte.SentryDutyDayDetails({
                    SentryID: $ondutyDetail.data('sentryid'),
                    DayDate: $ondutyDetail.data('dutydate'),
                }, function (JsonObj) {
                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {
                        
                        var sentryRow = JsonObj.SentryInfo;

                        $sentryName.text(sentryRow.SentryName || '');
                        $sentryType.text(sentryRow.SentryTypeName || '');
                        var sentryNum;
                        switch (sentryRow.ExecutorNumType) {
                            case 'ONE':
                            sentryNum = '单岗';
                            break
                            case 'TWO':
                            sentryNum = '双岗';
                            break
                            case 'MORE':
                            sentryNum = '多岗';
                            break
                            default:
                            sentryNum = '-';
                            break
                        }
                        $sentryNum.text(sentryNum);
                        $sentryDate.text(sentryRow.EnableBeginTime || '' + '至' + sentryRow.EnableEndTime || '');
                        
                        var $list = $dutyList;
                        $list.empty();

                        // sentryRow.DutyList = [];

                        for(var key in sentryRow.DutyList){
                            var row = sentryRow.DutyList[key];
                            var html = '';
                            html += '<div class="position-container duty-par">';
                            html += '  <div class="onduty-position">';
                            html += '    <div class="text-item">';
                            html += '      <div class="detail-left">'+ (row.DutyName || '') +'</div>';
                            html += '      <div class="">'+ (row.DutyBeginTime + '~' + row.DutyEndTime) +'</div>';
                            html += '    </div>';
                            html += '    <div class="text-item">';
                            html += '      <div class="detail-left">执勤闹铃</div>';
                            html += '      <div class="">'+ (row.AlarmTime || '') +'</div>';
                            html += '    </div>';
                            html += '    <div class="text-item duty-team">';
                            html += '      <div class="detail-left">执勤队伍</div>';
                            var teamName = "";
                            for(var k in row.DepartmentGroupList){
                                teamName += row.DepartmentGroupList[k].DepartmentGroupName + ' '
                            }
                            html += '      <div class="">'+ teamName +'</div>';
                            html += '    </div>';
                            html += '    <div class="text-item duty-people-list" data-dutyid='+ row.DutyID +'>';
                            html += '      <div class="detail-left">执勤人员</div>';
                            html += '    <div class="flex-column">';
                            html += '      <div class="people-list">';
                            // for(var k in row.RegularExecutorList){
                            //     html += '      <div data-uiid="'+ row.RegularExecutorList[k].UIdentifyID +'">'+ row.RegularExecutorList[k].UserName +'</div>';
                            // }

                            for(var k in row.RegularExecutorList){
                                html += '      <div class="temp-people" data-uiid="'+ row.RegularExecutorList[k].UIdentifyID +'">';
                                html += '        <div>'+ row.RegularExecutorList[k].UserName +'</div>';
                                html += '        <div class="img-cancle-temp-people"></div>';
                                html += '      </div>';
                            }

                            html += '      </div>';
                            html += '      <div class="flex-column-center add-people ui-margin-b-17">';
                            html += '        <div class="img-add-temp-people"></div>';
                            html += '        <div class="ui-fontsize-16 ui-color-blue">添加人员</div>';
                            html += '      </div>';
                            html += '      </div>';
                            html += '    </div>';
                            html += '  </div>';
                            html += '  <div class="ui-border-t-slim temp-people-box" data-dutyid='+ row.DutyID +'>';
                            html += '    <div class="detail-left">临时人员</div>';
                            html += '    <div class="flex-column">';
                            html += '      <div class="temp-people-list">';
                            for(var k in row.TempExecutorList){
                                html += '      <div class="temp-people" data-uiid="'+ row.TempExecutorList[k].UIdentifyID +'">';
                                html += '        <div>'+ row.TempExecutorList[k].UserName +'</div>';
                                html += '        <div class="img-cancle-temp-people"></div>';
                                html += '      </div>';
                            }
                            html += '      </div>';
                            html += '      <div class="flex-column-center add-temp-people">';
                            html += '        <div class="img-add-temp-people"></div>';
                            html += '        <div class="ui-fontsize-16 ui-color-blue">添加人员</div>';
                            html += '      </div>';
                            html += '    </div>';
                            html += '  </div>';
                            html += '  <div class="ui-border-t-slim ui-height-35 flex-column-center ui-color-99 ui-fontsize-12">若无需设定临时人员，则留空</div>';
                            html += '</div>';

                            var $html = $(html);
                            $list.append($html);

                            //添加临时执勤人员
                            $('.add-temp-people').off().tap(ToClick,function(){
                                var dutyid = $(this).parents('.temp-people-box').data('dutyid');
                                // 选择人员
                                $ondutyDetail.hide();
                                $saveBtn.hide();
                                $selectPeople.show();
                                var chooseparams = {
                                    search : Param.search || '',
                                    chooselist : [],
                                    disabeldlist : [],
                                }
                                $(this).prev().children().each(function(){
                                    var params = {
                                        uiid:$(this).data('uiid')
                                    }
                                    chooseparams.chooselist.push(params);
                                })
                                $(this).parents('.position-container').find('.people-list').children().each(function(){
                                    var params = {
                                        uiid:$(this).data('uiid')
                                    }
                                    chooseparams.disabeldlist.push(params);
                                })
                                app.Init("Work_Schedule_Calendar_Select_People.html", false, {
                                    sentryid : $ondutyDetail.data('sentryid'),
                                    dutyDate: $ondutyDetail.data('dutydate'),
                                    dutyid : dutyid,
                                    chooseparams : chooseparams,
                                    type: 'TEMP'
                                });
                            })

                            //添加固定执勤人员
                            $('.add-people').off().tap(ToClick,function(){
                                var dutyid = $(this).parents('.duty-people-list').data('dutyid');
                                // 选择人员
                                $ondutyDetail.hide();
                                $saveBtn.hide();
                                $selectPeople.show();
                                var chooseparams = {
                                    search : Param.search || '',
                                    chooselist : [],
                                    disabeldlist : [],
                                }
                                $(this).prev().children().each(function(){
                                    var params = {
                                        uiid:$(this).data('uiid')
                                    }
                                    chooseparams.chooselist.push(params);
                                })
                                // $(this).parents('.position-container').find('.people-list').children().each(function(){
                                //     var params = {
                                //         uiid:$(this).data('uiid')
                                //     }
                                //     chooseparams.disabeldlist.push(params);
                                // })
                                app.Init("Work_Schedule_Calendar_Select_People.html", false, {
                                    sentryid : $ondutyDetail.data('sentryid'),
                                    dutyDate: $ondutyDetail.data('dutydate'),
                                    dutyid : dutyid,
                                    chooseparams : chooseparams,
                                    type: 'REGULAR'
                                });
                            })

                            $('.img-cancle-temp-people').off().tap(ToClick, function(){
                                // 移除临时人员
                                $(this).parent().remove();
                            })
                        }

                        if (!sentryRow.DutyList || sentryRow.DutyList.length === 0) {
                            var $html = $('<div class="no-messages ui-bgc-f5">没有信息</div>');
                            $list.append($html);
                        }
                    } else if (JsonObj.Code == -101) {
                        // 账号多地登录
                        exitApp(JsonObj.Message)
                    } else {
                        Msg.Error.Show(JsonObj.Message)
                    }
                })
            }


            function submit(){  
                // [
                //   {
                //     "DutyID": 100, 
                //     "TempExecutorList": [
                //       {
                //         "DepartmentGroupID": 21, 
                //         "UIdentifyID": "7c67c628e9534c4d94ac535645e3f8cb"
                //       }
                //     ]
                //   }, 
                //   {
                //     "DutyID": 101, 
                //     "TempExecutorList": [
                //       {
                //         "DepartmentGroupID": 21, 
                //         "UIdentifyID": "7c67c628e9534c4d94ac535645e3f8cb"
                //       }
                //     ]
                //   }
                // ]

                var Dutys = [];
                $('.duty-par').each(function(){
                    var regularExecutorList = [];
                    var executorList = [];
                    var dutyid = $(this).find(".temp-people-box").eq(0).data('dutyid');

                    $(this).find('.people-list .temp-people').each(function(){
                        regularExecutorList.push({
                            DepartmentGroupID:$(this).data('groupid') || 0,
                            UIdentifyID:$(this).data('uiid')
                        })
                    })

                    $(this).find('.temp-people-list .temp-people').each(function(){
                        executorList.push({
                            DepartmentGroupID:$(this).data('groupid') || 0,
                            UIdentifyID:$(this).data('uiid')
                        })
                    })

                    Dutys.push({
                        DutyID: dutyid,
                        RegularExecutorList: regularExecutorList,
                        TempExecutorList: executorList
                    })
                })

                console.log(Dutys)
                
                inte.SentryDutyAssignExecutor({
                    SentryID: $ondutyDetail.data('sentryid'),
                    DayDate: $ondutyDetail.data('dutydate'),
                    Executor:JSON.stringify(Dutys)
                },function(JsonObj){
                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {
                        Msg.OK.Show('保存成功',2,function(){ 
                            window.location.reload() 
                        })
                    } else if (JsonObj.Code == -101) {
                        //账号多地登录
                        exitApp(JsonObj.Message);
                    } else {
                        Msg.Error.Show(JsonObj.Message);
                    }
                })
            }

            if(isFirst){
                OverScroll($ScrollInit.get(0));
                $saveBtn.tap(ToClick,function(){
                    submit();
                })
            }else{
                
                $ondutyDetail.show();
                $saveBtn.show();

                $ondutyDetail.data('sentryid',Param.sentryid);
                $ondutyDetail.data('dutydate',Param.dutyDate);

                $("#btnBack").off().click(function(){
                    $('article').css('height','100%');
                    $('#selecMonthContainer').show();
                    $('#week').show();
                    $ondutyDetail.hide();
                    $saveBtn.hide();
                    $(this).off().click(function(){
                        backAppPage();
                    });
                })

                if(Param.from == "calendar"){
                    ScheduleInfo();
                    $divDate.html('<div class="ui-margin-r-8">'+ Param.dutyDate +'</div><div>'+ Param.dutyWeek +'</div>');
                }else if(Param.from == "select"){

                    if (Param.type == "TEMP") {
                        var $list = $('.temp-people-box[data-dutyid='+ Param.dutyid +']  .temp-people-list');
                        $list.empty();
                        for(var key in Param.chooseparams.chooselist){
                            var row = Param.chooseparams.chooselist[key];
                            var html = '';
                            html += '      <div class="temp-people" data-uiid='+ row.uiid +'>';
                            html += '        <div>'+ row.name +'</div>';
                            html += '        <div class="img-cancle-temp-people"></div>';
                            html += '      </div>';
                            $list.append(html);
                        }
                    } else if(Param.type == "REGULAR"){
                        var $list = $('.duty-people-list[data-dutyid='+ Param.dutyid +']  .people-list');
                        $list.empty();
                        for(var key in Param.chooseparams.chooselist){
                            var row = Param.chooseparams.chooselist[key];
                            var html = '';
                            html += '      <div class="temp-people" data-uiid='+ row.uiid +'>';
                            html += '        <div>'+ row.name +'</div>';
                            html += '        <div class="img-cancle-temp-people"></div>';
                            html += '      </div>';
                            $list.append(html);
                        }
                    }

                    $('.img-cancle-temp-people').off().tap(ToClick, function(){
                        // 移除临时人员
                        $(this).parent().remove();
                    })
                }
            }
        }
    },

    "Work_Schedule_Calendar_Select_People.html": {
        Init: function (isFirst, Param) {
            var $selectPeople = $('#selectPeople');
            $selectPeople.data('param',Param);
            var $ScrollInit = $("#select-people-list");
            //搜索框相关
            var $txtSearch = $("#txtSearch");
            var $btnClose = $("#btnClose");
            var versionsNum = window.PlatformID;

            var initClick = function () {

                $btnClose.off().tap(ToClick, function () {
                    $txtSearch.val("");
                    getDepartmentSearch();
                    $btnClose.addClass("ui-hide");
                });

            };

            //写完关键词触发
            var compositionendToShow = function () {
                var flag = false;
                if (versionsNum == 1) {
                    flag = true;
                    $txtSearch.on({
                        compositionstart: function () {
                            flag = false;
                        },
                        compositionend: function () {
                            flag = true;
                        },
                        input: function () {
                            setTimeout(function () {
                                if (flag) {
                                    inputSearch();
                                }
                            }, 50);
                        }
                    });
                }else if(versionsNum == 0){
                    $txtSearch.on({
                      compositionend:function(){
                        setTimeout(function(){
                          inputSearch();
                          flag = false;
                        },50)
                      },
                      compositionstart:function(){
                        flag = true;
                      },
                      keydown:function () {
                        setTimeout(function(){
                          if(!flag){
                            inputSearch();
                          }
                        },50)
                      }
                    });
                }
            };

            var inputSearch = function(){
                var str = $txtSearch.val().trim() || "";
                if (str) {
                    $btnClose.removeClass("ui-hide");
                }
                getDepartmentSearch(str);
            }

            //搜索
            var getDepartmentSearch = function (searchName,first) {

                inte.SentryDutyExecutorList({
                    SentryID: $selectPeople.data('param').sentryid,
                    DutyID: $selectPeople.data('param').dutyid,
                    DayDate: $selectPeople.data('param').dutyDate,
                    Type: $selectPeople.data('param').type,
                    SearchName: searchName || ''
                }, function (JsonObj) {

                    if (JsonObj.Code == 1 || JsonObj.Code == -301) {
                        $ScrollInit.empty();
                        var $list = $ScrollInit;
                        for (var key in JsonObj.DepartmentGroupList) {
                            var html = '';
                            $list = $ScrollInit;
                            var GroupRow = JsonObj.DepartmentGroupList[key];
                            if (GroupRow.DepartmentGroupLevel == 2) {
                                html += '<div class="search-group-list ui-bgc-ff ui-padding-lr-15" data-groupid="' + GroupRow.DepartmentGroupID + '">';
                                html += '  <div class="flex-column-center ui-color-61 ui-height-45 ui-fontsize-15 detail-toggle">';
                                html += '      <div class="img-select-people"></div>';
                                html += '      <div class="search-right-icon search-toggle-icon"></div><div>' + GroupRow.DepartmentGroupName + '</div>';
                                html += '  </div>';
                                html += '  <div class="group-list height-0">'
                                for (var i in GroupRow.UserList) {
                                    var row = GroupRow.UserList[i];
                                    html += '<div class="list-item ui-flex-align-center ui-height-45" data-uiid="' + row.UIdentifyID + '" data-groupid=' + GroupRow.DepartmentGroupID + ' data-dutylist='+ JSON.stringify(row.DutyList) +'>';
                                    html += '<div class="img-select-people"></div>';
                                    html += '<div class="flex-column-center ui-border-b-slim ui-height-45 people-name">' + row.UserName + '</div>';
                                    html += '</div>';
                                }
                                html += '</div>';
                            } else if (GroupRow.DepartmentGroupLevel == 3) {
                                var $teamEl = $('.search-group-list[data-groupid=' + GroupRow.UpperDepartmentGroupID + ']');
                                var flag = $teamEl.length > 0
                                // if($teamEl.length){
                                if (!flag) {
                                    html += '<div class="search-group-list ui-bgc-ff ui-padding-lr-15">'
                                }
                                html += '<div class="flex-column-center ui-color-61 ui-height-45 ui-fontsize-15 search-group ' + (flag ? 'height-0' : '') + '">';
                                html += '  <div class="img-select-people"></div>';
                                html += '  <div class="search-group-leftmar ' + (flag ? 'search-left-icon' : 'search-right-icon') + '"></div><div>' + GroupRow.DepartmentGroupName + '</div>';
                                html += '</div>'
                                html += "<div class='secondary-group-list height-0'>"
                                for (var i in GroupRow.UserList) {
                                    var row = GroupRow.UserList[i];
                                    html += '<div class="list-item ui-flex-align-center ui-height-45" data-uiid="' + row.UIdentifyID + '" data-groupid=' + GroupRow.DepartmentGroupID + ' data-dutylist='+ JSON.stringify(row.DutyList) +'>';
                                    html += '<div class="img-select-people"></div>';
                                    html += '<div class="flex-column-center ui-border-b-slim ui-height-45 people-name">' + row.UserName + '</div>';
                                    html += '</div>';
                                }
                                html += '</div>';
                                html += '</div>';
                                if (!flag) {
                                    html += '</div>'
                                }

                                if (flag) {
                                    $list = $teamEl;
                                }
                                // }
                            }

                            var $html = $(html);
                            $list.append($html);
                        }

                        if (!JsonObj.DepartmentGroupList.length) {
                            html = '<div class="no-messages ui-bgc-f5">没有信息</div>';
                            $list.append(html);
                        }

                        
                        $('.search-group-list').each(function(){
                            $(this).find('.ui-border-b-slim').last().removeClass('ui-border-b-slim');
                        })

                        $('.search-group-list').find('.list-item').last().removeClass('ui-border-b-slim');

                        if (searchName){
                            $('.search-group-list').find('.height-0').removeClass('height-0');
                            $('.search-group-list').find('.search-right-icon').removeClass('search-right-icon').addClass('search-left-icon');
                        }
                        
                        $(".detail-toggle").off().tap(ToClick, function () {
                            $(this).find(".search-toggle-icon").eq(0).toggleClass("search-right-icon");
                            $(this).find(".search-toggle-icon").eq(0).toggleClass("search-left-icon");
                            var $next = $(this).next();
                            $next.toggleClass("height-0");
                            $(this).nextAll().each(function () {
                                if ($next.hasClass("height-0")) {
                                    if (!$(this).hasClass("height-0")) {
                                        $(this).addClass("height-0");
                                    }
                                } else {
                                    if ($(this).hasClass("height-0")) {
                                        $(this).removeClass("height-0");
                                    }
                                    if ($(this).hasClass('search-group')) {
                                        var $arrow = $(this).find(".search-group-leftmar").eq(0);
                                        $arrow.addClass('search-left-icon');
                                        $arrow.removeClass('search-right-icon');
                                    }
                                }
                            })
                        });

                        $('.search-group').off().tap(ToClick, function () {
                            $(this).find(".search-group-leftmar").eq(0).toggleClass("search-right-icon");
                            $(this).find(".search-group-leftmar").eq(0).toggleClass("search-left-icon");
                            $(this).next().toggleClass("height-0");
                        });

                        $('.img-select-people').off().tap(ToClick, chooseEvent)

                        $('.list-item').off().tap(ToClick, function () {
                            $(this).toggleClass('choose');
                            chooseRender($(this).parents('.search-group-list'));
                        })

                        // restore
                        if(first){
                            restoreChoose();
                            // TOFIX
                            removeRegular();
                        }

                    } else if (JsonObj.Code == -101) {
                        //账号多地登录
                        exitApp(JsonObj.Message);
                    } else {
                        Msg.Error.Show(JsonObj.Message);
                    }
                })
            };

            // 选择图标渲染
            function chooseRender($root){

                var $team = $root.find('.detail-toggle');
                var teamChooseCount = $root.find('.list-item.choose').length;
                var teamItemCount = $root.find('.list-item').length;
                if(teamChooseCount > 0 && teamChooseCount == teamItemCount){
                    $team.addClass('choose');
                    $team.removeClass('choose-not-all');
                    $root.find('.search-group').addClass('choose');
                    $root.find('.search-group').removeClass('choose-not-all');
                }else if(teamChooseCount > 0 && teamChooseCount < teamItemCount){
                    $team.removeClass('choose');
                    $team.addClass('choose-not-all');
                }else if(teamChooseCount == 0){
                    $team.removeClass('choose');
                    $team.removeClass('choose-not-all');
                    $root.find('.search-group').removeClass('choose');
                    $root.find('.search-group').removeClass('choose-not-all');
                }

                $root.find('.search-group').each(function(){
                    var $group = $(this);
                    var $grouplist = $(this).next();

                    var groupChooseCount = $grouplist.find('.list-item.choose').length;
                    var groupItemCount = $grouplist.find('.list-item').length;
                    if(groupChooseCount > 0 && groupChooseCount == groupItemCount){
                        $group.addClass('choose');
                        $group.removeClass('choose-not-all');
                    }else if(groupChooseCount > 0 && groupChooseCount < groupItemCount){
                        $group.removeClass('choose');
                        $group.addClass('choose-not-all');
                    }else if(groupChooseCount == 0){
                        $group.removeClass('choose');
                        $group.removeClass('choose-not-all');
                    }
                })
            }

            // 图标点击
            function chooseEvent(e) {
                if(e){
                    e.stopPropagation();
                }

                var $parent = $(this).parent();
                var $root = $(this).parents('.search-group-list');

                // 如果是队的选择框 队内所有选择框切换
                if ($parent.hasClass('detail-toggle')) {

                    if (!$parent.hasClass('choose')) {
                        $root.find('.list-item>.img-select-people').parent().addClass('choose');
                        $parent.nextAll().removeClass('height-0');
                        $parent.find('.search-toggle-icon').removeClass('search-right-icon').addClass('search-left-icon');
                    } else {
                        $root.find('.list-item>.img-select-people').parent().removeClass('choose');
                    }
                    chooseRender($root);
                }
                // 如果是班的选择框 班内所有选择框切换
                else if ($parent.hasClass('search-group')) {

                    if (!$parent.hasClass('choose')) {
                        $parent.next().find('.list-item').addClass('choose');
                        $parent.next().removeClass("height-0");
                        $parent.find('.search-group-leftmar').removeClass('search-right-icon').addClass('search-left-icon');
                    } else {
                        $parent.next().find('.list-item').removeClass('choose');
                    }
                    chooseRender($root);
                }
                // 如果是员工 只切换该员工选择框
                else {
                    $parent.toggleClass('choose');
                    chooseRender($root);
                }
            };

            // 将固定人员移出页面
            function removeRegular(){
                for(var key in $selectPeople.data('param').chooseparams.disabeldlist){
                    var row = $selectPeople.data('param').chooseparams.disabeldlist[key];
                    var $item = $('.list-item[data-uiid='+ row.uiid +']');
                    $item.remove();
                }
                
                $('.secondary-group-list').each(function(){
                    if($(this).find('.list-item').length == 0){
                        $(this).parents('.search-group-list').remove;
                    }
                })

                $('.search-group-list').each(function(){
                    if($(this).find('.list-item').length == 0){
                        $(this).remove();
                        $(this).prev().remove();
                    }
                })

                if($('.search-group-list').length == 0){
                    var html = '<div class="no-messages ui-bgc-f5">没有信息</div>';
                    $ScrollInit.empty();
                    $ScrollInit.append(html);
                }
            }

            // 恢复选择
            function restoreChoose(){
                var rootList = [];
                for(var key in $selectPeople.data('param').chooseparams.chooselist){
                    var row = $selectPeople.data('param').chooseparams.chooselist[key];
                    var item = $('.list-item[data-uiid='+ row.uiid +']');
                    item.addClass('choose');
                    var $root = item.parents('.search-group-list');
                    if($.inArray($root,rootList) < 0){
                        rootList.push($root);
                    }
                }

                $('.search-group-list').each(function(){
                    chooseRender($(this));
                })

                rootList.forEach(function($root){
                    $root.find('.height-0').removeClass('height-0');
                    $root.find('.search-toggle-icon').removeClass('search-right-icon').addClass('search-left-icon');
                });
            };

            // 解析网址参数
            function requestParse(){
                try{
                    var infoStr = request('info');
                    var info = Base64.decode(infoStr);
                    requestParams = JSON.parse(info);
                }
                catch(err){
                    requestParams = {
                        search:'',
                        chooselist:[]
                    }   
                }
            }


            if (isFirst) {
                initClick();
                OverScroll($ScrollInit.get(0));
                compositionendToShow();
            }else{
                
                $("#btnBack").off().click(function () {
                    $selectPeople.hide();

                    var chooselist = [];
                    $('.choose.list-item').each(function () {
                        chooselist.push({
                            uiid : $(this).data('uiid'),
                            name : $(this).find('.people-name').text().replace('（队长）','').replace('（班长）','')
                        })
                    })

                    var chooseparams = {
                        chooselist:chooselist,
                        search:$txtSearch.val()
                    }              
                    app.Init("Work_Schedule_Calendar_Detail.html", false, {
                        from : 'select',
                        sentryid : $selectPeople.data('param').sentryid,
                        dutyDate: $selectPeople.data('param').dutyDate,
                        dutyid : $selectPeople.data('param').dutyid,
                        type : $selectPeople.data('param').type,
                        chooseparams : chooseparams
                    });
                });

                // restore
                // $txtSearch.val(search);
                getDepartmentSearch($selectPeople.data('param').search,true);
            }
        }
    }
});