/**
 * Created by Administrator on 2017-08-24.
 */
/*
 选择图片控件初始化封装
 */
+function ($) {
    $.fn.UI_ImgFileInit = function (op, fun) {
        var $this = $(this);
        var dop = {
            $this: $this,
            $img: $('<img>'),
            $file: null,// $('<input type="file" class="inp-posi" accept="image/*" />'),
            height: 720,
            value: $this.data("dval")
        }
        if (typeof (op) == "function") {
            fun = op;
            op = {}
        }

        //获取图片方向
        function getPhotoOrientation(img) {
            var orient;
            EXIF.getData(img, function () {
                orient = EXIF.getTag(this, 'Orientation');
            });
            return orient;
        }

        //图片压缩
        var compressImg = function (file, imgData, maxHeight, onCompress) {
            if (!imgData) return false;
            onCompress = onCompress || function () { };
            maxHeight = maxHeight || 720;//默认最大高度800px
            var canvas = document.createElement("canvas");
            var img = new Image();
            img.objFile = file;

            img.onload = function () {


                if (img.height > maxHeight) {//按最大高度等比缩放
                    img.width *= maxHeight / img.height;
                    img.height = maxHeight;
                }

                var ctx = canvas.getContext("2d");
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                canvas.width = img.width;
                canvas.height = img.height;

                //获取图片方向
                var orient = getPhotoOrientation(img);

                //如果图片方向等于6 ，则旋转矫正，反之则不做处理,ios和部分三星图片会旋转
                if (orient == 6) {
                    ctx.save();
                    ctx.translate(img.width / 2, img.height / 2);
                    ctx.rotate(90 * Math.PI / 180);
                    ctx.drawImage(img, 0 - img.height / 2, 0 - img.width / 2, img.height, img.width);
                    ctx.restore();
                } else {
                    ctx.drawImage(img, 0, 0, img.width, img.height);
                }
                // ctx.drawImage(img, 0, 0, img.width, img.height);

                var data64 = canvas.toDataURL("image/jpeg");

                //转化blob 对象
                var data = data64.split(',')[1];
                data = window.atob(data);
                var ia = new Uint8Array(data.length);
                for (var i = 0; i < data.length; i++) {
                    ia[i] = data.charCodeAt(i);
                };
                // canvas.toDataURL 返回的默认格式就是 image/png
                var blob = new Blob([ia], { type: "image/jpg" });
                onCompress(img.objFile, data64, blob, img.width, img.height);
            };

            img.src = imgData;
        }


        op = $.extend(true, dop, op);

        var $this = $(this);
        var id = $this.attr("id") + '_ImgFile';
        $this.tap(ToClick, function () {
            op.$file = $('<input type="file" class="inp-posi" accept="image/*" />');
            op.$file.attr("id", id);

            op.$file.change(function (evt) {
                Msg.Load.Show("读取中...");
                var files = evt.target.files;
                var newfiles = new Array();
                $this.data("afiles", evt.target.files)
                var isImg = true;
                var fileslength = this.files.length;
                for (var i = 0; i < fileslength; i++) {
                    var file = files[i];
                    var imageType = /image.*/;
                    if (typeof (file) == "object" && file.type.match(imageType)) {

                        var reader = new FileReader();
                        reader.objFile = { "file": file, "index": i };
                        reader.onload = function () {
                            compressImg(reader.objFile, reader.result, op.height, function (file, data, blob, width, height) {
                                Msg.Load.Hide(true);
                                op.$img.attr("src", data);
                                newfiles.push(blob);
                                //file.file = blob;
                                //$("#divmessage").prepend("I:"+file.index+"|"+(fileslength-1)+"|"+(blob.name)+"|"+(files[file.index].name)+"   </br>");
                                if (file.index == (fileslength - 1)) {
                                    if (isImg && fun) {
                                        fun(newfiles, data, width, height, $this);
                                    }
                                }
                                //$("#newImg").attr("src",data);//保存图片压缩后的64位编码
                            });
                            //op.$img.attr("src", reader.result);
                        }
                        reader.readAsDataURL(file);
                    } else {
                        isImg = false;
                        Msg.Error.Show("请选择图片文件", 2);
                    }
                }
            });


            op.$file.click();
        })


        return this;
    }
}(jQuery);


/*
 日期控件初始化封装
 */
+function ($) {
    $.fn.UI_BirthdayInit = function (op, fun) {
        var $this = $(this);
        var dop = {
            value: $this.data("dval")
        }
        if (typeof (op) == "function") {
            fun = op;
            op = {}
        }

        op = $.extend(true, dop, op);
        $this.tap(ToClick, function () {
            var $this = $(this);
            var id = $this.attr("id") + '_Birthday';
            var $inputobj = $("#" + id);
            var $input = null;
            if ($inputobj.length == 0) {
                var inputtml = new Array();
                inputtml.push('<input id="' + id + '" name="' + id + '" type="text" readonly class="inp-posi" value="' + op.value + '"/>');
                var $input = $(inputtml.join(""));
                $(".article-content").append($input)

                var currYear = (new Date()).getFullYear();
                var opt = {};
                opt.date = { preset: 'date' };  //time:只显示时分 date:只显示年月日  datetime：显示年月日时分
                opt.datetime = { preset: 'datetime' };
                opt.time = { preset: 'time' };
                opt.default = {
                    theme: 'android-ics light', //皮肤样式
                    display: 'modal', //显示方【modal】【inline】【bubble】【top】【bottom】
                    mode: 'scroller', //日期选择模式
                    dateFormat: 'yy-mm-dd',//得到值的格式
                    dateOrder: 'yymmdd',//选择包含什么 如果只要年份 就只要yy
                    lang: 'zh',
                    showNow: false,
                    nowText: "今天",
                    startYear: currYear - 50, //开始年份
                    endYear: currYear + 10, //结束年份
                    //maxDate: new Date(),
                    onSelect: function (valueText, inst) {
                        if (fun) {
                            fun(valueText, $this);
                        }
                    }
                };
                var $inputmob = $input.mobiscroll($.extend(opt['date'], opt['default'], op));
                //$inputmob.setValur(value);

            } else {
                //$inputobj.remove();
                $input = $inputobj;
            }


            $input.trigger("focus");

        })
        return this;
    }
}(jQuery);



/**
 * Created by kxy on 2017-12-13.
 */
/*
 选择图片或视频控件初始化封装
 */
+function ($) {
    $.fn.UI_FileInit = function (op, fun) {
        var $this = $(this);
        var dop = {
            $this: $this,
            $img: $('<img>'),
            $file: null,// $('<input type="file" class="inp-posi" accept="image/*" />'),
            height: 720,
            value: $this.data("dval")
        }

        if (typeof (op) == "function") {
            fun = op;
            op = {}
        }

        //图片压缩
        var compressImg = function (file, imgData, maxHeight, onCompress) {
            if (!imgData) return false;
            onCompress = onCompress || function () { };
            maxHeight = maxHeight || 720;//默认最大高度800px
            var canvas = document.createElement("canvas");
            var img = new Image();
            img.objFile = file;

            img.onload = function () {


                if (img.height > maxHeight) {//按最大高度等比缩放
                    img.width *= maxHeight / img.height;
                    img.height = maxHeight;
                }

                var ctx = canvas.getContext("2d");
                ctx.clearRect(0, 0, canvas.width, canvas.height);
                canvas.width = img.width;
                canvas.height = img.height;
                ctx.drawImage(img, 0, 0, img.width, img.height);

                var data64 = canvas.toDataURL("image/jpeg");

                //转化blob 对象
                var data = data64.split(',')[1];
                data = window.atob(data);
                var ia = new Uint8Array(data.length);
                for (var i = 0; i < data.length; i++) {
                    ia[i] = data.charCodeAt(i);
                };
                // canvas.toDataURL 返回的默认格式就是 image/png
                var blob = new Blob([ia], { type: "image/jpg" });
                onCompress(img.objFile, data64, blob, img.width, img.height);
            };

            img.src = imgData;
        }


        op = $.extend(true, dop, op);
        var $this = $(this);
        var id = $this.attr("id") + '_ImgFile';
        $this.tap(ToClick, function () {
            op.$file = $('<input type="file" class="inp-posi"/>');
            op.$file.attr("id", id);

            op.$file.change(function (evt) {
                Msg.Load.Show("读取中...");
                var files = evt.target.files;
                var newfiles = new Array();
                $this.data("afiles", evt.target.files)
                var isImg = true;
                var fileslength = this.files.length;
                for (var i = 0; i < fileslength; i++) {
                    var file = files[i];
                    var imageType = /image.*/;
                    var videoType = /video.*/;
                    if (typeof (file) == "object" && file.type.match(videoType)) {

                        var reader = new FileReader();
                        reader.objFile = { "file": file, "index": i };
                        reader.onload = function () {
                            var fileSize = file.size;
                            if(fileSize <= 30*1024*1024){
                                fun(files,"","","", $this);
                            }else{
                                Msg.Error.Show("视频太大，不超过30MB", 2);
                            }
                            console.log("文件大小:" + fileSize);
                           
                            //op.$img.attr("src", reader.result);
                        }
                        reader.readAsDataURL(file);
                    } else if (typeof (file) == "object" && file.type.match(imageType)) {

                        var reader = new FileReader();
                        reader.objFile = { "file": file, "index": i };
                        reader.onload = function () {
                            compressImg(reader.objFile, reader.result, op.height, function (file, data, blob, width, height) {
                                Msg.Load.Hide(true);
                                op.$img.attr("src", data);
                                newfiles.push(blob);
                                //file.file = blob;
                                //$("#divmessage").prepend("I:"+file.index+"|"+(fileslength-1)+"|"+(blob.name)+"|"+(files[file.index].name)+"   </br>");
                                if (file.index == (fileslength - 1)) {
                                    if (isImg && fun) {
                                        fun(newfiles, data, width, height, $this);
                                    }
                                }
                                //$("#newImg").attr("src",data);//保存图片压缩后的64位编码
                            });
                            //op.$img.attr("src", reader.result);
                        }
                        reader.readAsDataURL(file);
                    } else {
                        isImg = false;
                        Msg.Error.Show("请选择图片文件", 2);
                    }
                }
            });


            op.$file.click();
        })


        return this;
    }
}(jQuery);
