﻿//于是想相关的扩展方法
/*时间管理函数*/
/*时间实例化*/
String.prototype.toTime = function () {
    var strDate = this.replaceAll("-", "/");
    if (strDate.length > 0) {
        return new Date(strDate);
    }
    return new Date();
}
function TimeToTimeStamp(dateValue) {
    return TimeCom(dateValue).newDate.getTime();
}
function TimeStampToTime(timeStamp) {
    return new Date(parseInt(timeStamp) * 1000);
}
function TimeCom(dateValue) {
    var newDate = new Date();
    if (typeof (dateValue) == "string") {
        newDate = new Date(dateValue.toTime());
    } else {
        newDate = dateValue;
    }
    this.newDate = newDate;
    this.year = newDate.getFullYear();
    this.month = newDate.getMonth() + 1;
    this.day = newDate.getDate();
    this.hour = newDate.getHours();
    this.minute = newDate.getMinutes();
    this.second = newDate.getSeconds();
    this.msecond = newDate.getMilliseconds(); 
    this.week = newDate.getDay();
}

function TimeComStr(dateValue) {
    var newDate = new Date();
    if (typeof (dateValue) == "string") {
        newDate = new Date(dateValue.toTime());
    }
    this.newDate = newDate;
    this.year = newDate.getFullYear().toString();
    this.month = ((newDate.getMonth() + 1) < 10 ? "0" : "") + (newDate.getMonth() + 1).toString();
    this.day = (newDate.getDate() < 10 ? "0" : "") + (newDate.getDate()).toString();
    this.hour = (newDate.getHours() < 10 ? "0" : "") + (newDate.getHours()).toString();
    this.minute = (newDate.getMinutes() < 10 ? "0" : "") + (newDate.getMinutes()).toString();
    this.second = (newDate.getSeconds() < 10 ? "0" : "") + (newDate.getSeconds()).toString();
    this.msecond = (newDate.getMilliseconds() < 10 ? "00" : newDate.getMilliseconds() < 100 ? "00" : "") + (newDate.getMilliseconds()).toString();
    this.week = (newDate.getDay()).toString();
    return this;
}

/*format： 
    yyyy -> 年
    MM -> 月
    dd -> 日
    HH -> 时
    mm -> 分
    ss -> 秒
    ms -> 毫秒
    ww -> 周几

    var datestr = TimeToStr(new date(),"yyyy年MM月dd日")
    var datestr = TimeToStr(new date(),"yyyy-MM-dd")
*/
function TimeToStr(dateValue, format) {
    var newDate = new Date();
    if (typeof (dateValue) == "string") {
		if(dateValue==""){
			return "";
		}
        newDate = new Date(dateValue.toTime());
    }else{
        newDate = dateValue;
    }
    var newDate = newDate;
    var year = newDate.getFullYear().toString();
    var month = ((newDate.getMonth() + 1) < 10 ? "0" : "") + (newDate.getMonth() + 1).toString();
    var day = (newDate.getDate() < 10 ? "0" : "") + (newDate.getDate()).toString();
    var hour = (newDate.getHours() < 10 ? "0" : "") + (newDate.getHours()).toString();
    var minute = (newDate.getMinutes() < 10 ? "0" : "") + (newDate.getMinutes()).toString();
    var second = (newDate.getSeconds() < 10 ? "0" : "") + (newDate.getSeconds()).toString();
    var msecond = (newDate.getMilliseconds() < 10 ? "00" : newDate.getMilliseconds() < 100 ? "00" : "") + (newDate.getMilliseconds()).toString();
    var week = (newDate.getDay()).toString();
    var weekcapital = "";
    switch(week)
    {
        case "0": weekcapital = '日'; break;
        case "1": weekcapital = '一'; break;
        case "2": weekcapital = '二'; break;
        case "3": weekcapital = '三'; break;
        case "4": weekcapital = '四'; break;
        case "5": weekcapital = '五'; break;
        case "6": weekcapital = '六'; break;
    }

    format = format.replace("yyyy", year);
    format = format.replace("MM", month);
    format = format.replace("dd", day);
    format = format.replace("HH", hour);
    format = format.replace("mm", minute);
    format = format.replace("ss", second);
    format = format.replace("ms", msecond);
    format = format.replace("ww", week);
    format = format.replace("WW", weekcapital);
    return format
}

/*求时间差*/
function DateDiff(interval, date1, date2) {
    var TimeCom1 = new TimeCom(date1);
    var TimeCom2 = new TimeCom(date2);
    var result;
    switch (String(interval).toLowerCase()) {
        case "y":
        case "year":
            result = TimeCom1.year - TimeCom2.year;
            break;
        case "n":
        case "month":
            result = (TimeCom1.year - TimeCom2.year) * 12 + (TimeCom1.month - TimeCom2.month);
            break;
        case "d":
        case "day":
            result = Math.round((Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day)) / (1000 * 60 * 60 * 24));
            break;
        case "h":
        case "hour":
            result = Math.round((Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day, TimeCom1.hour) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day, TimeCom2.hour)) / (1000 * 60 * 60));
            break;
        case "m":
        case "minute":
            result = Math.round((Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day, TimeCom1.hour, TimeCom1.minute) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day, TimeCom2.hour, TimeCom2.minute)) / (1000 * 60));
            break;
        case "s":
        case "second":
            result = Math.round((Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day, TimeCom1.hour, TimeCom1.minute, TimeCom1.second) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day, TimeCom2.hour, TimeCom2.minute, TimeCom2.second)) / 1000);
            break;
        case "ms":
        case "msecond":
            result = Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day, TimeCom1.hour, TimeCom1.minute, TimeCom1.second, TimeCom1.msecond) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day, TimeCom2.hour, TimeCom2.minute, TimeCom2.second, TimeCom1.msecond);
            break;
        case "w":
        case "week":
            result = Math.round((Date.UTC(TimeCom1.year, TimeCom1.month - 1, TimeCom1.day) - Date.UTC(TimeCom2.year, TimeCom2.month - 1, TimeCom2.day)) / (1000 * 60 * 60 * 24)) % 7;
            break;
        default:
            result = "invalid";
    }
    return (result);
}
/*增加时间*/
function DateAdd(interval, num, dateValue) {
    var newCom = new TimeCom(dateValue);

    switch (String(interval).toLowerCase()) {
        case "y": case "year": newCom.year += num; break;
        case "n": case "month": newCom.month += num; break;
        case "d": case "day": newCom.day += num; break;
        case "h": case "hour": newCom.hour += num; break;
        case "m": case "minute": newCom.minute += num; break;
        case "s": case "second": newCom.second += num; break;
        case "ms": case "msecond": newCom.msecond += num; break;
        case "w": case "week": newCom.day += num * 7; break;
        default: return ("invalid");
    }
    //var now = newCom.year + "/" + newCom.month + "/" + newCom.day + " " + newCom.hour + ":" + newCom.minute + ":" + newCom.second;
    return (new Date(newCom.year, newCom.month - 1, newCom.day, newCom.hour, newCom.minute, newCom.second));
}

/*与当前时间相差*/
function DateDifferTime(dateValue) {
    var newDate = new Date();
    var newToDate = new Date();
    if (typeof (dateValue) == "string") {
        newDate = new Date(dateValue.toTime());
    }
    var DifferTime = {}
    DifferTime.newDate = newDate;
    DifferTime.newToDate = newToDate;
    DifferTime.c_msecond =  parseInt((newToDate.getTime()-newDate.getTime()));
    DifferTime.c_second = parseInt((newToDate.getTime()-newDate.getTime())/1000);
    DifferTime.c_minute = parseInt((newToDate.getTime()-newDate.getTime())/1000/60);
    DifferTime.c_hour = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60);
    DifferTime.c_day = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24);
    DifferTime.c_month = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24/30);
    DifferTime.c_year = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24/30/365);
    DifferTime.year = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24/30/365);
    DifferTime.month = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24/30%365);
    DifferTime.day = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60/24%30);
    DifferTime.hour = parseInt((newToDate.getTime()-newDate.getTime())/1000/60/60%24);
    DifferTime.minute = parseInt((newToDate.getTime()-newDate.getTime())/1000/60%60);
    DifferTime.second = parseInt((newToDate.getTime()-newDate.getTime())/1000%60);
    DifferTime.msecond = parseInt((newToDate.getTime()-newDate.getTime())%1000);
    //this.week = (newDate.getDay()).toString();
    return DifferTime;
}
/*时间管理函数end*/

//time1-time2
function DateDifferTimeDay(time1, time2) {

    if (time1.length < 11 || time2.length < 11 ) {
        return 0;
    }

    var valueYmh1 = time1.substring(0,10);
    var valueNoon1 = time1.substring(11) == "上午" ? 0 : 1;
    var valueYmh2 = time2.substring(0,10);
    var valueNoon2 = time2.substring(11) == "上午" ? 0 : 1;

    var del = DateDiff("d",valueYmh1,valueYmh2);
    var del2 = (valueNoon1 - valueNoon2) == 0 ? 0.5 : (valueNoon1 - valueNoon2);

    if (del < 0) {
        if (del2 == 0.5) {
            del2 = -del2;
        } else if (del2 == 1){
            del2 = 0;
        }
    } else if (del > 0){
        if (del2 == -1) {
            del2 = 0;
        }
    }

    var DifferTime = (del + del2) || 0;

    return DifferTime;
}