// 图片列表组件

// data:title标题,beforeEl此元素前插入组件,imgLength图片个数
// fun 点击回调函数 返回 data,title
// notTiggerFun 不触发函数 返回 bool

function PhotoBox(data, fun, notTiggerFun) {

  this.title = data.title;
  this.beforeEl = data.beforeEl;
  this.imgLength = data.imgLength || 3;
  this.fun = fun;
  this.notTiggerFun = notTiggerFun;
  this.elid;
  var _this = this;

  this.init = function () {
    var elid = 'mpop' + parseInt(Math.random() * 100000);
    _this.elid = '#' + elid;
    var html = '';

    html += '<div class="scene-img" id="' + elid + '">';
    if (_this.title) {
      html += '<div class="scene-img-title">' + _this.title + '</div>'
    }
    html += '  <ul class="scene-img-list">';
    html += '    <li class="scene-img-box duty-img" id="imgAdd">';
    html += '      <img src="Img/ico_addPhoto@2x.png" alt="" class="">';
    html += '    </li>';
    html += '  </ul>';
    html += '</div">';

    _this.beforeEl.after($(html));

    $(_this.elid + ' #imgAdd').tap(ToClick, function () {
      setTimeout(function () {
        nativePhotoResultInstance.setFun(function (photo) {
          if (photo.path) {
            _this.imgAdd(photo.path);
          }
        })
        nativeOpenPhotoDialog('');
      }, 300);
    })
  }
  this.init();

  this.imgAdd = function (img, thumb, imgData) {
    if (img) {
      if (!thumb) thumb = img
      var $imgAdd = $(_this.elid + ' #imgAdd');
      var html = '';
      html += '<li class="scene-img-box">';
      html += '  <img src="' + thumb + '" alt="" class="scene-img-item">';
      html += '</li>';

      var $html = $(html);
      if (imgData) $html.find('img').data('imgdata', imgData);
      $html.off().tap(ToClick, function () {
        ImgPreview(img, $html, function () {
          if ($(_this.elid + ' .scene-img-item').length < _this.imgLength) {
            $imgAdd.removeClass("ui-hide");
          }
        });
      })
      $imgAdd.before($html);
    }

    if ($(_this.elid + ' .scene-img-item').length >= _this.imgLength) {
      $imgAdd.addClass("ui-hide");
    }
  }

  this.readonly = function () {
    $(_this.elid + ' #imgAdd').addClass("ui-hide");

    $(_this.elid + ' .scene-img-box').not('#imgAdd').each(function () {
      $(this).off().tap(ToClick, function () {
        var img = $(this).find('img').attr('src');
        ImgPreview(img);
      });
    })
  }


  this.editable = function () {
    if ($(_this.elid + ' .scene-img-item').length < _this.imgLength) {
      $(_this.elid + ' #imgAdd').removeClass("ui-hide");
    }

    $(_this.elid + ' .scene-img-box').not('#imgAdd').each(function () {
      $(this).off().tap(ToClick, function () {
        var img = $(this).find('img').attr('src');
        ImgPreview(img, $(this), function () {
          if ($(_this.elid + ' .scene-img-item').length < _this.imgLength) {
            $(_this.elid + ' #imgAdd').removeClass("ui-hide");
          }
        });
      });
    })
  }


  this.imgClean = function () {
    $(_this.elid + ' .scene-img-box').not('#imgAdd').remove();
  }

  this.getData = function () {
    var imgPathArray = [];
    $(_this.elid + ' .scene-img-item').each(function () {
      var path;
      if (!$(this).attr("src") || $(this).attr("src") == "Img/ico_addPhoto@2x.png") {
        path = ""
      } else {
        path = $(this).attr("src");
      }
      imgPathArray.push(path);
    })

    var imgPathString = JSON.stringify(imgPathArray);
    return imgPathString;
  }
}