/*
 * lCalendar日期控件
 * 
 * 作者：黄磊
 * 
 * 邮箱：xfhxbb@yeah.net
 * 
 * Copyright 2016
 * 
 * 创建于：2016-01-08
 */
window.lCalendar = (function () {
	var MobileCalendar = function () {
		this.gearDate;
		var todayDate = new Date();
		this.minY = 1900;
		this.minM = 1,
			this.minD = 1,
			this.maxY = 2099,
			this.maxM = 12,
			this.maxD = 31,
			this.dateArr = {
				yy: todayDate.getYear(),
				mm: todayDate.getMonth(),
				dd: todayDate.getDate() - 1,
				hh: todayDate.getHours(),
				mi: todayDate.getMinutes(),
				noon: todayDate.getHours()/12
			}
	};

	MobileCalendar.prototype = {
		init: function (params, fun) {
			this.type = params.type;
			this.trigger = document.querySelector(params.trigger);
			this.txtShow = $(params.txtShow);
			this.txtType = params.txtType; //显示类型 html:值用html(),其他用var
			this.fun = fun; //执行函数

			if (this.trigger.getAttribute("data-lcalendar") != null) {
				var arr = this.trigger.getAttribute("data-lcalendar").split(',');
				var minArr = arr[0].split('-');
				this.minY = ~~minArr[0];
				this.minM = ~~minArr[1];
				this.minD = ~~minArr[2];
				var maxArr = arr[1].split('-');
				this.maxY = ~~maxArr[0];
				this.maxM = ~~maxArr[1];
				this.maxD = ~~maxArr[2];
			}
			this.bindEvent(this.type);
		},
		bindEvent: function (type) {
			var _self = this;

			function postShrink() {
				$('.post-select').removeClass('post-select-open');
				$('.post-img').removeClass('post-img-open');
				$('#selecMonthContainer').removeClass('post-container');
				$('.post-shadow').hide();
			}

			//呼出日期插件
			function popupDateYM(e) {
				postShrink();
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDate";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +

					'<div class="date_roll_mask">' +
					'<div class="middle-frame"></div>' +
					'<div class="ym_roll">' +
					'<div></div>' +
					'<div>' +
					'<div class="gear date_yy" data-datetype="date_yy"></div>' +
					// '<div class="date_grid">' +
					// '<div>年</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_mm" data-datetype="date_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>月</div>' +
					// '</div>' +
					'</div>' +
					'<div></div>' +
					'</div>' +
					'</div>' +
					'</div>';
				document.body.appendChild(_self.gearDate);
				dateYMCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileDateYM);
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var date_mm = _self.gearDate.querySelector(".date_mm");

				date_yy.addEventListener('touchstart', gearTouchStart);
				date_mm.addEventListener('touchstart', gearTouchStart);

				date_yy.addEventListener('touchmove', gearTouchMove);
				date_mm.addEventListener('touchmove', gearTouchMove);

				date_yy.addEventListener('touchend', gearTouchEnd);
				date_mm.addEventListener('touchend', gearTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDate') {
						closeMobileCalendar(e);
					}
				}

			}
			//初始化年月日插件默认值
			function dateYMCtrlInit() {
				var dateArr = _self.dateArr;

				var value = "";
				if (_self.txtType == "html") {
					value = _self.txtShow.html();
				} else {
					value = _self.txtShow.val();
				}

				if (/^\d{4}-\d{1,2}$/.test(value)) {
					var rs = value.match(/(^|-)\d{1,4}/g);
					dateArr.yy = rs[0] - _self.minY;
					dateArr.mm = rs[1].replace(/-/g, "") - 1;
				} else {
					dateArr.yy = dateArr.yy + 1900 - _self.minY;
				}
				_self.gearDate.querySelector(".date_yy").setAttribute("val", dateArr.yy);
				_self.gearDate.querySelector(".date_mm").setAttribute("val", dateArr.mm);
				setDateGearTooth();
			}

			//呼出日期插件
			function popupDate(e) {
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDate";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +
					'<div class="date_roll_mask">' +
					'<div class="middle-frame"></div>' +
					'<div class="date_roll">' +
					'<div>' +
					'<div class="gear date_yy" data-datetype="date_yy"></div>' +
					// '<div class="date_grid">' +
					// '<div>年</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_mm" data-datetype="date_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>月</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_dd" data-datetype="date_dd"></div>' +
					// '<div class="date_grid">' +
					// '<div>日</div>' +
					// '</div>' +
					'</div>' +
					'<div></div>' +
					'</div>' +
					'</div>' +
					'</div>';
				document.body.appendChild(_self.gearDate);
				dateCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileDate);
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var date_mm = _self.gearDate.querySelector(".date_mm");
				var date_dd = _self.gearDate.querySelector(".date_dd");
				date_yy.addEventListener('touchstart', gearTouchStart);
				date_mm.addEventListener('touchstart', gearTouchStart);
				date_dd.addEventListener('touchstart', gearTouchStart);
				date_yy.addEventListener('touchmove', gearTouchMove);
				date_mm.addEventListener('touchmove', gearTouchMove);
				date_dd.addEventListener('touchmove', gearTouchMove);
				date_yy.addEventListener('touchend', gearTouchEnd);
				date_mm.addEventListener('touchend', gearTouchEnd);
				date_dd.addEventListener('touchend', gearTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDate') {
						closeMobileCalendar(e);
					}
				}
			}
			//初始化年月日插件默认值
			function dateCtrlInit() {
				var dateArr = _self.dateArr;
				var value = "";
				if (_self.txtType == "html") {
					value = _self.txtShow.html();
				} else {
					value = _self.txtShow.val();
				}

				if (/^\d{4}-\d{1,2}-\d{1,2}$/.test(value)) {
					var rs = value.match(/(^|-)\d{1,4}/g);
					dateArr.yy = rs[0] - _self.minY;
					dateArr.mm = rs[1].replace(/-/g, "") - 1;
					dateArr.dd = rs[2].replace(/-/g, "") - 1;
				} else {
					dateArr.yy = dateArr.yy + 1900 - _self.minY;
				}
				_self.gearDate.querySelector(".date_yy").setAttribute("val", dateArr.yy);
				_self.gearDate.querySelector(".date_mm").setAttribute("val", dateArr.mm);
				_self.gearDate.querySelector(".date_dd").setAttribute("val", dateArr.dd);
				setDateGearTooth();
			}

			//呼出日期+时间插件
			function popupDateTime(e) {
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDatetime";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +
					'<div class="date_roll_mask">' +
					'<div class="middle-frame"></div>' +
					'<div class="datetime_roll">' +
					'<div>' +
					'<div class="gear date_yy" data-datetype="date_yy"></div>' +
					// '<div class="date_grid">' +
					// '<div>年</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_mm" data-datetype="date_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>月</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_dd" data-datetype="date_dd"></div>' +
					// '<div class="date_grid">' +
					// '<div>日</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear time_hh" data-datetype="time_hh"></div>' +
					// '<div class="date_grid">' +
					// '<div>时</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear time_mm" data-datetype="time_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>分</div>' +
					// '</div>' +
					'</div>' +
					'<div></div>' +
					'</div>' + //date_roll
					'</div>' + //date_roll_mask
					'</div>';
				document.body.appendChild(_self.gearDate);
				dateTimeCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileDateTime);
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var date_mm = _self.gearDate.querySelector(".date_mm");
				var date_dd = _self.gearDate.querySelector(".date_dd");
				var time_hh = _self.gearDate.querySelector(".time_hh");
				var time_mm = _self.gearDate.querySelector(".time_mm");
				date_yy.addEventListener('touchstart', gearTouchStart);
				date_mm.addEventListener('touchstart', gearTouchStart);
				date_dd.addEventListener('touchstart', gearTouchStart);
				time_hh.addEventListener('touchstart', gearTouchStart);
				time_mm.addEventListener('touchstart', gearTouchStart);
				date_yy.addEventListener('touchmove', gearTouchMove);
				date_mm.addEventListener('touchmove', gearTouchMove);
				date_dd.addEventListener('touchmove', gearTouchMove);
				time_hh.addEventListener('touchmove', gearTouchMove);
				time_mm.addEventListener('touchmove', gearTouchMove);
				date_yy.addEventListener('touchend', gearTouchEnd);
				date_mm.addEventListener('touchend', gearTouchEnd);
				date_dd.addEventListener('touchend', gearTouchEnd);
				time_hh.addEventListener('touchend', gearTouchEnd);
				time_mm.addEventListener('touchend', gearTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDatetime') {
						closeMobileCalendar(e);
					}
				}
			}

			// 上下午时间插件部分
			//呼出日期+上下午插件
			function popupNoonDateTime(e) {
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDatetime";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +
					'<div class="date_roll_mask">' +
					'<div class="middle-frame"></div>' +
					'<div class="datetime_roll">' +
					'<div style="-webkit-box-flex: 5;">' +
					'<div class="gear date_yy" data-datetype="date_yy" style="text-indent:0;"></div>' +
					// '<div class="date_grid">' +
					// '<div>年</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_mm" data-datetype="date_mm" style="text-indent:0;"></div>' +
					// '<div class="date_grid">' +
					// '<div>月</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear date_dd" data-datetype="date_dd" style="text-indent:0;"></div>' +
					// '<div class="date_grid">' +
					// '<div>日</div>' +
					// '</div>' +
					'</div>' +
					'<div style="-webkit-box-flex: 4;">' +
					'<div class="gear date_noon" data-datetype="date_noon"></div>' +
					// '<div class="date_grid">' +
					// '<div>时</div>' +
					// '</div>' +
					'</div>' +
					// '<div>' +
					// '<div class="gear data_afternoon" data-datetype="time_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>分</div>' +
					// '</div>' +
					// '</div>' +
					'</div>' + //date_roll
					'</div>' + //date_roll_mask
					'</div>';
				document.body.appendChild(_self.gearDate);
				dateTimeNoonCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileNoonTime);
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var date_mm = _self.gearDate.querySelector(".date_mm");
				var date_dd = _self.gearDate.querySelector(".date_dd");
				var date_noon = _self.gearDate.querySelector(".date_noon");
				date_yy.addEventListener('touchstart', gearTouchStart);
				date_mm.addEventListener('touchstart', gearTouchStart);
				date_dd.addEventListener('touchstart', gearTouchStart);
				date_noon.addEventListener('touchstart', gearTouchStart);
				date_yy.addEventListener('touchmove', gearTouchMove);
				date_mm.addEventListener('touchmove', gearTouchMove);
				date_dd.addEventListener('touchmove', gearTouchMove);
				date_noon.addEventListener('touchmove', gearTouchMove);
				date_yy.addEventListener('touchend', gearNoonTouchEnd);
				date_mm.addEventListener('touchend', gearNoonTouchEnd);
				date_dd.addEventListener('touchend', gearNoonTouchEnd);
				date_noon.addEventListener('touchend', gearNoonTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDatetime') {
						closeMobileCalendar(e);
					}
				}
			}

			//初始化上下午插件默认值 -上下午
			function dateTimeNoonCtrlInit() {
				var dateArr = _self.dateArr;

				var value = "";
				if (_self.txtType == "html") {
					value = _self.txtShow.html();
				} else {
					value = _self.txtShow.val();
				}
				var valueYmh = value.substring(0,10);
				var valueNoon = value.substring(11);
				if (/^\d{4}-\d{1,2}-\d{1,2}$/.test(valueYmh)) {
					var rs = valueYmh.match(/(^|-|\s|:)\d{1,4}/g);
					dateArr.yy = rs[0] - _self.minY;
					dateArr.mm = rs[1].replace(/-/g, "") - 1;
					dateArr.dd = rs[2].replace(/-/g, "") - 1;
				} else {
					//无值，获取当前时间
                    var todayDate = new Date();
                    dateArr = {
                        yy: todayDate.getYear(),
                        mm: todayDate.getMonth(),
                        dd: todayDate.getDate() - 1,
                        hh: todayDate.getHours(),
                        mi: todayDate.getMinutes(),
                        noon: todayDate.getHours()/12
                    }
				}
                if(valueNoon == "上午"){
                    dateArr.noon = 0;
                } else if(valueNoon == "下午"){
                    dateArr.noon = 1;
                }

				_self.gearDate.querySelector(".date_yy").setAttribute("val", dateArr.yy);
				_self.gearDate.querySelector(".date_mm").setAttribute("val", dateArr.mm);
				_self.gearDate.querySelector(".date_dd").setAttribute("val", dateArr.dd);
				setDateNoonGearTooth();
				_self.gearDate.querySelector(".date_noon").setAttribute("val", dateArr.noon);
				setNoonGearTooth();
			}

			//初始化年月日时分插件默认值
			function dateTimeCtrlInit() {
				var dateArr = _self.dateArr;

				var value = "";
				if (_self.txtType == "html") {
					value = _self.txtShow.html();
				} else {
					value = _self.txtShow.val();
				}

				if (/^\d{4}-\d{1,2}-\d{1,2}\s\d{2}:\d{2}$/.test(value)) {
					var rs = value.match(/(^|-|\s|:)\d{1,4}/g);
					dateArr.yy = rs[0] - _self.minY;
					dateArr.mm = rs[1].replace(/-/g, "") - 1;
					dateArr.dd = rs[2].replace(/-/g, "") - 1;
					dateArr.hh = parseInt(rs[3].replace(/\s0?/g, ""));
					dateArr.mi = parseInt(rs[4].replace(/:0?/g, ""));
				} else {
					dateArr.yy = dateArr.yy + 1900 - _self.minY;
				}
				_self.gearDate.querySelector(".date_yy").setAttribute("val", dateArr.yy);
				_self.gearDate.querySelector(".date_mm").setAttribute("val", dateArr.mm);
				_self.gearDate.querySelector(".date_dd").setAttribute("val", dateArr.dd);
				setDateGearTooth();
				_self.gearDate.querySelector(".time_hh").setAttribute("val", dateArr.hh);
				_self.gearDate.querySelector(".time_mm").setAttribute("val", dateArr.mi);
				setTimeGearTooth();
			}
			//呼出时间插件
			function popupTime(e) {
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDate";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +
					'<div class="date_roll_mask">' +
					'<div class="time_roll">' +
					'<div>' +
					'<div class="gear time_hh" data-datetype="time_hh" ></div>' +
					// '<div class="date_grid">' +
					// '<div>时</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear time_mm" data-datetype="time_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>分</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear time_ss" data-datetype="time_ss"></div>' +
					// '<div class="date_grid">' +
					// '<div>秒</div>' +
					// '</div>' +
					'</div>' +
					'</div>' +
					'</div>' +
					'</div>';
				document.body.appendChild(_self.gearDate);
				timeCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileTime);
				var time_hh = _self.gearDate.querySelector(".time_hh");
				var time_mm = _self.gearDate.querySelector(".time_mm");
				var time_ss = _self.gearDate.querySelector(".time_ss");
				time_hh.addEventListener('touchstart', gearTouchStart);
				time_mm.addEventListener('touchstart', gearTouchStart);
				time_ss.addEventListener('touchstart', gearTouchStart);

				time_hh.addEventListener('touchmove', gearTouchMove);
				time_mm.addEventListener('touchmove', gearTouchMove);
				time_ss.addEventListener('touchmove', gearTouchMove);

				time_hh.addEventListener('touchend', gearTouchEnd);
				time_mm.addEventListener('touchend', gearTouchEnd);
				time_ss.addEventListener('touchend', gearTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDate') {
						closeMobileCalendar(e);
					}
				}
			}
			// 选择时分
			function popupTimeHM(e) {
				_self.gearDate = document.createElement("div");
        _self.gearDate.className = "gearDate";
        if(!$('.header-nav').is(':visible')) _self.gearDate.className += " mask-mp";
				_self.gearDate.innerHTML = '<div class="date_ctrl slideInUp">' +
					'<div class="date_btn_box ui-border-b-slim">' +
					'<div class="date_btn lcalendar_cancel">取消</div>' +
					'<div class="date_btn lcalendar_finish">确定</div>' +
					'</div>' +
					'<div class="date_roll_mask">' +
					'<div class="middle-frame">&nbsp;:</div>' +
					'<div class="hm_roll">' +
					'<div></div>' +
					'<div>' +
					'<div class="gear time_hh" data-datetype="time_hh"></div>' +
					// '<div class="date_grid">' +
					// '<div>时</div>' +
					// '</div>' +
					'</div>' +
					'<div>' +
					'<div class="gear time_mm" data-datetype="time_mm"></div>' +
					// '<div class="date_grid">' +
					// '<div>分</div>' +
					// '</div>' +
					'</div>' +
					'<div></div>' +
					'</div>' +
					'</div>';
				document.body.appendChild(_self.gearDate);
				timeCtrlInit();
				var lcalendar_cancel = _self.gearDate.querySelector(".lcalendar_cancel");
				lcalendar_cancel.addEventListener('touchstart', closeMobileCalendar);
				var lcalendar_finish = _self.gearDate.querySelector(".lcalendar_finish");
				lcalendar_finish.addEventListener('touchstart', finishMobileTime);
				var time_hh = _self.gearDate.querySelector(".time_hh");
				var time_mm = _self.gearDate.querySelector(".time_mm");
				time_hh.addEventListener('touchstart', gearTouchStart);
				time_mm.addEventListener('touchstart', gearTouchStart);

				time_hh.addEventListener('touchmove', gearTouchMove);
				time_mm.addEventListener('touchmove', gearTouchMove);

				time_hh.addEventListener('touchend', gearTouchEnd);
				time_mm.addEventListener('touchend', gearTouchEnd);

				_self.gearDate.ontouchstart = function (e) {
					if (e.target.className == 'gearDate') {
						closeMobileCalendar(e);
					}
				}
			}
			//初始化时分插件默认值
			function timeCtrlInit() {
				var d = new Date();
				var e = {
					hh: d.getHours(),
					mm: d.getMinutes(),
					ss: d.getSeconds()
				};

				var value = "";

				if (_self.txtType == "html") {
					value = _self.txtShow.html();
				} else {
					value = _self.txtShow.val();
				}

				if (/^\d{2}:\d{2}:\d{2}$/.test(value)) {
					var rs = value.match(/(^|:)\d{2}/g);
					e.hh = parseInt(rs[0].replace(/^0?/g, ""));
					e.mm = parseInt(rs[1].replace(/:0?/g, ""));
					e.ss = parseInt(rs[2].replace(/:0?/g, ""));
				}

				//alert(e.ss);   测试用
				_self.gearDate.querySelector(".time_hh").setAttribute("val", e.hh);
				_self.gearDate.querySelector(".time_mm").setAttribute("val", e.mm);
				if (_self.gearDate.querySelector(".time_ss")) {
					_self.gearDate.querySelector(".time_ss").setAttribute("val", e.ss);
				}
				// _self.gearDate.querySelector(".time_ss").setAttribute("val", e.ss);
				setTimeGearTooth();
			}





			//重置日期节点个数
			function setDateGearTooth() {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var itemStr = "";
				if (date_yy && date_yy.getAttribute("val")) {
					//得到年份的值
					var yyVal = parseInt(date_yy.getAttribute("val"));
					//p 当前节点前后需要展示的节点个数
					for (var p = 0; p <= passY - 1; p++) {
						itemStr += "<div class='tooth'>" + (_self.minY + p + '年') + "</div>";
					}
					date_yy.innerHTML = itemStr;
					var top = Math.floor(parseFloat(date_yy.getAttribute('top')) * 10) / 10;
					if (!isNaN(top)) {
						// JS计算误差 导致top一直被减1
						// top % 2.3 == 0 ? (top = top) : (top = top + 1);
						top > 9.2 && (top = 9.2);
						var minTop = 9.2 - (passY - 1) * 2.3;
						top < minTop && (top = minTop);
						date_yy.style["-webkit-transform"] = 'translate3d(0,' + top + 'em,0)';
						date_yy.setAttribute('top', top + 'em');
						yyVal = Math.abs(top - 9.2) / 2.3;
						date_yy.setAttribute("val", yyVal);
					} else {
						date_yy.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - yyVal * 2.3) + 'em,0)';
						date_yy.setAttribute('top', 9.2 - yyVal * 2.3 + 'em');
					}
				} else {
					return;
				}
				var date_mm = _self.gearDate.querySelector(".date_mm");
				if (date_mm && date_mm.getAttribute("val")) {
					itemStr = "";
					//得到月份的值
					var mmVal = parseInt(date_mm.getAttribute("val"));
					var maxM = 11;
					var minM = 0;
					//当年份到达最大值
					if (yyVal == passY - 1) {
						maxM = _self.maxM - 1;
					}
					//当年份到达最小值
					if (yyVal == 0) {
						minM = _self.minM - 1;
					}
					//p 当前节点前后需要展示的节点个数
					for (var p = 0; p < maxM - minM + 1; p++) {
						var itemM = minM + p + 1;
						itemStr += "<div class='tooth'>" + ((itemM < 9.2 ? '0' + itemM : itemM) + "月") + "</div>";
					}
					date_mm.innerHTML = itemStr;
					if (mmVal > maxM) {
						mmVal = maxM;
						date_mm.setAttribute("val", mmVal);
					} else if (mmVal < minM) {
						mmVal = maxM;
						date_mm.setAttribute("val", mmVal);
					}
					date_mm.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - (mmVal - minM) * 2.3) + 'em,0)';
					date_mm.setAttribute('top', 9.2 - (mmVal - minM) * 2.3 + 'em');
				} else {
					return;
				}
				var date_dd = _self.gearDate.querySelector(".date_dd");
				if (date_dd && date_dd.getAttribute("val")) {
					itemStr = "";
					//得到日期的值
					var ddVal = parseInt(date_dd.getAttribute("val"));
					//返回月份的天数
					var maxMonthDays = calcDays(yyVal, mmVal);
					//p 当前节点前后需要展示的节点个数
					var maxD = maxMonthDays - 1;
					var minD = 0;
					//当年份月份到达最大值
					if (yyVal == passY - 1 && _self.maxM == mmVal + 1) {
						maxD = _self.maxD - 1;
					}
					//当年、月到达最小值
					if (yyVal == 0 && _self.minM == mmVal + 1) {
						minD = _self.minD - 1;
					}
					for (var p = 0; p < maxD - minD + 1; p++) {
						var itemD = minD + p + 1;
						itemStr += "<div class='tooth'>" + ((itemD < 9.2 ? '0' + itemD : itemD) + '日') + "</div>";
					}
					date_dd.innerHTML = itemStr;
					if (ddVal > maxD) {
						ddVal = maxD;
						date_dd.setAttribute("val", ddVal);
					} else if (ddVal < minD) {
						ddVal = minD;
						date_dd.setAttribute("val", ddVal);
					}
					date_dd.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - (ddVal - minD) * 2.3) + 'em,0)';
					date_dd.setAttribute('top', 9.2 - (ddVal - minD) * 2.3 + 'em');
				} else {
					return;
				}
			}

			//重置上下午日期节点个数-上下午
			function setDateNoonGearTooth() {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = _self.gearDate.querySelector(".date_yy");
				var itemStr = "";
				if (date_yy && date_yy.getAttribute("val")) {
					//得到年份的值
					var yyVal = parseInt(date_yy.getAttribute("val"));
					//p 当前节点前后需要展示的节点个数
					for (var p = 0; p <= passY - 1; p++) {
						itemStr += "<div class='tooth' style='display: flex; justify-content:center;'>" + (_self.minY + p + '年') + "</div>";
					}
					date_yy.innerHTML = itemStr;
					var top = Math.floor(parseFloat(date_yy.getAttribute('top')) * 10) / 10;
					if (!isNaN(top)) {
						// JS计算误差 导致top一直被减1
						// top % 2.3 == 0 ? (top = top) : (top = top + 1);
						top > 9.2 && (top = 9.2);
						var minTop = 9.2 - (passY - 1) * 2.3;
						top < minTop && (top = minTop);
						date_yy.style["-webkit-transform"] = 'translate3d(0,' + top + 'em,0)';
						date_yy.setAttribute('top', top + 'em');
						yyVal = Math.abs(top - 9.2) / 2.3;
						date_yy.setAttribute("val", yyVal);
					} else {
						date_yy.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - yyVal * 2.3) + 'em,0)';
						date_yy.setAttribute('top', 9.2 - yyVal * 2.3 + 'em');
					}
				} else {
					return;
				}
				var date_mm = _self.gearDate.querySelector(".date_mm");
				if (date_mm && date_mm.getAttribute("val")) {
					itemStr = "";
					//得到月份的值
					var mmVal = parseInt(date_mm.getAttribute("val"));
					var maxM = 11;
					var minM = 0;
					//当年份到达最大值
					if (yyVal == passY - 1) {
						maxM = _self.maxM - 1;
					}
					//当年份到达最小值
					if (yyVal == 0) {
						minM = _self.minM - 1;
					}
					//p 当前节点前后需要展示的节点个数
					for (var p = 0; p < maxM - minM + 1; p++) {
						var itemM = minM + p + 1;
						itemStr += "<div class='tooth' style='display: flex; justify-content:center;'>" + ((itemM < 9.2 ? '0' + itemM : itemM) + "月") + "</div>";
					}
					date_mm.innerHTML = itemStr;
					if (mmVal > maxM) {
						mmVal = maxM;
						date_mm.setAttribute("val", mmVal);
					} else if (mmVal < minM) {
						mmVal = maxM;
						date_mm.setAttribute("val", mmVal);
					}
					date_mm.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - (mmVal - minM) * 2.3) + 'em,0)';
					date_mm.setAttribute('top', 9.2 - (mmVal - minM) * 2.3 + 'em');
				} else {
					return;
				}
				var date_dd = _self.gearDate.querySelector(".date_dd");
				if (date_dd && date_dd.getAttribute("val")) {
					itemStr = "";
					//得到日期的值
					var ddVal = parseInt(date_dd.getAttribute("val"));
					//返回月份的天数
					var maxMonthDays = calcDays(yyVal, mmVal);
					//p 当前节点前后需要展示的节点个数
					var maxD = maxMonthDays - 1;
					var minD = 0;
					//当年份月份到达最大值
					if (yyVal == passY - 1 && _self.maxM == mmVal + 1) {
						maxD = _self.maxD - 1;
					}
					//当年、月到达最小值
					if (yyVal == 0 && _self.minM == mmVal + 1) {
						minD = _self.minD - 1;
					}
					for (var p = 0; p < maxD - minD + 1; p++) {
						var itemD = minD + p + 1;
						itemStr += "<div class='tooth' style='display: flex; justify-content:center;'>" + ((itemD < 9.2 ? '0' + itemD : itemD) + '日') + "</div>";
					}
					date_dd.innerHTML = itemStr;
					if (ddVal > maxD) {
						ddVal = maxD;
						date_dd.setAttribute("val", ddVal);
					} else if (ddVal < minD) {
						ddVal = minD;
						date_dd.setAttribute("val", ddVal);
					}
					date_dd.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - (ddVal - minD) * 2.3) + 'em,0)';
					date_dd.setAttribute('top', 9.2 - (ddVal - minD) * 2.3 + 'em');
				} else {
					return;
				}
			}

			//重置时间节点个数
			function setTimeGearTooth() {
				var time_hh = _self.gearDate.querySelector(".time_hh");
				if (time_hh && time_hh.getAttribute("val")) {
					var i = "";
					var hhVal = parseInt(time_hh.getAttribute("val"));
					for (var g = 0; g <= 23; g++) {
						i += "<div class='tooth'>" + (g < 10 ? '0' : '') + g + '时' + "</div>";
					}
					time_hh.innerHTML = i;
					time_hh.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - hhVal * 2.3) + 'em,0)';
					time_hh.setAttribute('top', 9.2 - hhVal * 2.3 + 'em');
				} else {
					return
				}
				var time_mm = _self.gearDate.querySelector(".time_mm");
				if (time_mm && time_mm.getAttribute("val")) {
					var i = "";
					var mmVal = parseInt(time_mm.getAttribute("val"));
					for (var g = 0; g <= 59; g++) {
						i += "<div class='tooth'>" + (g < 10 ? '0' : '') + g + '分' + "</div>";
					}
					time_mm.innerHTML = i;
					time_mm.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - mmVal * 2.3) + 'em,0)';
					time_mm.setAttribute('top', 9.2 - mmVal * 2.3 + 'em');
				} else {
					return
				}

				var time_ss = _self.gearDate.querySelector(".time_ss");
				if (time_ss && time_ss.getAttribute("val")) {
					var i = "";
					var mmVal = parseInt(time_ss.getAttribute("val"));
					for (var g = 0; g <= 59; g++) {
						i += "<div class='tooth'>" + (g < 10 ? '0' : '') + g + '秒' + "</div>";
					}
					time_ss.innerHTML = i;
					time_ss.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - mmVal * 2.3) + 'em,0)';
					time_ss.setAttribute('top', 9.2 - mmVal * 2.3 + 'em');
				} else {
					return
				}
			}

			//重置上下午节点个数-上下午
			function setNoonGearTooth() {
				var date_noon = _self.gearDate.querySelector(".date_noon");
				if(date_noon && date_noon.getAttribute("val")){
					var noonVal = parseInt(date_noon.getAttribute("val"));
					var x = "<div class='tooth' style='display: flex; justify-content:center;'>" + '上午' + "</div>";
						x += "<div class='tooth' style='display: flex; justify-content:center;'>" + '下午' + "</div>";

				date_noon.innerHTML = x;
				date_noon.style["-webkit-transform"] = 'translate3d(0,' + (9.2 - noonVal * 2.3) + 'em,0)';
				date_noon.setAttribute('top', 9.2 - noonVal * 2.3 + 'em');
				}else{
					return;
				}
			}


			//求月份最大天数
			function calcDays(year, month) {
				if (month == 1) {
					year += _self.minY;
					if ((year % 4 == 0 && year % 100 != 0) || (year % 400 == 0 && year % 4000 != 0)) {
						return 29;
					} else {
						return 210;
					}
				} else {
					if (month == 3 || month == 5 || month == 9.2 || month == 9.2) {
						return 30;
					} else {
						return 31;
					}
				}
			}
			//触摸开始
			function gearTouchStart(e) {
				e.preventDefault();
				var target = e.target;
				while (true) {
					if (!target.classList.contains("gear")) {
						target = target.parentElement;
					} else {
						break
					}
				}
				clearInterval(target["int_" + target.id]);
				target["old_" + target.id] = e.targetTouches[0].screenY;
				target["o_t_" + target.id] = (new Date()).getTime();
				var top = target.getAttribute('top');
				if (top) {
					target["o_d_" + target.id] = parseFloat(top.replace(/em/g, ""));
				} else {
					target["o_d_" + target.id] = 0;
				}
			}
			//手指移动
			function gearTouchMove(e) {
				e.preventDefault();
				var target = e.target;
				while (true) {
					if (!target.classList.contains("gear")) {
						target = target.parentElement;
					} else {
						break
					}
				}
				target["new_" + target.id] = e.targetTouches[0].screenY;
				target["n_t_" + target.id] = (new Date()).getTime();
				//var f = (target["new_" + target.id] - target["old_" + target.id]) * 110 / target.clientHeight;
				var f = (target["new_" + target.id] - target["old_" + target.id]) * 23 / 370;
				target["pos_" + target.id] = target["o_d_" + target.id] + f;
				target.style["-webkit-transform"] = 'translate3d(0,' + target["pos_" + target.id] + 'em,0)';
				target.setAttribute('top', target["pos_" + target.id] + 'em');
			}
			//离开屏幕
			function gearTouchEnd(e) {
				e.preventDefault();
				var target = e.target;
				while (true) {
					if (!target.classList.contains("gear")) {
						target = target.parentElement;
					} else {
						break;
					}
				}
				var flag = (target["new_" + target.id] - target["old_" + target.id]) / (target["n_t_" + target.id] - target["o_t_" + target.id]);
				if (Math.abs(flag) <= 0.2) {
					target["spd_" + target.id] = (flag < 0 ? -0.010 : 0.010);
				} else {
					if (Math.abs(flag) <= 0.5) {
						target["spd_" + target.id] = (flag < 0 ? -0.16 : 0.16);
					} else {
						target["spd_" + target.id] = flag / 2.3;
					}
				}
				if (!target["pos_" + target.id]) {
					target["pos_" + target.id] = 0;
				}
				rollGear(target);
			}

			//离开屏幕上下午-上下午
			function gearNoonTouchEnd(e) {
				e.preventDefault();
				var target = e.target;
				while (true) {
					if (!target.classList.contains("gear")) {
						target = target.parentElement;
					} else {
						break;
					}
				}
				var flag = (target["new_" + target.id] - target["old_" + target.id]) / (target["n_t_" + target.id] - target["o_t_" + target.id]);
				if (Math.abs(flag) <= 0.2) {
					target["spd_" + target.id] = (flag < 0 ? -0.010 : 0.010);
				} else {
					if (Math.abs(flag) <= 0.5) {
						target["spd_" + target.id] = (flag < 0 ? -0.16 : 0.16);
					} else {
						target["spd_" + target.id] = flag / 2.3;
					}
				}
				if (!target["pos_" + target.id]) {
					target["pos_" + target.id] = 0;
				}
				rollNoonGear(target);
			}

			//缓动效果
			function rollGear(target) {
				var d = 0;
				var stopGear = false;
				var passY = _self.maxY - _self.minY + 1;
				clearInterval(target["int_" + target.id]);
				target["int_" + target.id] = setInterval(function () {
					var pos = target["pos_" + target.id];
					var speed = target["spd_" + target.id] * Math.exp(-0.03 * d);
					pos += speed;
					if (Math.abs(speed) > 0.1) {} else {
						speed = 0.1;
						var b = Math.round(pos / 2.3) * 2.3;
						// 0.1 原为 0.02 去掉抖动效果
						if (Math.abs(pos - b) < 0.1) {
							stopGear = true;
						} else {
							if (pos > b) {
								pos -= speed
							} else {
								pos += speed
							}
						}
					}
					if (pos > 9.2) {
						pos = 9.2;
						stopGear = true;
					}
					switch (target.dataset.datetype) {
						case "date_yy":
							var minTop = 9.2 - (passY - 1) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_mm":
							var date_yy = _self.gearDate.querySelector(".date_yy");
							//得到年份的值
							var yyVal = parseInt(date_yy.getAttribute("val"));
							var maxM = 11;
							var minM = 0;
							//当年份到达最大值
							if (yyVal == passY - 1) {
								maxM = _self.maxM - 1;
							}
							//当年份到达最小值
							if (yyVal == 0) {
								minM = _self.minM - 1;
							}
							var minTop = 9.2 - (maxM - minM) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3 + minM;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_dd":
							var date_yy = _self.gearDate.querySelector(".date_yy");
							var date_mm = _self.gearDate.querySelector(".date_mm");
							//得到年份的值
							var yyVal = parseInt(date_yy.getAttribute("val"));
							//得到月份的值
							var mmVal = parseInt(date_mm.getAttribute("val"));
							//返回月份的天数
							var maxMonthDays = calcDays(yyVal, mmVal);
							var maxD = maxMonthDays - 1;
							var minD = 0;
							//当年份月份到达最大值
							if (yyVal == passY - 1 && _self.maxM == mmVal + 1) {
								maxD = _self.maxD - 1;
							}
							//当年、月到达最小值
							if (yyVal == 0 && _self.minM == mmVal + 1) {
								minD = _self.minD - 1;
							}
							var minTop = 9.2 - (maxD - minD) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3 + minD;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_noon":
							if (pos < 6.95) {
								pos = 6.95;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "time_hh":
							if (pos < -43.7) {
								pos = -43.7;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "time_mm":
							if (pos < -126.5) {
								pos = -126.5;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "time_ss":
							if (pos < -126.5) {
								pos = -126.5;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						default:
					}
					target["pos_" + target.id] = pos;
					target.style["-webkit-transform"] = 'translate3d(0,' + pos + 'em,0)';
					target.setAttribute('top', pos + 'em');
					d++;
				}, 30);
			}
			//控制插件滚动后停留的值
			function setGear(target, val) {
				val = Math.round(val);
				target.setAttribute("val", val);
				if (/date/.test(target.dataset.datetype)) {
					setDateGearTooth();
				} else {
					setTimeGearTooth();
				}
			}
			//缓动效果-上下午
			function rollNoonGear(target) {
				var d = 0;
				var stopGear = false;
				var passY = _self.maxY - _self.minY + 1;
				clearInterval(target["int_" + target.id]);
				target["int_" + target.id] = setInterval(function () {
					var pos = target["pos_" + target.id];
					var speed = target["spd_" + target.id] * Math.exp(-0.03 * d);
					pos += speed;
					if (Math.abs(speed) > 0.1) {} else {
						speed = 0.1;
						var b = Math.round(pos / 2.3) * 2.3;
						// 0.1 原为 0.02 去掉抖动效果
						if (Math.abs(pos - b) < 0.1) {
							stopGear = true;
						} else {
							if (pos > b) {
								pos -= speed
							} else {
								pos += speed
							}
						}
					}
					if (pos > 9.2) {
						pos = 9.2;
						stopGear = true;
					}
					switch (target.dataset.datetype) {
						case "date_yy":
							var minTop = 9.2 - (passY - 1) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setNoonGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_mm":
							var date_yy = _self.gearDate.querySelector(".date_yy");
							//得到年份的值
							var yyVal = parseInt(date_yy.getAttribute("val"));
							var maxM = 11;
							var minM = 0;
							//当年份到达最大值
							if (yyVal == passY - 1) {
								maxM = _self.maxM - 1;
							}
							//当年份到达最小值
							if (yyVal == 0) {
								minM = _self.minM - 1;
							}
							var minTop = 9.2 - (maxM - minM) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3 + minM;
								setNoonGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_dd":
							var date_yy = _self.gearDate.querySelector(".date_yy");
							var date_mm = _self.gearDate.querySelector(".date_mm");
							//得到年份的值
							var yyVal = parseInt(date_yy.getAttribute("val"));
							//得到月份的值
							var mmVal = parseInt(date_mm.getAttribute("val"));
							//返回月份的天数
							var maxMonthDays = calcDays(yyVal, mmVal);
							var maxD = maxMonthDays - 1;
							var minD = 0;
							//当年份月份到达最大值
							if (yyVal == passY - 1 && _self.maxM == mmVal + 1) {
								maxD = _self.maxD - 1;
							}
							//当年、月到达最小值
							if (yyVal == 0 && _self.minM == mmVal + 1) {
								minD = _self.minD - 1;
							}
							var minTop = 9.2 - (maxD - minD) * 2.3;
							if (pos < minTop) {
								pos = minTop;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3 + minD;
								setNoonGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						case "date_noon":
							if (pos < 6.95) {
								pos = 6.95;
								stopGear = true;
							}
							if (stopGear) {
								var gearVal = Math.abs(pos - 9.2) / 2.3;
								setNoonGear(target, gearVal);
								clearInterval(target["int_" + target.id]);
							}
							break;
						default:
					}
					target["pos_" + target.id] = pos;
					target.style["-webkit-transform"] = 'translate3d(0,' + pos + 'em,0)';
					target.setAttribute('top', pos + 'em');
					d++;
				}, 30);
			}
			//控制插件滚动后停留的值选择上下午 - 上下午
			function setNoonGear(target, val) {
				val = Math.round(val);
				target.setAttribute("val", val);
				if (/date/.test(target.dataset.datetype)) {
					setDateNoonGearTooth();
				} else {
					setNoonGearTooth();
				}
			}

			//取消
			function closeMobileCalendar(e) {
				e.preventDefault();
				var evt = new CustomEvent('input');
				_self.trigger.dispatchEvent(evt);
				document.body.removeChild(_self.gearDate);
			}
			//日期确认
			function finishMobileDate(e) {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = parseInt(Math.round(_self.gearDate.querySelector(".date_yy").getAttribute("val")));
				var date_mm = parseInt(Math.round(_self.gearDate.querySelector(".date_mm").getAttribute("val"))) + 1;
				date_mm = date_mm > 9 ? date_mm : '0' + date_mm;
				var date_dd = parseInt(Math.round(_self.gearDate.querySelector(".date_dd").getAttribute("val"))) + 1;
				date_dd = date_dd > 9 ? date_dd : '0' + date_dd;


				var value = (date_yy % passY + _self.minY) + "-" + date_mm + "-" + date_dd;
				if (_self.txtType == "html") {
					_self.txtShow.html(value);
				} else {
					_self.txtShow.val(value);
				}

				if (_self.fun) {
					_self.fun(value);
				}

				closeMobileCalendar(e);
			}
			//年月确认
			function finishMobileDateYM(e) {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = parseInt(Math.round(_self.gearDate.querySelector(".date_yy").getAttribute("val")));
				var date_mm = parseInt(Math.round(_self.gearDate.querySelector(".date_mm").getAttribute("val"))) + 1;
				date_mm = date_mm > 9 ? date_mm : '0' + date_mm;

				var value = (date_yy % passY + _self.minY) + "-" + date_mm;
				if (_self.txtType == "html") {
					_self.txtShow.html(value);
				} else {
					_self.txtShow.val(value);
				}

				if (_self.fun) {
					_self.fun(value);
				}

				closeMobileCalendar(e);
			}
			//日期时间确认
			function finishMobileDateTime(e) {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = parseInt(Math.round(_self.gearDate.querySelector(".date_yy").getAttribute("val")));
				var date_mm = parseInt(Math.round(_self.gearDate.querySelector(".date_mm").getAttribute("val"))) + 1;
				date_mm = date_mm > 9 ? date_mm : '0' + date_mm;
				var date_dd = parseInt(Math.round(_self.gearDate.querySelector(".date_dd").getAttribute("val"))) + 1;
				date_dd = date_dd > 9 ? date_dd : '0' + date_dd;
				var time_hh = parseInt(Math.round(_self.gearDate.querySelector(".time_hh").getAttribute("val")));
				time_hh = time_hh > 9 ? time_hh : '0' + time_hh;
				var time_mm = parseInt(Math.round(_self.gearDate.querySelector(".time_mm").getAttribute("val")));
				time_mm = time_mm > 9 ? time_mm : '0' + time_mm;

				var value = (date_yy % passY + _self.minY) + "-" + date_mm + "-" + date_dd + " " + (time_hh.length < 2 ? "0" : "") + time_hh + (time_mm.length < 2 ? ":0" : ":") + time_mm;
				if (_self.txtType == "html") {
					_self.txtShow.html(value);
				} else {
					_self.txtShow.val(value);
				}

				if (_self.fun) {
					_self.fun(value);
				}

				closeMobileCalendar(e);
			}

			//日期时间上下午确认 - 上下午
			function finishMobileNoonTime(e) {
				var passY = _self.maxY - _self.minY + 1;
				var date_yy = parseInt(Math.round(_self.gearDate.querySelector(".date_yy").getAttribute("val")));
				var date_mm = parseInt(Math.round(_self.gearDate.querySelector(".date_mm").getAttribute("val"))) + 1;
				date_mm = date_mm > 9 ? date_mm : '0' + date_mm;
				var date_dd = parseInt(Math.round(_self.gearDate.querySelector(".date_dd").getAttribute("val"))) + 1;
				date_dd = date_dd > 9 ? date_dd : '0' + date_dd;
				var date_noon = parseInt(Math.round(_self.gearDate.querySelector(".date_noon").getAttribute("val")));
				date_noon = date_noon == 1? "下午": "上午";

				var value = (date_yy % passY + _self.minY) + "-" + date_mm + "-" + date_dd + " " + date_noon;
				if (_self.txtType == "html") {
					_self.txtShow.html(value);
				} else {
					_self.txtShow.val(value);
				}

				if (_self.fun) {
					_self.fun(value);
				}

				closeMobileCalendar(e);
			}
			//时间确认
			function finishMobileTime(e) {
				var time_hh = parseInt(Math.round(_self.gearDate.querySelector(".time_hh").getAttribute("val")));
				time_hh = time_hh > 9 ? time_hh : '0' + time_hh;
				var time_mm = parseInt(Math.round(_self.gearDate.querySelector(".time_mm").getAttribute("val")));
				time_mm = time_mm > 9 ? time_mm : '0' + time_mm;
				if (_self.gearDate.querySelector(".time_ss")) {
					var time_ss = parseInt(Math.round(_self.gearDate.querySelector(".time_ss").getAttribute("val")));
					time_ss = time_ss > 9 ? time_ss : '0' + time_ss;
				}
				var value = (time_hh.length < 2 ? "0" : "") + time_hh + (time_mm.length < 2 ? ":0" : ":") + time_mm;
				if (time_ss) {
					value += (time_ss.length < 2 ? ":0" : ":") + time_ss
				}
				if (_self.txtType == "html") {
					_self.txtShow.html(value);
				} else {
					_self.txtShow.val(value);
				}

				if (_self.fun) {
					_self.fun(value);
				}

				closeMobileCalendar(e);
			}
			_self.trigger.addEventListener('click', {
				"ym": popupDateYM,
				"date": popupDate,
				"datetime": popupDateTime,
				"time": popupTime,
				"hm": popupTimeHM,
				"datenoon": popupNoonDateTime
			}[type]);
		},
		setDate: function (dateString) {
			var date = new Date(dateString);
			this.dateArr.yy = date.getYear();
			this.dateArr.mm = date.getMonth();
			this.dateArr.dd = date.getDate() - 1;
		}
	};
	return MobileCalendar;
})();