/**
 * Created by Administrator on 2017-08-18.
 */
//浏览器相关的东西
window.Browser = {
  Versions: function () {
    var u = navigator.userAgent.toLowerCase(),
      app = navigator.appVersion;
    return { //移动终端浏览器版本信息
      IsIpad: u.match(/ipad/i) == "ipad",
      IsIphoneOs: u.match(/iphone os/i) == "iphone os",
      IsIOS: (u.match(/ipad/i) == "ipad" || u.match(/iphone os/i) == "iphone os"),
      IsWeiXin: u.match(/MicroMessenger/i) == "micromessenger",
      IsMidp: u.match(/midp/i) == "midp",
      IsUc7: u.match(/rv:1.2.3.4/i) == "rv:1.2.3.4",
      IsUc7: u.match(/rv:1.2.3.4/i) == "rv:1.2.3.4",
      IsUc: u.match(/ucweb/i) == "ucweb",
      IsAndroid: u.match(/android/i) == "android",
      IsCE: u.match(/windows ce/i) == "windows ce",
      IsWM: u.match(/windows mobile/i) == "windows mobile",
      IsMobile: (u.match(/ipad/i) == "ipad" || u.match(/iphone os/i) == "iphone os" ||
        u.match(/midp/i) == "midp" || u.match(/rv:1.2.3.4/i) == "rv:1.2.3.4" || u.match(/rv:1.2.3.4/i) == "rv:1.2.3.4" ||
        u.match(/ucweb/i) == "ucweb" || u.match(/android/i) == "android" || u.match(/windows ce/i) == "windows ce" ||
        u.match(/windows mobile/i) == "windows mobile"),
      IsMiniProgram: u.match(/miniprogram/i) == "miniprogram"
    };
  }(),
  Device: navigator.userAgent.toLowerCase() + '|' + navigator.appVersion + '|' + (navigator.browserLanguage || navigator.language).toLowerCase(),
  Language: (navigator.browserLanguage || navigator.language).toLowerCase(),
  Url: function (Tab) {
    //0:完整地址(含参数)
    //1:完整地址(不含参数)
    //2:主机地址(含http://)
    var curWwwPath = window.document.location.href;
    //获取主机地址之后的目录，如： cis/website/meun.htm
    var pathName = window.document.location.pathname;
    var pos = curWwwPath.indexOf(pathName); //获取主机地址，如： http://localhost:8080
    var localhostPaht = curWwwPath.substring(0, pos); //获取带"/"的项目名，如：/cis
    var projectName = pathName.substring(0, pathName.substr(1).indexOf('/') + 1);
    //var rootPath = locahostPaht + projectName;
    var url = "";
    switch (Tab) {
    case 0:
      url = curWwwPath;
      break;
    case 1:
      url = localhostPaht + pathName;
      break;
    case 2:
      url = localhostPaht;
      break;
    }
    return url
  },
  OSV: function () {

    //正则,忽略大小写
    var pattern_phone = new RegExp("iphone", "i");
    var pattern_android = new RegExp("android", "i");
    var userAgent = navigator.userAgent.toLowerCase();
    var isAndroid = pattern_android.test(userAgent);
    var isIphone = pattern_phone.test(userAgent);
    var phoneType = "phoneType";
    if (isAndroid) {
      var zh_cnIndex = userAgent.indexOf("-");
      var spaceIndex = userAgent.indexOf("build", zh_cnIndex + 4);
      var fullResult = userAgent.substring(zh_cnIndex, spaceIndex);
      phoneType = fullResult.split(";")[1];
    } else if (isIphone) {
      //6   w=375    6plus w=414   5s w=320     5 w=320
      var wigth = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
      if (wigth > 400) {
        phoneType = "iPhone6 plus";
      } else if (wigth > 370) {
        phoneType = "iPhone6";
      } else if (wigth > 315) {
        phoneType = "iPhone5 or iPhone5s";
      } else {
        phoneType = "iPhone 4s";
      }
    } else {
      phoneType = "不能识别手机系统";
    }

    return phoneType || "";
  }
}


var BugMsg = {
  IsBug: true,
  Verify: function () {
    var $msg = $("#msg");
    if ($msg.length == 0) {
      $msg = $("<div id='msg' style='pointer-events:none; position:absolute; height: 90%; overflow: auto; top:10px;left:10px;color:red;font-size:14px;z-index: 99999;'></div>")
      $("html").append($msg);
    }
    return $msg;
  },
  Html: function (Str) {
    if (BugMsg.IsBug) {
      var $msg = BugMsg.Verify();
      $msg.html(Str);
    }
  },
  Add: function (Str) {
    if (BugMsg.IsBug) {
      var $msg = BugMsg.Verify();
      $msg.prepend(Str + "<br/>");
    }
  }
}

/*获取URL参数集合*/
function getUrlParams() {
  var params = {};
  var url = window.location.href;
  var idx = url.indexOf("?");
  if (idx > 0) {
    var queryStr = url.substring(idx + 1);
    var args = queryStr.split("&");
    for (var i = 0; i < args.length; i++) {
      var a = args[i];
      if (a != "") {
        var nv = a.split("=");
        if (nv.length > 1) {
          params[nv[0]] = nv[1];
        }
      }
    }
  }
  return params;
}




/*动态加载css或js*/
var DynamicLoading = {
  CSS: function (paths, fun) {
    var cssNum = paths.length;

    //BugMsg.Add("CSS总数量:" + cssNum)
    if (cssNum > 0) {
      for (var i in paths) {
        var path = paths[i];
        if (!path || path.length === 0) {
          cssNum--
          //BugMsg.Add("CSS剩余数量:" + cssNum + "," + path)
          if (cssNum == 0) {
            if (fun) {
              fun();
            }
          }
        }
        var isExist = false;
        var olinks = document.getElementsByTagName('link');
        if (olinks.length > 0) {
          for (var i in olinks) {
            if (typeof (olinks[i]) == "object" && olinks[i].href.indexOf(path) != -1) {
              isExist = true;
            }
          }
        }

        if (isExist) {
          cssNum--
          //BugMsg.Add("CSS剩余数量:" + cssNum + "," + path)
          if (cssNum == 0) {
            if (fun) {
              fun();
            }
          }
        } else {
          var head = document.getElementsByTagName('head')[0];
          var link = document.createElement('link');
          link.href = path + "?_=" + Math.random();;
          link.rel = 'stylesheet';
          link.type = 'text/css';


          var linkReady = function () {
            this.onload = this.onerror = null;
            cssNum--
            //BugMsg.Add("CSS剩余数量:" + cssNum + "," + this.href)
            if (cssNum == 0) {
              if (fun) {
                fun();
              }
            }
          };

          link.onload = link.onerror = linkReady;
          head.appendChild(link);


        }
      }

    }
  },
  Js: function (paths, fun) {
    var jsNum = paths.length;
    //BugMsg.Add("Js总数量:" + jsNum)
    if (jsNum > 0) {
      for (var i in paths) {
        var path = paths[i];
        if (!path || path.length === 0) {
          jsNum--
          //BugMsg.Add("Js剩余数量:" + jsNum + "," + path)
          if (jsNum == 0) {
            if (fun) {
              fun();
            }
          }
          //throw new Error('argument "path" is required !');
        }
        var isExist = false;
        var oscripts = document.getElementsByTagName('script');
        if (oscripts.length > 0) {
          for (var i in oscripts) {
            if (typeof (oscripts[i]) == "object" && oscripts[i].src.indexOf(path) != -1) {
              isExist = true;
            }
          }
        }
        if (isExist) {
          jsNum--
          //BugMsg.Add("Js剩余数量:" + jsNum + "," + path)
          if (jsNum == 0) {
            if (fun) {
              fun();
            }
          }
        } else {
          var head = document.getElementsByTagName('head')[0];
          var script = document.createElement('script');
          script.src = path + "?_=" + Math.random();
          script.type = 'text/javascript';
          var scriptReady = function () {
            this.onload = this.onerror = null;
            jsNum--
            //BugMsg.Add("Js剩余数量:" + jsNum + "," + this.src)
            if (jsNum == 0) {
              if (fun) {
                fun();
              }
            }
          };
          script.onload = script.onerror = scriptReady;
          head.appendChild(script);
        }
      }
    }
  }
}


//var ToClick = "click";

DynamicLoading.CSS([
  'Css/page-msg.css',
  'Css/lCalendar.css',
  'Css/BPopUp.css',
  'Css/mobileSelect.css'
  // 'Css/font-awesome/css/font-awesome.min.css'
], function () {

  // $("body").show();
});

var dynamicJs = [
  'Js/lib/util/jquery.tap.min.js',
  'Js/lib/util/jquery.md5.js',
  'Js/lib/util/lCalendar.js',
  'Js/lib/util/BPopUp.js',
  'Js/lib/util/mobileSelect.js',
  'Js/lib/util/MPopUp.js',
  'Js/lib/util/ImgPreview.js',
  'Js/lib/util/PhotoBox.js',
  'Js/lib/tool/Extend.js',
  'Js/lib/tool/ExtendTime.js',
  'Js/lib/tool/AutoInit.js',
  'Js/lib/tool/Storage.js',
  'Js/lib/tool/PageMsg.js',
  'Js/dal/Type_List.js',
  'Js/dal/Inte.js',
  'Js/bll/App.js'
];
if (Browser.Versions.IsMiniProgram) {
  dynamicJs.push('Js/lib/util/jweixin-1.3.2.js');
  dynamicJs.push('Js/lib/tool/WeiXin.js');
}
DynamicLoading.Js(dynamicJs, function () {

  // BanCrossScreen();
  //
  // AppPageInit();
  // setTimeout(function init() {
  //     BanCrossScreen();
  //     AppPageInit();
  // }, 500);
  AddrInit();
  AndroidCss("Css/android/main-android.css");

  if (Browser.Versions.IsIOS || Browser.Versions.IsIphoneOs || Browser.Versions.IsIpad) {
    $('body').css('font-family', 'sf-font')
  } else if (Browser.Versions.IsAndroid && Browser.Versions.IsMiniProgram) {
    $('body').css('font-family', 'Microsoft YaHei')
  }

  $(document).ready(function () {
    BanCrossScreen();
    AppPageInit();
    //测试数据 正式环境中注释
    testRequestParam();
    $("body").show();
    // setTimeout(function init() {
    //     BanCrossScreen();
    //     AppPageInit();
    // }, 200);
  });

});

function AndroidCss(pages) {
  if (PlatformID == 1) {
    if (Array.isArray(pages)) {
      for (var i in pages) {
        AppendCss(pages[i])
      }
    } else {
      AppendCss(pages)
    }
  }
}

function AppendCss(path) {
  var head = document.getElementsByTagName('head')[0];
  var link = document.createElement('link');
  link.href = path + "?_=" + Math.random();
  link.rel = 'stylesheet';
  link.type = 'text/css';

  head.appendChild(link);
}

//初始化点击类型
function ClickInit() {
  window.ToClick = "click";
  if (Browser.Versions.IsMobile == 1) {
    ToClick = "tap";
  }
}

//设置基础字体宽高
function BasisSize(fun) {

  window.OneBasisSize = 100 / 375;
  window.GlobalBasisSize = window.innerWidth * OneBasisSize;
  document.documentElement.style.fontSize = GlobalBasisSize + 'px';

  if (fun) {
    fun();
  }


  if (!$(window).data("isResize")) {
    $(window).resize(function () {
      BasisSize(fun);
    });
    $(window).data("isResize", true)
  }

}

function AddrInit() {

  // // setAppStorage("UIDENTIFY_ID", '5a80f7825a1446cda7cb648256a00982');
  //  setAppStorage("UIDENTIFY_ID", 'a09aac5f4f04482fb9fa6acf3c63bc13');
  //  // setAppStorage("UIDENTIFY_ID", '2806cd252cd246e29410b5fff86fad7c');
  //  // setAppStorage("UIDENTIFY_ID", 'e102ebe7589f446890298985e942e14f');
  //  setAppStorage("OIDENTIFY_ID", '9c43fa9293fa47fab7e8da59765ec9cc'); //机构识别码ID
  //  setAppStorage("DEPARTMENT_SPEC_ID", '1'); //部门ID
  //  setAppStorage("DEPARTMENT_GROUP_ID", '37'); //部门组IDhttp://192.168.11.225:8012/MonthlyA_Index.html
  //  setAppStorage("SESSION_ID", "");
  //  setAppStorage("RoleSpecKey", "CAPTAIN"); //角色规格KEY  CAPTAIN队长、MEMBER队员、MANAGER经理、CAPTAIN_Z中队长、CAPTAIN_D大队长、ADMIN_A甲方管理员、GMANAGER总经理、MONITOR班长

  window.BasicAddr = Browser.Url(2) + "/";

  // window.ServerAddr = "https://secol.sxiyi.cn/SecOLServer/AppManage/";
  // window.ServerAddr = "http://192.168.11.115:8656/SecurityOnlineServer/AppManage/";
  // window.ServerAddr = "https://www.anbaool.com/SecOLServerV3/AppManage/";
  // window.ShowAddr = "https://www.anbaool.com/";
  // window.ShowAddr = "https://secol.sxiyi.cn/";
  // 测试用服务接口
  window.ServerAddr = "https://www.anbaool.com/SecOLServerV3/AppManage/";
  window.AppName = "SecurityOnline";
  window.PlatformID = getBrowserVersions(); //平台ID（0 IOS， 1 安卓， 2 PC）
  window.RoleSpec = objRoleSpecKey[getAppStorage("RoleSpecKey")]; //
  window.Debug = true; //
  initBaseRequestParams();
}

function BanCrossScreen() {
  window.OverScroll = function (el) {
    //// console.log(el)
    if (el) {
      el.addEventListener('touchstart', function (evt) {
        BugMsg.IsBug = true;
        var top = el.scrollTop,
          totalScroll = el.scrollHeight,
          currentScroll = top + el.offsetHeight
        //If we're at the top or the bottom of the containers
        //scroll, push up or down one pixel.
        //
        //this prevents the scroll from "passing through" to
        //the body.
        var touch = evt.touches[0]; //获取第一个触点
        el.startX = parseInt(touch.pageX); //页面触点X坐标
        el.startY = parseInt(touch.pageY); //页面触点Y坐标


        if (top === 0) {
          // el.scrollTop = 1
        } else if (currentScroll === totalScroll) {
          el.scrollTop = top - 1
        }
      })
      el.addEventListener('touchmove', function (evt) {
        //if the content is actually scrollable, i.e. the content is long enough
        //that scrolling can occur
        //BugMsg.Add(el.scrollTop);
        //BugMsg.Add(el.scrollHeight);
        //BugMsg.Add(el.offsetHeight);

        //if(el.offsetHeight < el.scrollHeight)
        //    evt._isScroller = true

        var touch = evt.touches[0]; //获取第一个触点
        endX = parseInt(touch.pageX); //页面触点X坐标
        endY = parseInt(touch.pageY); //页面触点Y坐标
        ////BugMsg.Add(el.innerHTML);
        //BugMsg.Add(el.scrollTop);
        //BugMsg.Add(endY);
        //BugMsg.Add("-----");
        //如果startY<endY 表示上滑动
        if (el.startY > endY)
        {
          evt._isScroller = true;
          evt.stopPropagation();
        } else {
          if (el.scrollTop == 0 || el.scrollTop == 1) {
            evt._isScroller = false
          } else {
            evt._isScroller = true;
          }
        }

        //BugMsg.Add(el.scrollTop);
        //BugMsg.Add(evt._isScroller ? "t":"f");
        if (evt._isScroller) {
          evt.stopPropagation();
        }
        //// console.log(el)
        //BugMsg.Add("AAAAA");
      })
    }

  }
  document.body.addEventListener('touchmove', function (evt) {
    //In this case, the default behavior is scrolling the body, which
    //would result in an overflow.  Since we don't want that, we preventDefault.
    if (!evt._isScroller) {

      // evt.preventDefault() //这个开启会导致有时无法滑动界面
    }
  })

  OverScroll(document.querySelector('.ui-content'));
}

function BanCrossScreen_old(el) {
  var scrollTop = 0,
    scrollHeight = 0,
    offsetHeight = 0;
  var isScroller = false; //false 表示不禁用
  var startX = 0,
    startY = 0;
  var endX = 0,
    endY = 0;
  //document.body.addEventListener('touchmove', function(evt) {
  //    //In this case, the default behavior is scrolling the body, which
  //    //would result in an overflow.  Since we don't want that, we preventDefault.
  //
  //});
  el.addEventListener('touchstart', function (evt) {

    //// console.log(evt);
    //BugMsg.Add(el.scrollTop + "," + el.offsetHeight + "," + el.scrollHeight);
    var touch = evt.touches[0]; //获取第一个触点
    startX = parseInt(touch.pageX); //页面触点X坐标
    startY = parseInt(touch.pageY); //页面触点Y坐标

    //if (el.scrollTop == 0) {
    //    isScroller = true;
    //    //el.scrollTop = 1;
    //}
    //if(isScroller) {
    //    evt.preventDefault();
    //}
  }, false);
  el.addEventListener('touchmove', function (evt) {

    //BugMsg.Add("2222");
    var touch = evt.touches[0]; //获取第一个触点
    endX = parseInt(touch.pageX); //页面触点X坐标
    endY = parseInt(touch.pageY); //页面触点Y坐标

    //如果startY>endY 表示上滑动
    if (startY > endY)
    {
      isScroller = false;
      //if(el.scrollTop+el.offsetHeight>=el.scrollHeight){
      //    isScroller=true;
      //}else{
      //    isScroller=false;
      //}
    } else {
      if (el.scrollTop == 0) {
        isScroller = true;
        //el.scrollTop = 1;
      } else {
        isScroller = false;
      }
    }
    //BugMsg.Add(isScroller?"t":"f");
    if (isScroller) {
      BugMsg.Add(isScroller ? "t" : "f");
      //evt.preventDefault();
      evt.stopPropagation();
    }
    //BugMsg.Html(startX +","+ startY+","+ endX +","+endY);
  }, false);

  el.addEventListener('scroll', function (evt) {
    //BugMsg.Html(el.scrollTop+","+ el.offsetHeight +","+ el.scrollHeight)
    if (el.scrollTop <= 0) {
      isScroller = true;
    } else
    if (el.scrollTop + el.offsetHeight >= el.scrollHeight) {
      isScroller = true;
    } else {
      isScroller = false;
    }
  });

}

function testRequestParam() {
  if (!getAppStorage("UIDENTIFY_ID")) setAppStorage("UIDENTIFY_ID", '7c67c628e9534c4d94ac535645e3f8cb');
  // if(!getAppStorage("UIDENTIFY_ID"))   setAppStorage("UIDENTIFY_ID",'5a80f7825a1446cda7cb648256a00982');
  // if(!getAppStorage("UIDENTIFY_ID"))   setAppStorage("UIDENTIFY_ID",'2806cd252cd246e29410b5fff86fad7c');
  // if(!getAppStorage("UIDENTIFY_ID"))   setAppStorage("UIDENTIFY_ID",'029e6c1a6e754579b0ea795016410810');
  if (!getAppStorage("OIDENTIFY_ID")) setAppStorage("OIDENTIFY_ID", 'fb7ff023055042afa7465a0c20068819');
  if (!getAppStorage("DEPARTMENT_SPEC_ID")) setAppStorage("DEPARTMENT_SPEC_ID", 1);
  if (!getAppStorage("DEPARTMENT_GROUP_ID")) setAppStorage("DEPARTMENT_GROUP_ID", 0);
}

BasisSize();
ClickInit();

// 小程序初始化基础参数
function initBaseRequestParams() {
  // wx && wx.miniProgram.getEnv((res) => { window.isMiniprogram = res.miniprogram })
  // if (!window.isMiniprogram) return;
  // TOFIX
  // window.PlatformID = 4;
  if (window.PlatformID != 4) return;
  window.AppName = "MyDaily";
  var baseParams = request('base');
  if (baseParams) {
    var params = JSON.parse(Base64.decode(baseParams));
    setAppStorage("UIDENTIFY_ID", params.uid);
    setAppStorage("OIDENTIFY_ID", params.oid);
    setAppStorage("DEPARTMENT_SPEC_ID", params.specid);
    setAppStorage("DEPARTMENT_GROUP_ID", params.groupid);
    setAppStorage("ROLE_ID", params.roleid);
    setAppStorage("PROJECT_ID", params.projid);
    setAppStorage("PROJECT_TYPE", params.projtype);
    setAppStorage("PROJECT_NAME", params.projname);
    setAppStorage("SESSION_ID", params.sessionid);
    setAppStorage("FILE_SERVER_URL", params.fileserver);
    setAppStorage("GPS_LAT", params.lat);
    setAppStorage("GPS_LON", params.lon);
  }

  // 微信SDK初始化
  if (window.WeiXinAttorney) {
    WeiXinAttorney.mpInit(function () {
      console.log('mpInit');
    })
  }

  // 小程序部分页面头部不显示
  mpHeadFix();
}


var mpHeadFixArr = [{
  url: 'Mine_Index.html',
}, {
  url: 'Clock_QrCode_Result.html',
}, {
  url: 'Clock_Record.html',
}, {
  url: 'Search_Index.html',
}, {
  url: 'Mine_ChooseTeam.html',
}]

function mpHeadFix() {
  var $head = $('.header-nav');
  var $title = $('.header-title');
  var $back = $('#btnBack');
  $title.text('');
  $back.addClass('ui-hide');
  if (!$head.length) return;
  for (var key in mpHeadFixArr) {
    var item = mpHeadFixArr[key];
    var url = item.url.toLowerCase();
    var href = window.location.href.toLowerCase();
    if (href.indexOf(url) > -1) {
      $head.addClass('ui-hide');
      $('.mp-fix').addClass('mp-fix-active');
      break;
    }
  }
}
